/* tslint:disable */
/* eslint-disable */
/**
 * ChronoSheets API
 * <div style=\'font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;\'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target=\'_BLANK\' href=\'http://tsheets.xyz/signup\'>http://tsheets.xyz/signup</a>. </p></div><div id=\'cs-extra-info\'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface AggregateClient
 */
export interface AggregateClient {
    /**
     * The ID of the client
     * @type {number}
     * @memberof AggregateClient
     */
    Id?: number;
    /**
     * The ID of your organisation
     * @type {number}
     * @memberof AggregateClient
     */
    OrganisationId?: number;
    /**
     * The name of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientName?: string | null;
    /**
     * The address line 1 of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientAddressLine1?: string | null;
    /**
     * The address line 2 of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientAddressLine2?: string | null;
    /**
     * The address suburb of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientSuburb?: string | null;
    /**
     * The address state of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientState?: string | null;
    /**
     * The postcode of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientPostCode?: string | null;
    /**
     * The contact person working under the client
     * @type {string}
     * @memberof AggregateClient
     */
    PersonOfContact?: string | null;
    /**
     * The phone number of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientPhoneNumber?: string | null;
    /**
     * The mobile phone number of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientMobileNumber?: string | null;
    /**
     * The email address of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientEmailAddress?: string | null;
    /**
     * The website URL of the client
     * @type {string}
     * @memberof AggregateClient
     */
    ClientWebURL?: string | null;
    /**
     * The number of projects under the client
     * @type {number}
     * @memberof AggregateClient
     */
    ProjectCount?: number;
    /**
     * A list of projects that are under this client
     * @type {Array<AggregateProject>}
     * @memberof AggregateClient
     */
    ClientProjects?: Array<AggregateProject> | null;
}
/**
 * A standard API response
 * @export
 * @interface AggregateClientListApiResponse
 */
export interface AggregateClientListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<AggregateClient>}
     * @memberof AggregateClientListApiResponse
     */
    Data?: Array<AggregateClient> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof AggregateClientListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof AggregateClientListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface AggregateJobCode
 */
export interface AggregateJobCode {
    /**
     * The ID of the job code (not the code itself)
     * @type {number}
     * @memberof AggregateJobCode
     */
    Id?: number;
    /**
     * The job code itself
     * @type {string}
     * @memberof AggregateJobCode
     */
    Code?: string | null;
    /**
     * The name of the client
     * @type {string}
     * @memberof AggregateJobCode
     */
    Client?: string | null;
    /**
     * The ID of the client
     * @type {number}
     * @memberof AggregateJobCode
     */
    ClientId?: number;
    /**
     * The name of the project
     * @type {string}
     * @memberof AggregateJobCode
     */
    Project?: string | null;
    /**
     * The ID of the project
     * @type {number}
     * @memberof AggregateJobCode
     */
    ProjectId?: number;
    /**
     * Your organisation ID
     * @type {number}
     * @memberof AggregateJobCode
     */
    OrganisationId?: number;
    /**
     * A flag indicating whether or not the job code has been marked as deleted
     * @type {boolean}
     * @memberof AggregateJobCode
     */
    IsDeleted?: boolean;
    /**
     * The list of available tasks under this job code
     * @type {Array<AggregateJobTask>}
     * @memberof AggregateJobCode
     */
    AvailableTasks?: Array<AggregateJobTask> | null;
    /**
     * The list of employee IDs that are permitted to record timesheets with this job code (empty means everyone)
     * @type {Array<number>}
     * @memberof AggregateJobCode
     */
    PermittedEmployees?: Array<number> | null;
}
/**
 * A standard API response
 * @export
 * @interface AggregateJobCodeListApiResponse
 */
export interface AggregateJobCodeListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<AggregateJobCode>}
     * @memberof AggregateJobCodeListApiResponse
     */
    Data?: Array<AggregateJobCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof AggregateJobCodeListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof AggregateJobCodeListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface AggregateJobTask
 */
export interface AggregateJobTask {
    /**
     * The Id of the task
     * @type {number}
     * @memberof AggregateJobTask
     */
    Id?: number;
    /**
     * The label of the task
     * @type {string}
     * @memberof AggregateJobTask
     */
    Label?: string | null;
    /**
     * A flag indicating that this task has been marked as deleted
     * @type {boolean}
     * @memberof AggregateJobTask
     */
    IsDeleted?: boolean;
}
/**
 * 
 * @export
 * @interface AggregateProject
 */
export interface AggregateProject {
    /**
     * The ID of the project
     * @type {number}
     * @memberof AggregateProject
     */
    Id?: number;
    /**
     * The ID of the client that this project is assigned to
     * @type {number}
     * @memberof AggregateProject
     */
    ClientId?: number;
    /**
     * The ID of your organisation
     * @type {number}
     * @memberof AggregateProject
     */
    OrganisationId?: number;
    /**
     * The name of the project (can be viewed in PROJECT TIMELINES)
     * @type {string}
     * @memberof AggregateProject
     */
    ProjectName?: string | null;
    /**
     * The estimated cost of the project (can be viewed in PROJECT TIMELINES)
     * @type {number}
     * @memberof AggregateProject
     */
    CostEstimation?: number;
    /**
     * The start date of the project (can be viewed in PROJECT TIMELINES)
     * @type {string}
     * @memberof AggregateProject
     */
    StartDate?: string | null;
    /**
     * The end date of the project (can be viewed in PROJECT TIMELINES)
     * @type {string}
     * @memberof AggregateProject
     */
    EndDate?: string | null;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum ApiResponseCode {
    Succeeded = 'Succeeded',
    FatalException = 'FatalException',
    GeneralError = 'GeneralError',
    ValidationError = 'ValidationError',
    UnAuthorized = 'UnAuthorized',
    SessionExpired = 'SessionExpired'
}

/**
 * 
 * @export
 * @enum {string}
 */
export enum AudioMediaTypes {
    Other = 'Other',
    Mp3 = 'Mp3',
    Mp4 = 'Mp4',
    Wav = 'Wav',
    Flac = 'Flac'
}

/**
 * 
 * @export
 * @enum {string}
 */
export enum AutomationAuditDataSortColumns {
    UserName = 'UserName',
    AutomationActionType = 'AutomationActionType',
    ClientDateTime = 'ClientDateTime',
    IsProcessed = 'IsProcessed'
}

/**
 * 
 * @export
 * @interface BasicCoordinate
 */
export interface BasicCoordinate {
    /**
     * 
     * @type {number}
     * @memberof BasicCoordinate
     */
    Latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof BasicCoordinate
     */
    Longitude?: number;
}
/**
 * A basic geofence
 * @export
 * @interface BasicGeofence
 */
export interface BasicGeofence {
    /**
     * The ID of the geofence
     * @type {number}
     * @memberof BasicGeofence
     */
    GeoFencingId?: number;
    /**
     * The descriptive name of the geofence
     * @type {string}
     * @memberof BasicGeofence
     */
    Name?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface BasicGeofenceListApiResponseForPaginated
 */
export interface BasicGeofenceListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<BasicGeofence>}
     * @memberof BasicGeofenceListApiResponseForPaginated
     */
    Data?: Array<BasicGeofence> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof BasicGeofenceListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof BasicGeofenceListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof BasicGeofenceListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * A basic NFC Code
 * @export
 * @interface BasicNFCCode
 */
export interface BasicNFCCode {
    /**
     * The ID of the NFC code
     * @type {number}
     * @memberof BasicNFCCode
     */
    NFCCodeId?: number;
    /**
     * The descriptive name of the NFC code
     * @type {string}
     * @memberof BasicNFCCode
     */
    Name?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface BasicNFCCodeListApiResponseForPaginated
 */
export interface BasicNFCCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<BasicNFCCode>}
     * @memberof BasicNFCCodeListApiResponseForPaginated
     */
    Data?: Array<BasicNFCCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof BasicNFCCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof BasicNFCCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof BasicNFCCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * A basic QR Code
 * @export
 * @interface BasicQRCode
 */
export interface BasicQRCode {
    /**
     * The ID of the QR code
     * @type {number}
     * @memberof BasicQRCode
     */
    QRCodeId?: number;
    /**
     * The descriptive name of the QR code
     * @type {string}
     * @memberof BasicQRCode
     */
    Name?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface BasicQRCodeListApiResponseForPaginated
 */
export interface BasicQRCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<BasicQRCode>}
     * @memberof BasicQRCodeListApiResponseForPaginated
     */
    Data?: Array<BasicQRCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof BasicQRCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof BasicQRCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof BasicQRCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * Contains a collection of Timesheet objects that are to be either created or updated.  If the ID of the timesheet is specified in the Timesheet object, then that Timesheet will be updated otherwise it will be created
 * @export
 * @interface BatchUpdateTimesheetRequest
 */
export interface BatchUpdateTimesheetRequest {
    /**
     * A collection of Timesheet objects to be either created or updated
     * @type {Array<Timesheet>}
     * @memberof BatchUpdateTimesheetRequest
     */
    Timesheets?: Array<Timesheet> | null;
}
/**
 * A standard API response
 * @export
 * @interface BooleanApiResponse
 */
export interface BooleanApiResponse {
    /**
     * The main Data of the response
     * @type {boolean}
     * @memberof BooleanApiResponse
     */
    Data?: boolean;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof BooleanApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof BooleanApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface Client
 */
export interface Client {
    /**
     * The ID of the client
     * @type {number}
     * @memberof Client
     */
    Id?: number;
    /**
     * The ID of your organisation
     * @type {number}
     * @memberof Client
     */
    OrganisationId?: number;
    /**
     * The name of the client
     * @type {string}
     * @memberof Client
     */
    ClientName?: string | null;
    /**
     * The address line 1 of the client
     * @type {string}
     * @memberof Client
     */
    ClientAddressLine1?: string | null;
    /**
     * The address line 2 of the client
     * @type {string}
     * @memberof Client
     */
    ClientAddressLine2?: string | null;
    /**
     * The address suburb of the client
     * @type {string}
     * @memberof Client
     */
    ClientSuburb?: string | null;
    /**
     * The address state of the client
     * @type {string}
     * @memberof Client
     */
    ClientState?: string | null;
    /**
     * The postcode of the client
     * @type {string}
     * @memberof Client
     */
    ClientPostCode?: string | null;
    /**
     * The contact person working under the client
     * @type {string}
     * @memberof Client
     */
    PersonOfContact?: string | null;
    /**
     * The phone number of the client
     * @type {string}
     * @memberof Client
     */
    ClientPhoneNumber?: string | null;
    /**
     * The mobile phone number of the client
     * @type {string}
     * @memberof Client
     */
    ClientMobileNumber?: string | null;
    /**
     * The email address of the client
     * @type {string}
     * @memberof Client
     */
    ClientEmailAddress?: string | null;
    /**
     * The website URL of the client
     * @type {string}
     * @memberof Client
     */
    ClientWebURL?: string | null;
    /**
     * The number of projects under the client
     * @type {number}
     * @memberof Client
     */
    ProjectCount?: number;
}
/**
 * A standard API response
 * @export
 * @interface ClientApiResponse
 */
export interface ClientApiResponse {
    /**
     * 
     * @type {Client}
     * @memberof ClientApiResponse
     */
    Data?: Client;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ClientApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ClientApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface ClientListApiResponse
 */
export interface ClientListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<Client>}
     * @memberof ClientListApiResponse
     */
    Data?: Array<Client> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ClientListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ClientListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface ClientSeriesReportItem
 */
export interface ClientSeriesReportItem {
    /**
     * 
     * @type {string}
     * @memberof ClientSeriesReportItem
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof ClientSeriesReportItem
     */
    EndDate?: string;
    /**
     * 
     * @type {number}
     * @memberof ClientSeriesReportItem
     */
    ClientId?: number;
    /**
     * 
     * @type {string}
     * @memberof ClientSeriesReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ClientSeriesReportItem
     */
    SpanSeconds?: number;
}
/**
 * A user within ChronoSheets
 * @export
 * @interface ClientSideUser
 */
export interface ClientSideUser {
    /**
     * The ID of the user
     * @type {number}
     * @memberof ClientSideUser
     */
    Id?: number;
    /**
     * The ID of the organisation
     * @type {number}
     * @memberof ClientSideUser
     */
    OrganisationId?: number;
    /**
     * The username of the user
     * @type {string}
     * @memberof ClientSideUser
     */
    UserName?: string | null;
    /**
     * The first name of the user
     * @type {string}
     * @memberof ClientSideUser
     */
    FirstName?: string | null;
    /**
     * The last name of the user
     * @type {string}
     * @memberof ClientSideUser
     */
    LastName?: string | null;
    /**
     * The email address of the user
     * @type {string}
     * @memberof ClientSideUser
     */
    EmailAddress?: string | null;
    /**
     * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
     * @type {number}
     * @memberof ClientSideUser
     */
    Roles?: number;
    /**
     * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
     * @type {number}
     * @memberof ClientSideUser
     */
    AlertSettings?: number;
    /**
     * Whether or not the setup wizard is required
     * @type {boolean}
     * @memberof ClientSideUser
     */
    SetupWizardRequired?: boolean;
    /**
     * Whether or not the user is subscribed to the user
     * @type {boolean}
     * @memberof ClientSideUser
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * 
     * @type {Organisation}
     * @memberof ClientSideUser
     */
    Organisation?: Organisation;
    /**
     * Whether or not this account is the organisation\'s primary account.
     * @type {boolean}
     * @memberof ClientSideUser
     */
    IsPrimaryAccount?: boolean;
}
/**
 * 
 * @export
 * @interface ClientTotalsReportItem
 */
export interface ClientTotalsReportItem {
    /**
     * 
     * @type {number}
     * @memberof ClientTotalsReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof ClientTotalsReportItem
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof ClientTotalsReportItem
     */
    ClientId?: number;
    /**
     * 
     * @type {string}
     * @memberof ClientTotalsReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ClientTotalsReportItem
     */
    SpanSeconds?: number;
}
/**
 * 
 * @export
 * @interface CombinedReportsData
 */
export interface CombinedReportsData {
    /**
     * 
     * @type {Array<JobSeriesReportItem>}
     * @memberof CombinedReportsData
     */
    SeriesJobCodes?: Array<JobSeriesReportItem> | null;
    /**
     * 
     * @type {Array<TaskSeriesReportItem>}
     * @memberof CombinedReportsData
     */
    SeriesTasks?: Array<TaskSeriesReportItem> | null;
    /**
     * 
     * @type {Array<ClientSeriesReportItem>}
     * @memberof CombinedReportsData
     */
    SeriesClients?: Array<ClientSeriesReportItem> | null;
    /**
     * 
     * @type {Array<ProjectSeriesReportItem>}
     * @memberof CombinedReportsData
     */
    SeriesProjects?: Array<ProjectSeriesReportItem> | null;
    /**
     * 
     * @type {Array<JobTotalsReportItem>}
     * @memberof CombinedReportsData
     */
    TotalsJobCodes?: Array<JobTotalsReportItem> | null;
    /**
     * 
     * @type {Array<TaskTotalsReportItem>}
     * @memberof CombinedReportsData
     */
    TotalsTasks?: Array<TaskTotalsReportItem> | null;
    /**
     * 
     * @type {Array<ClientTotalsReportItem>}
     * @memberof CombinedReportsData
     */
    TotalsClients?: Array<ClientTotalsReportItem> | null;
    /**
     * 
     * @type {Array<ProjectTotalsReportItem>}
     * @memberof CombinedReportsData
     */
    TotalsProjects?: Array<ProjectTotalsReportItem> | null;
}
/**
 * A standard API response
 * @export
 * @interface CombinedReportsDataApiResponse
 */
export interface CombinedReportsDataApiResponse {
    /**
     * 
     * @type {CombinedReportsData}
     * @memberof CombinedReportsDataApiResponse
     */
    Data?: CombinedReportsData;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof CombinedReportsDataApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof CombinedReportsDataApiResponse
     */
    Message?: string | null;
}
/**
 * A request for triggering timesheet automation
 * @export
 * @interface CreateAutomationStepRequest
 */
export interface CreateAutomationStepRequest {
    /**
     * The ID of the geofence being tracked. You must send only one of \'GeofencingId\', \'NfcId\' or \'QRCodeId\'.
     * @type {number}
     * @memberof CreateAutomationStepRequest
     */
    GeofencingId?: number | null;
    /**
     * The ID of the NFC tag being tracked. You must send only one of \'GeofencingId\', \'NfcId\' or \'QRCodeId\'.
     * @type {number}
     * @memberof CreateAutomationStepRequest
     */
    NfcId?: number | null;
    /**
     * The ID of the QR code being tracked. You must send only one of \'GeofencingId\', \'NfcId\' or \'QRCodeId\'.
     * @type {number}
     * @memberof CreateAutomationStepRequest
     */
    QRCodeId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationAction}
     * @memberof CreateAutomationStepRequest
     */
    AutomationActionType?: TimesheetAutomationAction;
    /**
     * The latitude that this action is recorded at
     * @type {number}
     * @memberof CreateAutomationStepRequest
     */
    Latitude?: number | null;
    /**
     * The longitude that this action is recorded at
     * @type {number}
     * @memberof CreateAutomationStepRequest
     */
    Longitude?: number | null;
    /**
     * A timesheet of the user\'s current time when this action is requested
     * @type {string}
     * @memberof CreateAutomationStepRequest
     */
    ClientTime?: string;
}
/**
 * A request object for creating a new geofence
 * @export
 * @interface CreateGeoFenceRequest
 */
export interface CreateGeoFenceRequest {
    /**
     * The name of the geo fence
     * @type {string}
     * @memberof CreateGeoFenceRequest
     */
    Name?: string | null;
    /**
     * A list of coordinates specifying the geofence region
     * @type {Array<BasicCoordinate>}
     * @memberof CreateGeoFenceRequest
     */
    FenceCoordinates?: Array<BasicCoordinate> | null;
    /**
     * The job code to be used when the person enters/leaves the geofence
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person enters/leaves the geofence
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationGeofenceAlertSettings}
     * @memberof CreateGeoFenceRequest
     */
    AlertSettings?: TimesheetAutomationGeofenceAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationGeofenceTriggerSettings}
     * @memberof CreateGeoFenceRequest
     */
    TriggerSettings?: TimesheetAutomationGeofenceTriggerSettings;
    /**
     * The start hour in which this geofence should apply.  After this time, the geofence will be active.
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this geofence should apply.  After this time, the geofence will be active.
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this geofence will stop applying.  After this time, the geofence will be inactive.
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this geofence will stop applying.  After this time, the geofence will be inactive.
     * @type {number}
     * @memberof CreateGeoFenceRequest
     */
    EndTimeMinute?: number;
}
/**
 * A request object for creating a new NFC code
 * @export
 * @interface CreateNFCCodeRequest
 */
export interface CreateNFCCodeRequest {
    /**
     * The name of the NFC code
     * @type {string}
     * @memberof CreateNFCCodeRequest
     */
    Name?: string | null;
    /**
     * The data stored on the NFC tag used to identify it
     * @type {string}
     * @memberof CreateNFCCodeRequest
     */
    NFCTagData?: string | null;
    /**
     * The job code to be used when the person activates/deactivates the NFC code
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person activates/deactivates the NFC code
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeAlertSettings}
     * @memberof CreateNFCCodeRequest
     */
    AlertSettings?: TimesheetAutomationNFCCodeAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeTriggerSettings}
     * @memberof CreateNFCCodeRequest
     */
    TriggerSettings?: TimesheetAutomationNFCCodeTriggerSettings;
    /**
     * The start hour in which this NFC code should apply.  After this time, the NFC code will be active.
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this NFC code should apply.  After this time, the NFC code will be active.
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
     * @type {number}
     * @memberof CreateNFCCodeRequest
     */
    EndTimeMinute?: number;
}
/**
 * A request object for creating a new QR code
 * @export
 * @interface CreateQRCodeRequest
 */
export interface CreateQRCodeRequest {
    /**
     * The name of the QR code
     * @type {string}
     * @memberof CreateQRCodeRequest
     */
    Name?: string | null;
    /**
     * The job code to be used when the person activates/deactivates the QR code
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person activates/deactivates the QR code
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationQRCodeAlertSettings}
     * @memberof CreateQRCodeRequest
     */
    AlertSettings?: TimesheetAutomationQRCodeAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationQRCodeTriggerSettings}
     * @memberof CreateQRCodeRequest
     */
    TriggerSettings?: TimesheetAutomationQRCodeTriggerSettings;
    /**
     * The start hour in which this QR code should apply.  After this time, the QR code will be active.
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this QR code should apply.  After this time, the QR code will be active.
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this QR code will stop applying.  After this time, the QR code will be inactive.
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this QR code will stop applying.  After this time, the QR code will be inactive.
     * @type {number}
     * @memberof CreateQRCodeRequest
     */
    EndTimeMinute?: number;
}
/**
 * Contains fields for creating a Trip
 * @export
 * @interface CreateTripRequest
 */
export interface CreateTripRequest {
    /**
     * The associated Timesheet record Id.  The Trip will be linked to the Timesheet with this TimesheetId
     * @type {number}
     * @memberof CreateTripRequest
     */
    TimesheetId?: number;
    /**
     * The associated Vehicle Id.  The Trip will show that this Vehicle was used
     * @type {number}
     * @memberof CreateTripRequest
     */
    VehicleId?: number;
    /**
     * A CSV of GPS path co-ordinates.  Format example: -37.8433562,144.7226188;[Lat1],[Long1];........[LatN],[LongN]
     * @type {string}
     * @memberof CreateTripRequest
     */
    PathCoordsStringCsv?: string | null;
    /**
     * The total distance of the Trip
     * @type {number}
     * @memberof CreateTripRequest
     */
    DistanceMeters?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof CreateTripRequest
     */
    MobilePlatform?: MobilePlatforms;
}
/**
 * An API Request object for logging into ChronoSheets
 * @export
 * @interface DoLoginRequest
 */
export interface DoLoginRequest {
    /**
     * Your ChronoSheets username or registered email address
     * @type {string}
     * @memberof DoLoginRequest
     */
    UsernameOrEmail?: string | null;
    /**
     * Your ChronoSheets password
     * @type {string}
     * @memberof DoLoginRequest
     */
    Password?: string | null;
    /**
     * Increase session expiry beyond default of 1 hour
     * @type {boolean}
     * @memberof DoLoginRequest
     */
    RememberMe?: boolean;
}
/**
 * A Response object containing important information that can be used after the user has logged in
 * @export
 * @interface DoLoginResponse
 */
export interface DoLoginResponse {
    /**
     * The ChronoSheets Auth Token.  Use this token for all subsequent requests to the API.  The Auth Token does these things: holds your session and gives you appropraite authorisation to access API endpoints based on your UserRoles
     * @type {string}
     * @memberof DoLoginResponse
     */
    CSAuthToken?: string | null;
    /**
     * 
     * @type {ClientSideUser}
     * @memberof DoLoginResponse
     */
    LoggedInUser?: ClientSideUser;
}
/**
 * A standard API response
 * @export
 * @interface DoLoginResponseApiResponse
 */
export interface DoLoginResponseApiResponse {
    /**
     * 
     * @type {DoLoginResponse}
     * @memberof DoLoginResponseApiResponse
     */
    Data?: DoLoginResponse;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof DoLoginResponseApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof DoLoginResponseApiResponse
     */
    Message?: string | null;
}
/**
 * An extended geofence record
 * @export
 * @interface ExtendedGeofence
 */
export interface ExtendedGeofence {
    /**
     * The ID of the geofence
     * @type {number}
     * @memberof ExtendedGeofence
     */
    GeoFencingId?: number;
    /**
     * The ID of the organisation owning the geofence record
     * @type {number}
     * @memberof ExtendedGeofence
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the geofence
     * @type {number}
     * @memberof ExtendedGeofence
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the geofence
     * @type {number}
     * @memberof ExtendedGeofence
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    Name?: string | null;
    /**
     * The name of the approx. location of the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    LocationName?: string | null;
    /**
     * A list of co-ordinates specifying the geofence
     * @type {Array<BasicCoordinate>}
     * @memberof ExtendedGeofence
     */
    Coordinates?: Array<BasicCoordinate> | null;
    /**
     * The date and time the geofence was created.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedGeofence
     */
    CreatedAt?: string;
    /**
     * The date and time the geofence was updated last.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedGeofence
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee enters/exits the geofence
     * @type {number}
     * @memberof ExtendedGeofence
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee enters/exits the geofence
     * @type {number}
     * @memberof ExtendedGeofence
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationGeofenceTriggerSettings}
     * @memberof ExtendedGeofence
     */
    TriggerSettings?: TimesheetAutomationGeofenceTriggerSettings;
    /**
     * The organisation group that will be notified when the geofence is triggered
     * @type {number}
     * @memberof ExtendedGeofence
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationGeofenceAlertSettings}
     * @memberof ExtendedGeofence
     */
    AlertSettings?: TimesheetAutomationGeofenceAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedGeofence
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof ExtendedGeofence
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedGeofence
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof ExtendedGeofence
     */
    EndTimeMinute?: number;
    /**
     * The Job code used when the employee enters/exits the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    JobCode?: string | null;
    /**
     * The name of the task used when the employee enters/exits the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    TaskName?: string | null;
    /**
     * The name of the employee who created the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    CreatedBy?: string | null;
    /**
     * The name of the employee who last updated the geofence
     * @type {string}
     * @memberof ExtendedGeofence
     */
    UpdatedBy?: string | null;
    /**
     * The name of the organisation group who will be notified when the geofence is triggered
     * @type {string}
     * @memberof ExtendedGeofence
     */
    AlertOrganisation?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface ExtendedGeofenceListApiResponseForPaginated
 */
export interface ExtendedGeofenceListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<ExtendedGeofence>}
     * @memberof ExtendedGeofenceListApiResponseForPaginated
     */
    Data?: Array<ExtendedGeofence> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ExtendedGeofenceListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ExtendedGeofenceListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof ExtendedGeofenceListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * An extended NFC Code record
 * @export
 * @interface ExtendedNFCCode
 */
export interface ExtendedNFCCode {
    /**
     * The ID of the NFC code
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    NFCCodeId?: number;
    /**
     * The data stored on the NFC tag used to identify it
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    NFCTagData?: string | null;
    /**
     * The ID of the organisation owning the NFC code record
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the NFC code
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the NFC code
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the NFC code
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    Name?: string | null;
    /**
     * The date and time the NFC code was created.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    CreatedAt?: string;
    /**
     * The date and time the NFC code was updated last.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee activates/deactivates the NFC code
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee activates/deactivates the NFC code
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeTriggerSettings}
     * @memberof ExtendedNFCCode
     */
    TriggerSettings?: TimesheetAutomationNFCCodeTriggerSettings;
    /**
     * The organisation group that will be notified when the NFC code is triggered
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeAlertSettings}
     * @memberof ExtendedNFCCode
     */
    AlertSettings?: TimesheetAutomationNFCCodeAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof ExtendedNFCCode
     */
    EndTimeMinute?: number;
    /**
     * The Job code used when the employee activates/deactivates the NFC code
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    JobCode?: string | null;
    /**
     * The name of the task used when the employee activates/deactivates the NFC code
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    TaskName?: string | null;
    /**
     * The name of the employee who created the NFC code
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    CreatedBy?: string | null;
    /**
     * The name of the employee who last updated the NFC code
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    UpdatedBy?: string | null;
    /**
     * The name of the organisation group who will be notified when the NFC code is triggered
     * @type {string}
     * @memberof ExtendedNFCCode
     */
    AlertOrganisation?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface ExtendedNFCCodeListApiResponseForPaginated
 */
export interface ExtendedNFCCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<ExtendedNFCCode>}
     * @memberof ExtendedNFCCodeListApiResponseForPaginated
     */
    Data?: Array<ExtendedNFCCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ExtendedNFCCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ExtendedNFCCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof ExtendedNFCCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * An extended QR Code record
 * @export
 * @interface ExtendedQRCode
 */
export interface ExtendedQRCode {
    /**
     * The ID of the QR code
     * @type {number}
     * @memberof ExtendedQRCode
     */
    QRCodeId?: number;
    /**
     * The ID of the organisation owning the QR code record
     * @type {number}
     * @memberof ExtendedQRCode
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the QR code
     * @type {number}
     * @memberof ExtendedQRCode
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the QR code
     * @type {number}
     * @memberof ExtendedQRCode
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the QR code
     * @type {string}
     * @memberof ExtendedQRCode
     */
    Name?: string | null;
    /**
     * The date and time the QR code was created.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedQRCode
     */
    CreatedAt?: string;
    /**
     * The date and time the QR code was updated last.  Time is in UTC.
     * @type {string}
     * @memberof ExtendedQRCode
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee activates/deactivates the QR code
     * @type {number}
     * @memberof ExtendedQRCode
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee activates/deactivates the QR code
     * @type {number}
     * @memberof ExtendedQRCode
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationQRCodeTriggerSettings}
     * @memberof ExtendedQRCode
     */
    TriggerSettings?: TimesheetAutomationQRCodeTriggerSettings;
    /**
     * The organisation group that will be notified when the QR code is triggered
     * @type {number}
     * @memberof ExtendedQRCode
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationQRCodeAlertSettings}
     * @memberof ExtendedQRCode
     */
    AlertSettings?: TimesheetAutomationQRCodeAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedQRCode
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof ExtendedQRCode
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof ExtendedQRCode
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof ExtendedQRCode
     */
    EndTimeMinute?: number;
    /**
     * The Job code used when the employee activates/deactivates the QR code
     * @type {string}
     * @memberof ExtendedQRCode
     */
    JobCode?: string | null;
    /**
     * The name of the task used when the employee activates/deactivates the QR code
     * @type {string}
     * @memberof ExtendedQRCode
     */
    TaskName?: string | null;
    /**
     * The name of the employee who created the QR code
     * @type {string}
     * @memberof ExtendedQRCode
     */
    CreatedBy?: string | null;
    /**
     * The name of the employee who last updated the QR code
     * @type {string}
     * @memberof ExtendedQRCode
     */
    UpdatedBy?: string | null;
    /**
     * The name of the organisation group who will be notified when the QR code is triggered
     * @type {string}
     * @memberof ExtendedQRCode
     */
    AlertOrganisation?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface ExtendedQRCodeListApiResponseForPaginated
 */
export interface ExtendedQRCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<ExtendedQRCode>}
     * @memberof ExtendedQRCodeListApiResponseForPaginated
     */
    Data?: Array<ExtendedQRCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ExtendedQRCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ExtendedQRCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof ExtendedQRCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum FileAttachmentTypes {
    Image = 'Image',
    WordDoc = 'WordDoc',
    Pdf = 'Pdf',
    MsSpreadSheet = 'MSSpreadSheet',
    MsPowerPoint = 'MSPowerPoint',
    RichTextFormat = 'RichTextFormat',
    ZipFile = 'ZipFile',
    Other = 'Other',
    Audio = 'Audio'
}

/**
 * 
 * @export
 * @interface FleetSummaryReportItem
 */
export interface FleetSummaryReportItem {
    /**
     * The ID of the vehicle
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    Id?: number;
    /**
     * The ID of the organisation managing the vehicle
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    OrganisationId?: number;
    /**
     * A name given to the vehicle
     * @type {string}
     * @memberof FleetSummaryReportItem
     */
    Name?: string | null;
    /**
     * The cost, in dollars, of running the vehicle over one kilometer
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    CostPerKilometer?: number;
    /**
     * The make of the vehicle
     * @type {string}
     * @memberof FleetSummaryReportItem
     */
    Make?: string | null;
    /**
     * The model of the vehicle
     * @type {string}
     * @memberof FleetSummaryReportItem
     */
    Model?: string | null;
    /**
     * The year the vehicle was manufactured
     * @type {string}
     * @memberof FleetSummaryReportItem
     */
    Year?: string | null;
    /**
     * The licence plate number of the vehicle
     * @type {string}
     * @memberof FleetSummaryReportItem
     */
    LicencePlateNumber?: string | null;
    /**
     * Whether or not the vehicle is deleted
     * @type {boolean}
     * @memberof FleetSummaryReportItem
     */
    IsDeleted?: boolean;
    /**
     * An array of employee IDs that are permitted to use the vehicle
     * @type {Array<number>}
     * @memberof FleetSummaryReportItem
     */
    PermittedEmployees?: Array<number> | null;
    /**
     * 
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    TotalDistanceMetersFiltered?: number;
    /**
     * 
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    TotalDistanceMeters?: number;
    /**
     * 
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    TotalRunningCostDollarsFiltered?: number;
    /**
     * 
     * @type {number}
     * @memberof FleetSummaryReportItem
     */
    TotalRunningCostDollars?: number;
}
/**
 * A standard API response
 * @export
 * @interface FleetSummaryReportItemListApiResponse
 */
export interface FleetSummaryReportItemListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<FleetSummaryReportItem>}
     * @memberof FleetSummaryReportItemListApiResponse
     */
    Data?: Array<FleetSummaryReportItem> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof FleetSummaryReportItemListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof FleetSummaryReportItemListApiResponse
     */
    Message?: string | null;
}
/**
 * A vehicle within the fleet
 * @export
 * @interface FleetVehicle
 */
export interface FleetVehicle {
    /**
     * The ID of the vehicle
     * @type {number}
     * @memberof FleetVehicle
     */
    Id?: number;
    /**
     * The ID of the organisation managing the vehicle
     * @type {number}
     * @memberof FleetVehicle
     */
    OrganisationId?: number;
    /**
     * A name given to the vehicle
     * @type {string}
     * @memberof FleetVehicle
     */
    Name?: string | null;
    /**
     * The cost, in dollars, of running the vehicle over one kilometer
     * @type {number}
     * @memberof FleetVehicle
     */
    CostPerKilometer?: number;
    /**
     * The make of the vehicle
     * @type {string}
     * @memberof FleetVehicle
     */
    Make?: string | null;
    /**
     * The model of the vehicle
     * @type {string}
     * @memberof FleetVehicle
     */
    Model?: string | null;
    /**
     * The year the vehicle was manufactured
     * @type {string}
     * @memberof FleetVehicle
     */
    Year?: string | null;
    /**
     * The licence plate number of the vehicle
     * @type {string}
     * @memberof FleetVehicle
     */
    LicencePlateNumber?: string | null;
    /**
     * Whether or not the vehicle is deleted
     * @type {boolean}
     * @memberof FleetVehicle
     */
    IsDeleted?: boolean;
    /**
     * An array of employee IDs that are permitted to use the vehicle
     * @type {Array<number>}
     * @memberof FleetVehicle
     */
    PermittedEmployees?: Array<number> | null;
}
/**
 * A standard API response
 * @export
 * @interface FleetVehicleApiResponse
 */
export interface FleetVehicleApiResponse {
    /**
     * 
     * @type {FleetVehicle}
     * @memberof FleetVehicleApiResponse
     */
    Data?: FleetVehicle;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof FleetVehicleApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof FleetVehicleApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface FleetVehicleListApiResponse
 */
export interface FleetVehicleListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<FleetVehicle>}
     * @memberof FleetVehicleListApiResponse
     */
    Data?: Array<FleetVehicle> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof FleetVehicleListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof FleetVehicleListApiResponse
     */
    Message?: string | null;
}
/**
 * A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the \'NotForced\' option.
 * @export
 * @enum {string}
 */
export enum ForcedReportFromAllReports {
    NotForced = 'NotForced',
    SeriesJobCodes = 'SeriesJobCodes',
    SeriesClients = 'SeriesClients',
    SeriesProjects = 'SeriesProjects',
    SeriesTasks = 'SeriesTasks',
    TotalsClients = 'TotalsClients',
    TotalsJobCodes = 'TotalsJobCodes',
    TotalsProjects = 'TotalsProjects',
    TotalsTasks = 'TotalsTasks'
}

/**
 * A geofence
 * @export
 * @interface Geofence
 */
export interface Geofence {
    /**
     * The ID of the geofence
     * @type {number}
     * @memberof Geofence
     */
    GeoFencingId?: number;
    /**
     * The ID of the organisation owning the geofence record
     * @type {number}
     * @memberof Geofence
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the geofence
     * @type {number}
     * @memberof Geofence
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the geofence
     * @type {number}
     * @memberof Geofence
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the geofence
     * @type {string}
     * @memberof Geofence
     */
    Name?: string | null;
    /**
     * The name of the approx. location of the geofence
     * @type {string}
     * @memberof Geofence
     */
    LocationName?: string | null;
    /**
     * A list of co-ordinates specifying the geofence
     * @type {Array<BasicCoordinate>}
     * @memberof Geofence
     */
    Coordinates?: Array<BasicCoordinate> | null;
    /**
     * The date and time the geofence was created.  Time is in UTC.
     * @type {string}
     * @memberof Geofence
     */
    CreatedAt?: string;
    /**
     * The date and time the geofence was updated last.  Time is in UTC.
     * @type {string}
     * @memberof Geofence
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee enters/exits the geofence
     * @type {number}
     * @memberof Geofence
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee enters/exits the geofence
     * @type {number}
     * @memberof Geofence
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationGeofenceTriggerSettings}
     * @memberof Geofence
     */
    TriggerSettings?: TimesheetAutomationGeofenceTriggerSettings;
    /**
     * The organisation group that will be notified when the geofence is triggered
     * @type {number}
     * @memberof Geofence
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationGeofenceAlertSettings}
     * @memberof Geofence
     */
    AlertSettings?: TimesheetAutomationGeofenceAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof Geofence
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof Geofence
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof Geofence
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof Geofence
     */
    EndTimeMinute?: number;
}
/**
 * A standard API response
 * @export
 * @interface GeofenceApiResponse
 */
export interface GeofenceApiResponse {
    /**
     * 
     * @type {Geofence}
     * @memberof GeofenceApiResponse
     */
    Data?: Geofence;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof GeofenceApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof GeofenceApiResponse
     */
    Message?: string | null;
}
/**
 * Fields for inserting a new Client
 * @export
 * @interface InsertClientRequest
 */
export interface InsertClientRequest {
    /**
     * The name of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientName?: string | null;
    /**
     * Address line 1 of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientAddressLine1?: string | null;
    /**
     * Address line 2 of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientAddressLine2?: string | null;
    /**
     * The suburb of the Client\'s address
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientSuburb?: string | null;
    /**
     * The state of the Client\'s address
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientState?: string | null;
    /**
     * The post code of the Client\'s address
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientPostCode?: string | null;
    /**
     * The name of the contact working with the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    PersonOfContact?: string | null;
    /**
     * The phone number of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientPhoneNumber?: string | null;
    /**
     * The mobile phone number of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientMobileNumber?: string | null;
    /**
     * The email address of the Client
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientEmailAddress?: string | null;
    /**
     * The Client\'s website URL
     * @type {string}
     * @memberof InsertClientRequest
     */
    ClientWebURL?: string | null;
}
/**
 * Fields for inserting a new Job Code
 * @export
 * @interface InsertJobCodeRequest
 */
export interface InsertJobCodeRequest {
    /**
     * A short code for the Job.  This is referred to as a Job Code
     * @type {string}
     * @memberof InsertJobCodeRequest
     */
    Code?: string | null;
    /**
     * The linked Project.  Time spent with this JobCode is on this Project
     * @type {number}
     * @memberof InsertJobCodeRequest
     */
    ProjectId?: number;
    /**
     * The linked Client.  Time spent with this JobCode is for this Client
     * @type {number}
     * @memberof InsertJobCodeRequest
     */
    ClientId?: number;
    /**
     * A list of Task Ids.  This are the Tasks that become available to the employee when they select this JobCode
     * @type {Array<number>}
     * @memberof InsertJobCodeRequest
     */
    LinkedTaskIds?: Array<number> | null;
    /**
     * Optionally restrict access to the JobCode by specifying which Organisation Groups can use it
     * @type {Array<number>}
     * @memberof InsertJobCodeRequest
     */
    LinkedOrgGroupIds?: Array<number> | null;
}
/**
 * Fields for inserting a new Organisation Group
 * @export
 * @interface InsertOrganisationGroupRequest
 */
export interface InsertOrganisationGroupRequest {
    /**
     * The name of the new Organisation Group.  This is used when you\'re looking up Organisation Groups elsewhere through ChronoSheets
     * @type {string}
     * @memberof InsertOrganisationGroupRequest
     */
    OrganisationGroupName?: string | null;
    /**
     * The Ids of the Users that are going to be in this Organisation Group
     * @type {Array<number>}
     * @memberof InsertOrganisationGroupRequest
     */
    OrganisationGroupUserIds?: Array<number> | null;
}
/**
 * Fields for inserting a new Project
 * @export
 * @interface InsertProjectRequest
 */
export interface InsertProjectRequest {
    /**
     * The Id of the Client that is associated with the new project
     * @type {number}
     * @memberof InsertProjectRequest
     */
    ClientId?: number;
    /**
     * The name of the new Project
     * @type {string}
     * @memberof InsertProjectRequest
     */
    ProjectName?: string | null;
    /**
     * The estimated cost of work to complete the project.  This value is used in the Organisation Reports view \'Project Costs\'
     * @type {number}
     * @memberof InsertProjectRequest
     */
    CostEstimation?: number;
    /**
     * The start date of the project.  When the project is due to start
     * @type {string}
     * @memberof InsertProjectRequest
     */
    StartDate?: string | null;
    /**
     * The end date of the project.  When the project is due to end
     * @type {string}
     * @memberof InsertProjectRequest
     */
    EndDate?: string | null;
}
/**
 * Fields for inserting a new Task
 * @export
 * @interface InsertTaskRequest
 */
export interface InsertTaskRequest {
    /**
     * The name of the Task.  Used to identify the Task when the user is selecting from a list of available Tasks
     * @type {string}
     * @memberof InsertTaskRequest
     */
    TaskName?: string | null;
    /**
     * Whether or not GPS Trip Tracking is enabled on this Task.  GPS Trip tracking is available on the iOS and Android apps.  If it\'s enabled an additional dialog is shown to the user after Task selection that allows the User to choose if they want to record the GPS data
     * @type {boolean}
     * @memberof InsertTaskRequest
     */
    TripEnabled?: boolean;
}
/**
 * Fields for inserting a new set of Pay Rates for a user.  Archiving of the previous Pay Rate is done for you automatically
 * @export
 * @interface InsertUserHourlyRateRequest
 */
export interface InsertUserHourlyRateRequest {
    /**
     * The Id of the User that is getting the new set of Pay Rates
     * @type {number}
     * @memberof InsertUserHourlyRateRequest
     */
    UserId?: number;
    /**
     * The Hourly Rate the employee should receive during their usual rostered hours
     * @type {number}
     * @memberof InsertUserHourlyRateRequest
     */
    HourlyRate?: number;
    /**
     * The Hourly Rate the employee should receive during outside of their usual rostered hours
     * @type {number}
     * @memberof InsertUserHourlyRateRequest
     */
    HourlyOvertimeRate?: number;
    /**
     * The current date time
     * @type {string}
     * @memberof InsertUserHourlyRateRequest
     */
    CurrentDate?: string;
}
/**
 * Used to mark a JobCode as a Favourite.  Favourites can be used in the Mobile app and on the ChronoSheets website
 * @export
 * @interface InsertUserJobFavouriteRequest
 */
export interface InsertUserJobFavouriteRequest {
    /**
     * The Id of the JobCode that is being marked as a favourite
     * @type {number}
     * @memberof InsertUserJobFavouriteRequest
     */
    JobId?: number;
}
/**
 * Fields for Inserting a new User account (employee) under your Organisation in ChronoSheets
 * @export
 * @interface InsertUserRequest
 */
export interface InsertUserRequest {
    /**
     * The Email Address of the employee
     * @type {string}
     * @memberof InsertUserRequest
     */
    EmailAddress?: string | null;
    /**
     * The First Name of the employee
     * @type {string}
     * @memberof InsertUserRequest
     */
    FirstName?: string | null;
    /**
     * The Last Name of the employee
     * @type {string}
     * @memberof InsertUserRequest
     */
    LastName?: string | null;
    /**
     * Whether or not the employee is subscribed to ChronoSheets newsletters
     * @type {boolean}
     * @memberof InsertUserRequest
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
     * @type {number}
     * @memberof InsertUserRequest
     */
    Roles?: number;
    /**
     * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
     * @type {number}
     * @memberof InsertUserRequest
     */
    AlertSettings?: number;
    /**
     * The UserName of the employee.  This can be used when logging into ChronoSheets
     * @type {string}
     * @memberof InsertUserRequest
     */
    UserName?: string | null;
    /**
     * Set the starting usual Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working during Rostered Hours
     * @type {number}
     * @memberof InsertUserRequest
     */
    HourlyPayRate?: number;
    /**
     * Set the starting usual Overtime Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working outside of Rostered Hours
     * @type {number}
     * @memberof InsertUserRequest
     */
    HourlyOvertimePayRate?: number;
    /**
     * The Current date time
     * @type {string}
     * @memberof InsertUserRequest
     */
    CurrentDate?: string;
}
/**
 * 
 * @export
 * @interface InsertUserResponse
 */
export interface InsertUserResponse {
    /**
     * 
     * @type {number}
     * @memberof InsertUserResponse
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof InsertUserResponse
     */
    UserId?: number;
    /**
     * 
     * @type {Array<string>}
     * @memberof InsertUserResponse
     */
    ValidationErrors?: Array<string> | null;
}
/**
 * A standard API response
 * @export
 * @interface InsertUserResponseApiResponse
 */
export interface InsertUserResponseApiResponse {
    /**
     * 
     * @type {InsertUserResponse}
     * @memberof InsertUserResponseApiResponse
     */
    Data?: InsertUserResponse;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof InsertUserResponseApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof InsertUserResponseApiResponse
     */
    Message?: string | null;
}
/**
 * Fields for inserting a new Vehicle
 * @export
 * @interface InsertVehicleRequest
 */
export interface InsertVehicleRequest {
    /**
     * The Name of the Vehicle
     * @type {string}
     * @memberof InsertVehicleRequest
     */
    Name?: string | null;
    /**
     * The fuel cost / running cost of the Vehicle, measured per kilometer
     * @type {number}
     * @memberof InsertVehicleRequest
     */
    CostPerKilometer?: number;
    /**
     * The make of the Vehicle
     * @type {string}
     * @memberof InsertVehicleRequest
     */
    Make?: string | null;
    /**
     * The model of the Vehicle
     * @type {string}
     * @memberof InsertVehicleRequest
     */
    Model?: string | null;
    /**
     * The year the Vehicle was made
     * @type {string}
     * @memberof InsertVehicleRequest
     */
    Year?: string | null;
    /**
     * The Licence Plate Number of the Vehicle
     * @type {string}
     * @memberof InsertVehicleRequest
     */
    LicencePlateNumber?: string | null;
    /**
     * Optionally restrict this Vehicle to only be available to employees within these Organisation Groups
     * @type {Array<number>}
     * @memberof InsertVehicleRequest
     */
    LinkedOrgGroupIds?: Array<number> | null;
}
/**
 * A standard API response
 * @export
 * @interface Int32ApiResponse
 */
export interface Int32ApiResponse {
    /**
     * The main Data of the response
     * @type {number}
     * @memberof Int32ApiResponse
     */
    Data?: number;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof Int32ApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof Int32ApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface Int32ListApiResponse
 */
export interface Int32ListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<number>}
     * @memberof Int32ListApiResponse
     */
    Data?: Array<number> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof Int32ListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof Int32ListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface JobCode
 */
export interface JobCode {
    /**
     * The ID of the job code (not the code itself)
     * @type {number}
     * @memberof JobCode
     */
    Id?: number;
    /**
     * The job code itself
     * @type {string}
     * @memberof JobCode
     */
    Code?: string | null;
    /**
     * The name of the client
     * @type {string}
     * @memberof JobCode
     */
    Client?: string | null;
    /**
     * The ID of the client
     * @type {number}
     * @memberof JobCode
     */
    ClientId?: number;
    /**
     * The name of the project
     * @type {string}
     * @memberof JobCode
     */
    Project?: string | null;
    /**
     * The ID of the project
     * @type {number}
     * @memberof JobCode
     */
    ProjectId?: number;
    /**
     * Your organisation ID
     * @type {number}
     * @memberof JobCode
     */
    OrganisationId?: number;
    /**
     * A flag indicating whether or not the job code has been marked as deleted
     * @type {boolean}
     * @memberof JobCode
     */
    IsDeleted?: boolean;
}
/**
 * A standard API response
 * @export
 * @interface JobCodeApiResponse
 */
export interface JobCodeApiResponse {
    /**
     * 
     * @type {JobCode}
     * @memberof JobCodeApiResponse
     */
    Data?: JobCode;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof JobCodeApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof JobCodeApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface JobCodeListApiResponse
 */
export interface JobCodeListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<JobCode>}
     * @memberof JobCodeListApiResponse
     */
    Data?: Array<JobCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof JobCodeListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof JobCodeListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface JobSeriesReportItem
 */
export interface JobSeriesReportItem {
    /**
     * 
     * @type {string}
     * @memberof JobSeriesReportItem
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof JobSeriesReportItem
     */
    EndDate?: string;
    /**
     * 
     * @type {number}
     * @memberof JobSeriesReportItem
     */
    JobId?: number;
    /**
     * 
     * @type {number}
     * @memberof JobSeriesReportItem
     */
    ClientId?: number;
    /**
     * 
     * @type {string}
     * @memberof JobSeriesReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof JobSeriesReportItem
     */
    ProjectId?: number;
    /**
     * 
     * @type {string}
     * @memberof JobSeriesReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof JobSeriesReportItem
     */
    SpanSeconds?: number;
    /**
     * 
     * @type {string}
     * @memberof JobSeriesReportItem
     */
    JobCode?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface JobSeriesReportItemListApiResponse
 */
export interface JobSeriesReportItemListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<JobSeriesReportItem>}
     * @memberof JobSeriesReportItemListApiResponse
     */
    Data?: Array<JobSeriesReportItem> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof JobSeriesReportItemListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof JobSeriesReportItemListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface JobTotalsReportItem
 */
export interface JobTotalsReportItem {
    /**
     * 
     * @type {number}
     * @memberof JobTotalsReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof JobTotalsReportItem
     */
    JobId?: number;
    /**
     * 
     * @type {string}
     * @memberof JobTotalsReportItem
     */
    JobCode?: string | null;
    /**
     * 
     * @type {number}
     * @memberof JobTotalsReportItem
     */
    ClientId?: number;
    /**
     * 
     * @type {string}
     * @memberof JobTotalsReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof JobTotalsReportItem
     */
    ProjectId?: number;
    /**
     * 
     * @type {string}
     * @memberof JobTotalsReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof JobTotalsReportItem
     */
    SpanSeconds?: number;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum MobilePlatforms {
    Unknown = 'Unknown',
    IOs = 'iOS',
    Android = 'Android'
}

/**
 * A NFC Code
 * @export
 * @interface NFCCode
 */
export interface NFCCode {
    /**
     * The ID of the NFC code
     * @type {number}
     * @memberof NFCCode
     */
    NFCCodeId?: number;
    /**
     * The data stored on the NFC tag used to identify it
     * @type {string}
     * @memberof NFCCode
     */
    NFCTagData?: string | null;
    /**
     * The ID of the organisation owning the NFC code record
     * @type {number}
     * @memberof NFCCode
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the NFC code
     * @type {number}
     * @memberof NFCCode
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the NFC code
     * @type {number}
     * @memberof NFCCode
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the NFC code
     * @type {string}
     * @memberof NFCCode
     */
    Name?: string | null;
    /**
     * The date and time the NFC code was created.  Time is in UTC.
     * @type {string}
     * @memberof NFCCode
     */
    CreatedAt?: string;
    /**
     * The date and time the NFC code was updated last.  Time is in UTC.
     * @type {string}
     * @memberof NFCCode
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee activates/deactivates the NFC code
     * @type {number}
     * @memberof NFCCode
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee activates/deactivates the NFC code
     * @type {number}
     * @memberof NFCCode
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeTriggerSettings}
     * @memberof NFCCode
     */
    TriggerSettings?: TimesheetAutomationNFCCodeTriggerSettings;
    /**
     * The organisation group that will be notified when the NFC code is triggered
     * @type {number}
     * @memberof NFCCode
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeAlertSettings}
     * @memberof NFCCode
     */
    AlertSettings?: TimesheetAutomationNFCCodeAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof NFCCode
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof NFCCode
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof NFCCode
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof NFCCode
     */
    EndTimeMinute?: number;
}
/**
 * A standard API response
 * @export
 * @interface NFCCodeApiResponse
 */
export interface NFCCodeApiResponse {
    /**
     * 
     * @type {NFCCode}
     * @memberof NFCCodeApiResponse
     */
    Data?: NFCCode;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof NFCCodeApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof NFCCodeApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface OrgReportTimesheetFileAttachment
 */
export interface OrgReportTimesheetFileAttachment {
    /**
     * The ID of the file attachment
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    FileAttachmentId?: number;
    /**
     * The ID of the user who attached the file
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    UserId?: number;
    /**
     * The ID of the organisation that owns the file and employs the employee
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    OrgId?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof OrgReportTimesheetFileAttachment
     */
    MobilePlatform?: MobilePlatforms;
    /**
     * 
     * @type {FileAttachmentTypes}
     * @memberof OrgReportTimesheetFileAttachment
     */
    AttachmentType?: FileAttachmentTypes;
    /**
     * Any notes regarding the file attachment
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    Notes?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, if it\'s not an image.  If the attachment is an image then this won\'t be set.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    NonImageFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the large version of the image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageLargeFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the medium version of the image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageMediumFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the small version of the image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageSmallFilePath?: string | null;
    /**
     * The original file name of the attachment
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    OriginalFileName?: string | null;
    /**
     * Meta-data indicating the latitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    Latitude?: number;
    /**
     * Meta-data indicating the longitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    Longitude?: number;
    /**
     * The date and time the attachment was uploaded.  Time is in UTC.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    DateUploaded?: string;
    /**
     * The original date and time the image was captured, if it was an image.  This data originates from the meta data inside the image file.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    DateImageCaptured?: string;
    /**
     * The number of bytes allocated for storing the file attachment.
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    StorageAllocationBytes?: number;
    /**
     * If the attachment was an audio file, this field indicates the duration of the audio file in seconds.  This data originates from the meta data inside the audio file.
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    AudioDurationSeconds?: number;
    /**
     * The ID of the timesheet this attachment is attached to.
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachment
     */
    TimesheetId?: number;
    /**
     * The limited use signed URL for the document (if it\'s not an image).  This URL is unique and will eventually expire.  If the attachment is an image, then this won\'t be set.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    DocumentS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the large version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageLargeS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the medium version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageMediumS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the small version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    ImageSmallS3SignedUrl?: string | null;
    /**
     * The start date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    TimesheetStart?: string;
    /**
     * The end date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    TimesheetEnd?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    Username?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachment
     */
    LastName?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface OrgReportTimesheetFileAttachmentListApiResponseForPaginated
 */
export interface OrgReportTimesheetFileAttachmentListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<OrgReportTimesheetFileAttachment>}
     * @memberof OrgReportTimesheetFileAttachmentListApiResponseForPaginated
     */
    Data?: Array<OrgReportTimesheetFileAttachment> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrgReportTimesheetFileAttachmentListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrgReportTimesheetFileAttachmentListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof OrgReportTimesheetFileAttachmentListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @interface OrgReportTranscript
 */
export interface OrgReportTranscript {
    /**
     * The ID of the file attachment
     * @type {number}
     * @memberof OrgReportTranscript
     */
    FileAttachmentId?: number;
    /**
     * The ID of the user who attached the file
     * @type {number}
     * @memberof OrgReportTranscript
     */
    UserId?: number;
    /**
     * The ID of the organisation that owns the file and employs the employee
     * @type {number}
     * @memberof OrgReportTranscript
     */
    OrgId?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof OrgReportTranscript
     */
    MobilePlatform?: MobilePlatforms;
    /**
     * 
     * @type {FileAttachmentTypes}
     * @memberof OrgReportTranscript
     */
    AttachmentType?: FileAttachmentTypes;
    /**
     * Any notes regarding the file attachment
     * @type {string}
     * @memberof OrgReportTranscript
     */
    Notes?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, if it\'s not an image.  If the attachment is an image then this won\'t be set.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    NonImageFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the large version of the image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageLargeFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the medium version of the image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageMediumFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the small version of the image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageSmallFilePath?: string | null;
    /**
     * The original file name of the attachment
     * @type {string}
     * @memberof OrgReportTranscript
     */
    OriginalFileName?: string | null;
    /**
     * Meta-data indicating the latitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof OrgReportTranscript
     */
    Latitude?: number;
    /**
     * Meta-data indicating the longitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof OrgReportTranscript
     */
    Longitude?: number;
    /**
     * The date and time the attachment was uploaded.  Time is in UTC.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    DateUploaded?: string;
    /**
     * The original date and time the image was captured, if it was an image.  This data originates from the meta data inside the image file.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    DateImageCaptured?: string;
    /**
     * The number of bytes allocated for storing the file attachment.
     * @type {number}
     * @memberof OrgReportTranscript
     */
    StorageAllocationBytes?: number;
    /**
     * If the attachment was an audio file, this field indicates the duration of the audio file in seconds.  This data originates from the meta data inside the audio file.
     * @type {number}
     * @memberof OrgReportTranscript
     */
    AudioDurationSeconds?: number;
    /**
     * The ID of the timesheet this attachment is attached to.
     * @type {number}
     * @memberof OrgReportTranscript
     */
    TimesheetId?: number;
    /**
     * The limited use signed URL for the document (if it\'s not an image).  This URL is unique and will eventually expire.  If the attachment is an image, then this won\'t be set.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    DocumentS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the large version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageLargeS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the medium version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageMediumS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the small version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof OrgReportTranscript
     */
    ImageSmallS3SignedUrl?: string | null;
    /**
     * The start date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof OrgReportTranscript
     */
    TimesheetStart?: string;
    /**
     * The end date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof OrgReportTranscript
     */
    TimesheetEnd?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    Username?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    LastName?: string | null;
    /**
     * 
     * @type {boolean}
     * @memberof OrgReportTranscript
     */
    FinishedJob?: boolean;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    CompletedProcessing?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    Created?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    StartedProcessing?: string;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTranscript
     */
    TranscriptionId?: number;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    JobName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTranscript
     */
    Contents?: string | null;
    /**
     * 
     * @type {AudioMediaTypes}
     * @memberof OrgReportTranscript
     */
    MediaType?: AudioMediaTypes;
    /**
     * 
     * @type {TranscriptionJobStatus}
     * @memberof OrgReportTranscript
     */
    TranscriptionStatus?: TranscriptionJobStatus;
}
/**
 * A paginated API repsonse
 * @export
 * @interface OrgReportTranscriptListApiResponseForPaginated
 */
export interface OrgReportTranscriptListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<OrgReportTranscript>}
     * @memberof OrgReportTranscriptListApiResponseForPaginated
     */
    Data?: Array<OrgReportTranscript> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrgReportTranscriptListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrgReportTranscriptListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof OrgReportTranscriptListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @interface OrgReportTrip
 */
export interface OrgReportTrip {
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    TripId?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    TimesheetId?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    VehicleId?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    OrgId?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof OrgReportTrip
     */
    MobilePlatform?: MobilePlatforms;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    EndDate?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    VehicleName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    VehicleMake?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    VehicleModel?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    VehicleYear?: string | null;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    CostPerKilometer?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    TripTotalCost?: number;
    /**
     * 
     * @type {number}
     * @memberof OrgReportTrip
     */
    TotalTripDistanceMeters?: number;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    StartAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    EndAddress?: string | null;
    /**
     * 
     * @type {Array<TripCoordinate>}
     * @memberof OrgReportTrip
     */
    PathCoordinates?: Array<TripCoordinate> | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    CacheExpiryDate?: string;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    Username?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof OrgReportTrip
     */
    LastName?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface OrgReportTripListApiResponseForPaginated
 */
export interface OrgReportTripListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<OrgReportTrip>}
     * @memberof OrgReportTripListApiResponseForPaginated
     */
    Data?: Array<OrgReportTrip> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrgReportTripListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrgReportTripListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof OrgReportTripListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * An organisation in ChronoSheets
 * @export
 * @interface Organisation
 */
export interface Organisation {
    /**
     * The ID of the organisation
     * @type {number}
     * @memberof Organisation
     */
    Id?: number;
    /**
     * The name of the organisation
     * @type {string}
     * @memberof Organisation
     */
    Name?: string | null;
    /**
     * Address line 1 of the organisation
     * @type {string}
     * @memberof Organisation
     */
    AddressLine01?: string | null;
    /**
     * Address line 2 of the organisation
     * @type {string}
     * @memberof Organisation
     */
    AddressLine02?: string | null;
    /**
     * The suburb where the organisation is located
     * @type {string}
     * @memberof Organisation
     */
    Suburb?: string | null;
    /**
     * The state where the organisation is located
     * @type {string}
     * @memberof Organisation
     */
    State?: string | null;
    /**
     * The postcode of the organisation
     * @type {string}
     * @memberof Organisation
     */
    Postcode?: string | null;
    /**
     * The country of the organisation
     * @type {string}
     * @memberof Organisation
     */
    Country?: string | null;
    /**
     * The primary phone contact number of the organisation
     * @type {string}
     * @memberof Organisation
     */
    Phone?: string | null;
    /**
     * The primary email address of the organisation
     * @type {string}
     * @memberof Organisation
     */
    EmailAddress?: string | null;
    /**
     * The timezone of the organisation
     * @type {string}
     * @memberof Organisation
     */
    Timezone?: string | null;
    /**
     * The customer ID of the payments subscription
     * @type {string}
     * @memberof Organisation
     */
    SubscriptionCustomerId?: string | null;
    /**
     * The sign up token
     * @type {string}
     * @memberof Organisation
     */
    SignupToken?: string | null;
    /**
     * Whether or not the organisation is active
     * @type {boolean}
     * @memberof Organisation
     */
    IsActive?: boolean;
    /**
     * The payments coupon code
     * @type {string}
     * @memberof Organisation
     */
    StripeCouponCode?: string | null;
    /**
     * 
     * @type {SubscriptionSource}
     * @memberof Organisation
     */
    SubscriptionSource?: SubscriptionSource;
    /**
     * 
     * @type {SignUpSource}
     * @memberof Organisation
     */
    SignUpSource?: SignUpSource;
    /**
     * A temporary mobile sign up code
     * @type {string}
     * @memberof Organisation
     */
    MobileSignUpCode?: string | null;
    /**
     * The start date and time of the organisations subscription
     * @type {string}
     * @memberof Organisation
     */
    SubscriptionCycleStart?: string;
    /**
     * The end date and time of the organisations subscription
     * @type {string}
     * @memberof Organisation
     */
    SubscriptionCycleEnd?: string;
    /**
     * The organisation\'s pricing plans
     * @type {Array<OrganisationPricingPlan>}
     * @memberof Organisation
     */
    PricingPlans?: Array<OrganisationPricingPlan> | null;
    /**
     * Allow your employees to edit timesheets outside of the current work day
     * @type {boolean}
     * @memberof Organisation
     */
    EditTimesheetsOutsideToday?: boolean;
}
/**
 * A standard API response
 * @export
 * @interface OrganisationApiResponse
 */
export interface OrganisationApiResponse {
    /**
     * 
     * @type {Organisation}
     * @memberof OrganisationApiResponse
     */
    Data?: Organisation;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrganisationApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrganisationApiResponse
     */
    Message?: string | null;
}
/**
 * An organisation group.  Organisation groups are used throughout ChronoSheets to assign many groups to one alert, action or restriction.  E.g. you can assign an organisation group to receive geofence alerts, or you could restrict access to vehicles to users within an organisation group.
 * @export
 * @interface OrganisationGroup
 */
export interface OrganisationGroup {
    /**
     * The ID of the organisation group
     * @type {number}
     * @memberof OrganisationGroup
     */
    Id?: number;
    /**
     * The ID of the organisation
     * @type {number}
     * @memberof OrganisationGroup
     */
    OrganisationId?: number;
    /**
     * The descriptive name of the organisation group
     * @type {string}
     * @memberof OrganisationGroup
     */
    OrganisationGroupName?: string | null;
    /**
     * Whether or not the organisation group is deleted
     * @type {boolean}
     * @memberof OrganisationGroup
     */
    IsDeleted?: boolean;
}
/**
 * A standard API response
 * @export
 * @interface OrganisationGroupApiResponse
 */
export interface OrganisationGroupApiResponse {
    /**
     * 
     * @type {OrganisationGroup}
     * @memberof OrganisationGroupApiResponse
     */
    Data?: OrganisationGroup;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrganisationGroupApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrganisationGroupApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface OrganisationGroupListApiResponse
 */
export interface OrganisationGroupListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<OrganisationGroup>}
     * @memberof OrganisationGroupListApiResponse
     */
    Data?: Array<OrganisationGroup> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof OrganisationGroupListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof OrganisationGroupListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface OrganisationPricingPlan
 */
export interface OrganisationPricingPlan {
    /**
     * 
     * @type {string}
     * @memberof OrganisationPricingPlan
     */
    PlanId?: string | null;
    /**
     * 
     * @type {number}
     * @memberof OrganisationPricingPlan
     */
    Quantity?: number;
}
/**
 * A project in ChronoSheets
 * @export
 * @interface Project
 */
export interface Project {
    /**
     * The ID of the project
     * @type {number}
     * @memberof Project
     */
    Id?: number;
    /**
     * The ID of the client for which the project is being undertaken for
     * @type {number}
     * @memberof Project
     */
    ClientId?: number;
    /**
     * The ID of the organisation that is completing the project
     * @type {number}
     * @memberof Project
     */
    OrganisationId?: number;
    /**
     * A descriptive name of the project
     * @type {string}
     * @memberof Project
     */
    ProjectName?: string | null;
    /**
     * The project\'s estimated cost
     * @type {number}
     * @memberof Project
     */
    CostEstimation?: number;
    /**
     * The project\'s actual cost
     * @type {number}
     * @memberof Project
     */
    CostActual?: number;
    /**
     * The start date and time of the project
     * @type {string}
     * @memberof Project
     */
    StartDate?: string | null;
    /**
     * The end date and time of the project
     * @type {string}
     * @memberof Project
     */
    EndDate?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface ProjectApiResponse
 */
export interface ProjectApiResponse {
    /**
     * 
     * @type {Project}
     * @memberof ProjectApiResponse
     */
    Data?: Project;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ProjectApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ProjectApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface ProjectCostingReportItem
 */
export interface ProjectCostingReportItem {
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    ProjectId?: number;
    /**
     * 
     * @type {string}
     * @memberof ProjectCostingReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    ClientId?: number;
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {string}
     * @memberof ProjectCostingReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    EstimatedCost?: number;
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    ActualCostFiltered?: number;
    /**
     * 
     * @type {number}
     * @memberof ProjectCostingReportItem
     */
    ActualCost?: number;
}
/**
 * A standard API response
 * @export
 * @interface ProjectCostingReportItemListApiResponse
 */
export interface ProjectCostingReportItemListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<ProjectCostingReportItem>}
     * @memberof ProjectCostingReportItemListApiResponse
     */
    Data?: Array<ProjectCostingReportItem> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ProjectCostingReportItemListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ProjectCostingReportItemListApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface ProjectListApiResponse
 */
export interface ProjectListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<Project>}
     * @memberof ProjectListApiResponse
     */
    Data?: Array<Project> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof ProjectListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof ProjectListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface ProjectSeriesReportItem
 */
export interface ProjectSeriesReportItem {
    /**
     * 
     * @type {string}
     * @memberof ProjectSeriesReportItem
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof ProjectSeriesReportItem
     */
    EndDate?: string;
    /**
     * 
     * @type {number}
     * @memberof ProjectSeriesReportItem
     */
    ProjectId?: number;
    /**
     * 
     * @type {string}
     * @memberof ProjectSeriesReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ProjectSeriesReportItem
     */
    SpanSeconds?: number;
}
/**
 * 
 * @export
 * @interface ProjectTotalsReportItem
 */
export interface ProjectTotalsReportItem {
    /**
     * 
     * @type {number}
     * @memberof ProjectTotalsReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof ProjectTotalsReportItem
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof ProjectTotalsReportItem
     */
    ProjectId?: number;
    /**
     * 
     * @type {string}
     * @memberof ProjectTotalsReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ProjectTotalsReportItem
     */
    SpanSeconds?: number;
}
/**
 * A QR Code
 * @export
 * @interface QRCode
 */
export interface QRCode {
    /**
     * The ID of the QR code
     * @type {number}
     * @memberof QRCode
     */
    QRCodeId?: number;
    /**
     * The ID of the organisation owning the QR code record
     * @type {number}
     * @memberof QRCode
     */
    OrgId?: number;
    /**
     * The ID of the user/employee who created the QR code
     * @type {number}
     * @memberof QRCode
     */
    CreatedByUserId?: number;
    /**
     * The ID of the user/employee who last updated the QR code
     * @type {number}
     * @memberof QRCode
     */
    LastUpdatedByUserId?: number;
    /**
     * A descriptive name of the QR code
     * @type {string}
     * @memberof QRCode
     */
    Name?: string | null;
    /**
     * The date and time the QR code was created.  Time is in UTC.
     * @type {string}
     * @memberof QRCode
     */
    CreatedAt?: string;
    /**
     * The date and time the QR code was updated last.  Time is in UTC.
     * @type {string}
     * @memberof QRCode
     */
    UpdatedAt?: string;
    /**
     * The ID of the job code used when the employee activates/deactivates the QR code
     * @type {number}
     * @memberof QRCode
     */
    TriggerJobCodeId?: number;
    /**
     * The ID of the task used when the employee activates/deactivates the QR code
     * @type {number}
     * @memberof QRCode
     */
    TriggerTaskId?: number;
    /**
     * 
     * @type {TimesheetAutomationQRCodeTriggerSettings}
     * @memberof QRCode
     */
    TriggerSettings?: TimesheetAutomationQRCodeTriggerSettings;
    /**
     * The organisation group that will be notified when the QR code is triggered
     * @type {number}
     * @memberof QRCode
     */
    AlertToOrgGroupId?: number;
    /**
     * 
     * @type {TimesheetAutomationQRCodeAlertSettings}
     * @memberof QRCode
     */
    AlertSettings?: TimesheetAutomationQRCodeAlertSettings;
    /**
     * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
     * @type {number}
     * @memberof QRCode
     */
    StartTimeHour?: number;
    /**
     * The minute start time.  E.g. 46 would be the 46th minute of the hour.
     * @type {number}
     * @memberof QRCode
     */
    StartTimeMinute?: number;
    /**
     * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
     * @type {number}
     * @memberof QRCode
     */
    EndTimeHour?: number;
    /**
     * The minute end time.  E.g. 13 would be the 13th minute of the hour.
     * @type {number}
     * @memberof QRCode
     */
    EndTimeMinute?: number;
}
/**
 * A standard API response
 * @export
 * @interface QRCodeApiResponse
 */
export interface QRCodeApiResponse {
    /**
     * 
     * @type {QRCode}
     * @memberof QRCodeApiResponse
     */
    Data?: QRCode;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof QRCodeApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof QRCodeApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum RawDataSortColumns {
    EmailAddress = 'EmailAddress',
    JobCode = 'JobCode',
    TaskName = 'TaskName',
    ClientName = 'ClientName',
    ProjectName = 'ProjectName',
    StartDate = 'StartDate',
    EndDate = 'EndDate',
    SpanSeconds = 'SpanSeconds',
    Description = 'Description',
    PayAmount = 'PayAmount',
    PayOvertimeAmount = 'PayOvertimeAmount',
    TripCost = 'TripCost',
    TripDistanceMeters = 'TripDistanceMeters',
    Username = 'Username'
}

/**
 * 
 * @export
 * @interface RawReportItem
 */
export interface RawReportItem {
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    UserId?: number;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    Username?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    JobCode?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    TaskName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    ClientName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    ProjectName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    EndDate?: string;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    SpanSeconds?: number;
    /**
     * 
     * @type {string}
     * @memberof RawReportItem
     */
    Description?: string | null;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    PayAmount?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    PayOvertimeAmount?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    TripCost?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    TripDistanceMeters?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    SpanSecondsNormalTime?: number;
    /**
     * 
     * @type {number}
     * @memberof RawReportItem
     */
    SpanSecondsOvertime?: number;
}
/**
 * A paginated API repsonse
 * @export
 * @interface RawReportItemListApiResponseForPaginated
 */
export interface RawReportItemListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<RawReportItem>}
     * @memberof RawReportItemListApiResponseForPaginated
     */
    Data?: Array<RawReportItem> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof RawReportItemListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof RawReportItemListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof RawReportItemListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * Fields used to save a Client
 * @export
 * @interface SaveClientRequest
 */
export interface SaveClientRequest {
    /**
     * The Id of the Client
     * @type {number}
     * @memberof SaveClientRequest
     */
    Id?: number;
    /**
     * The name of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientName?: string | null;
    /**
     * Address line 1 of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientAddressLine1?: string | null;
    /**
     * Address line 2 of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientAddressLine2?: string | null;
    /**
     * The suburb of the Client\'s address
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientSuburb?: string | null;
    /**
     * The state of the Client\'s address
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientState?: string | null;
    /**
     * The post code of the Client\'s address
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientPostCode?: string | null;
    /**
     * The name of the contact working with the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    PersonOfContact?: string | null;
    /**
     * The phone number of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientPhoneNumber?: string | null;
    /**
     * The mobile phone number of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientMobileNumber?: string | null;
    /**
     * The email address of the Client
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientEmailAddress?: string | null;
    /**
     * The Client\'s website URL
     * @type {string}
     * @memberof SaveClientRequest
     */
    ClientWebURL?: string | null;
}
/**
 * Fields used to save an OrganisationGroup
 * @export
 * @interface SaveOrganisationGroupRequest
 */
export interface SaveOrganisationGroupRequest {
    /**
     * The Id of the Organisation Group you want to update/save
     * @type {number}
     * @memberof SaveOrganisationGroupRequest
     */
    Id?: number;
    /**
     * The updated name of the Organisation Group
     * @type {string}
     * @memberof SaveOrganisationGroupRequest
     */
    OrganisationGroupName?: string | null;
    /**
     * Whether or not the Organisation Group is to be marked as deleted
     * @type {boolean}
     * @memberof SaveOrganisationGroupRequest
     */
    IsDeleted?: boolean;
}
/**
 * Fields for saving an existing Vehicle
 * @export
 * @interface SaveVehicleRequest
 */
export interface SaveVehicleRequest {
    /**
     * The Id of the Vehicle that is being updated
     * @type {number}
     * @memberof SaveVehicleRequest
     */
    Id?: number;
    /**
     * The Name of the Vehicle
     * @type {string}
     * @memberof SaveVehicleRequest
     */
    Name?: string | null;
    /**
     * The fuel cost / running cost of the Vehicle, measured per kilometer
     * @type {number}
     * @memberof SaveVehicleRequest
     */
    CostPerKilometer?: number;
    /**
     * The make of the Vehicle
     * @type {string}
     * @memberof SaveVehicleRequest
     */
    Make?: string | null;
    /**
     * The model of the Vehicle
     * @type {string}
     * @memberof SaveVehicleRequest
     */
    Model?: string | null;
    /**
     * The year the Vehicle was made
     * @type {string}
     * @memberof SaveVehicleRequest
     */
    Year?: string | null;
    /**
     * The Licence Plate Number of the Vehicle
     * @type {string}
     * @memberof SaveVehicleRequest
     */
    LicencePlateNumber?: string | null;
    /**
     * Optionally restrict this Vehicle to only be available to employees within these Organisation Groups
     * @type {Array<number>}
     * @memberof SaveVehicleRequest
     */
    LinkedOrgGroupIds?: Array<number> | null;
    /**
     * Whether or not this Vehicle is to be marked as deleted
     * @type {boolean}
     * @memberof SaveVehicleRequest
     */
    IsDeleted?: boolean;
}
/**
 * 
 * @export
 * @interface SetOrganisationGroupUsersRequest
 */
export interface SetOrganisationGroupUsersRequest {
    /**
     * 
     * @type {number}
     * @memberof SetOrganisationGroupUsersRequest
     */
    OrganisationGroupId?: number;
    /**
     * 
     * @type {string}
     * @memberof SetOrganisationGroupUsersRequest
     */
    CsvUserIds?: string | null;
}
/**
 * An object that can be used to set the Usual Hours (Rostered Hours) of an employee user account
 * @export
 * @interface SetUsualHoursRequest
 */
export interface SetUsualHoursRequest {
    /**
     * A Collection of days (Mon-Sun) with updated Roster timeslots
     * @type {Array<UsualHoursDay>}
     * @memberof SetUsualHoursRequest
     */
    UsualHoursData?: Array<UsualHoursDay> | null;
    /**
     * The Id of the User that these updated Rostered Hours will be applied to
     * @type {number}
     * @memberof SetUsualHoursRequest
     */
    UserId?: number;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum SignUpSource {
    Desktop = 'Desktop',
    MobileiOs = 'MobileiOS',
    MobileAndroid = 'MobileAndroid'
}

/**
 * 
 * @export
 * @enum {string}
 */
export enum SortDirection {
    Ascending = 'Ascending',
    Descending = 'Descending'
}

/**
 * Denotes which payment system the subscription was created with
 * @export
 * @enum {string}
 */
export enum SubscriptionSource {
    None = 'None',
    Stripe = 'Stripe',
    AppleInApp = 'AppleInApp',
    GoogleInApp = 'GoogleInApp'
}

/**
 * 
 * @export
 * @interface TaskSeriesReportItem
 */
export interface TaskSeriesReportItem {
    /**
     * 
     * @type {string}
     * @memberof TaskSeriesReportItem
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof TaskSeriesReportItem
     */
    EndDate?: string;
    /**
     * 
     * @type {number}
     * @memberof TaskSeriesReportItem
     */
    TaskId?: number;
    /**
     * 
     * @type {string}
     * @memberof TaskSeriesReportItem
     */
    TaskName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TaskSeriesReportItem
     */
    SpanSeconds?: number;
}
/**
 * 
 * @export
 * @interface TaskTotalsReportItem
 */
export interface TaskTotalsReportItem {
    /**
     * 
     * @type {number}
     * @memberof TaskTotalsReportItem
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof TaskTotalsReportItem
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof TaskTotalsReportItem
     */
    TaskId?: number;
    /**
     * 
     * @type {string}
     * @memberof TaskTotalsReportItem
     */
    TaskName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TaskTotalsReportItem
     */
    SpanSeconds?: number;
}
/**
 * 
 * @export
 * @interface TimeSlot
 */
export interface TimeSlot {
    /**
     * 
     * @type {TimesheetDay}
     * @memberof TimeSlot
     */
    DayType?: TimesheetDay;
    /**
     * 
     * @type {number}
     * @memberof TimeSlot
     */
    UsualHourId?: number;
    /**
     * 
     * @type {number}
     * @memberof TimeSlot
     */
    StartHour?: number;
    /**
     * 
     * @type {number}
     * @memberof TimeSlot
     */
    StartMinute?: number;
    /**
     * 
     * @type {number}
     * @memberof TimeSlot
     */
    EndHour?: number;
    /**
     * 
     * @type {number}
     * @memberof TimeSlot
     */
    EndMinute?: number;
    /**
     * 
     * @type {boolean}
     * @memberof TimeSlot
     */
    IsValid?: boolean;
}
/**
 * 
 * @export
 * @interface Timesheet
 */
export interface Timesheet {
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    TimesheetId?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    JobId?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    TaskId?: number;
    /**
     * 
     * @type {string}
     * @memberof Timesheet
     */
    StartDateTime?: string;
    /**
     * 
     * @type {string}
     * @memberof Timesheet
     */
    EndDateTime?: string;
    /**
     * 
     * @type {string}
     * @memberof Timesheet
     */
    Description?: string | null;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    TripId?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    FileAttachmentCount?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    PayAmount?: number;
    /**
     * 
     * @type {number}
     * @memberof Timesheet
     */
    OvertimePayAmount?: number;
    /**
     * 
     * @type {boolean}
     * @memberof Timesheet
     */
    IncludesOvertime?: boolean;
}
/**
 * Timesheet automation actions for geofences, QR codes or NFC tags
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationAction {
    EnterGeofence = 'EnterGeofence',
    ExitGeofence = 'ExitGeofence',
    TapOnNfc = 'TapOnNfc',
    TapOffNfc = 'TapOffNfc',
    ScanOnQrCode = 'ScanOnQRCode',
    ScanOffQrCode = 'ScanOffQRCode'
}

/**
 * Alert settings for geofences.  This value will determine the alert behavior for the geofence and send alerts to the linked user.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationGeofenceAlertSettings {
    None = 'None',
    SendWhenEntering = 'SendWhenEntering',
    SendWhenExiting = 'SendWhenExiting',
    SendWhenEnteringOrExiting = 'SendWhenEnteringOrExiting'
}

/**
 * Trigger settings for geoefences. This value will determine the timesheet automation behavior for the automation when the employee enters/exits the geofence.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationGeofenceTriggerSettings {
    None = 'None',
    StartTimesheetWhenEntering = 'StartTimesheetWhenEntering',
    StopTimesheetWhenEntering = 'StopTimesheetWhenEntering',
    StartOnEnterStopOnLeave = 'StartOnEnterStopOnLeave'
}

/**
 * Alert settings for NFC Code.  This value will determine the alert behavior for the NFC Code and send alerts to the linked user.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationNFCCodeAlertSettings {
    None = 'None',
    SendWhenScanOn = 'SendWhenScanOn',
    SendWhenScanOff = 'SendWhenScanOff',
    SendWhenScanOnOrScanOff = 'SendWhenScanOnOrScanOff'
}

/**
 * Trigger settings for NFC Codes. This value will determine the timesheet automation behavior for the automation when the employee activates/deactivates the NFC Code.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationNFCCodeTriggerSettings {
    None = 'None',
    StartOnScanOn = 'StartOnScanOn',
    StopOnScanOn = 'StopOnScanOn',
    StartOnScanOnStopOnScanOff = 'StartOnScanOnStopOnScanOff'
}

/**
 * Alert settings for QR Code.  This value will determine the alert behavior for the QR Code and send alerts to the linked user.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationQRCodeAlertSettings {
    None = 'None',
    SendWhenScanOn = 'SendWhenScanOn',
    SendWhenScanOff = 'SendWhenScanOff',
    SendWhenScanOnOrScanOff = 'SendWhenScanOnOrScanOff'
}

/**
 * Trigger settings for QR Codes. This value will determine the timesheet automation behavior for the automation when the employee activates/deactivates the QR Code.
 * @export
 * @enum {string}
 */
export enum TimesheetAutomationQRCodeTriggerSettings {
    None = 'None',
    StartOnScanOn = 'StartOnScanOn',
    StopOnScanOn = 'StopOnScanOn',
    StartOnScanOnStopOnScanOff = 'StartOnScanOnStopOnScanOff'
}

/**
 * 
 * @export
 * @interface TimesheetAutomationWithOrgAndGeofence
 */
export interface TimesheetAutomationWithOrgAndGeofence {
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    AutomationId?: number;
    /**
     * 
     * @type {TimesheetAutomationAction}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    AutomationActionType?: TimesheetAutomationAction;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    Created?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    Latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    Longitude?: number;
    /**
     * 
     * @type {boolean}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    IsProcessed?: boolean;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    Expires?: string;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    ClientDateTime?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    UserId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    UserName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    LastName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    OrgId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    GeofenceName?: string | null;
    /**
     * 
     * @type {Array<BasicCoordinate>}
     * @memberof TimesheetAutomationWithOrgAndGeofence
     */
    Coordinates?: Array<BasicCoordinate> | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
 */
export interface TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<TimesheetAutomationWithOrgAndGeofence>}
     * @memberof TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
     */
    Data?: Array<TimesheetAutomationWithOrgAndGeofence> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @interface TimesheetAutomationWithOrgAndNFCCode
 */
export interface TimesheetAutomationWithOrgAndNFCCode {
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    AutomationId?: number;
    /**
     * 
     * @type {TimesheetAutomationAction}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    AutomationActionType?: TimesheetAutomationAction;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    Created?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    Latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    Longitude?: number;
    /**
     * 
     * @type {boolean}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    IsProcessed?: boolean;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    Expires?: string;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    ClientDateTime?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    UserId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    UserName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    LastName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    OrgId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCode
     */
    NFCCodeName?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
 */
export interface TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<TimesheetAutomationWithOrgAndNFCCode>}
     * @memberof TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
     */
    Data?: Array<TimesheetAutomationWithOrgAndNFCCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @interface TimesheetAutomationWithOrgAndQRCode
 */
export interface TimesheetAutomationWithOrgAndQRCode {
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    AutomationId?: number;
    /**
     * 
     * @type {TimesheetAutomationAction}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    AutomationActionType?: TimesheetAutomationAction;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    Created?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    Latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    Longitude?: number;
    /**
     * 
     * @type {boolean}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    IsProcessed?: boolean;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    Expires?: string;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    ClientDateTime?: string;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    UserId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    UserName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    LastName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    OrgId?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCode
     */
    QRCodeName?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
 */
export interface TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<TimesheetAutomationWithOrgAndQRCode>}
     * @memberof TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
     */
    Data?: Array<TimesheetAutomationWithOrgAndQRCode> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum TimesheetDay {
    Monday = 'Monday',
    Tuesday = 'Tuesday',
    Wednesday = 'Wednesday',
    Thursday = 'Thursday',
    Friday = 'Friday',
    Saturday = 'Saturday',
    Sunday = 'Sunday'
}

/**
 * A file attachment attached to a timesheet
 * @export
 * @interface TimesheetFileAttachment
 */
export interface TimesheetFileAttachment {
    /**
     * The ID of the file attachment
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    FileAttachmentId?: number;
    /**
     * The ID of the user who attached the file
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    UserId?: number;
    /**
     * The ID of the organisation that owns the file and employs the employee
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    OrgId?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof TimesheetFileAttachment
     */
    MobilePlatform?: MobilePlatforms;
    /**
     * 
     * @type {FileAttachmentTypes}
     * @memberof TimesheetFileAttachment
     */
    AttachmentType?: FileAttachmentTypes;
    /**
     * Any notes regarding the file attachment
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    Notes?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, if it\'s not an image.  If the attachment is an image then this won\'t be set.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    NonImageFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the large version of the image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageLargeFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the medium version of the image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageMediumFilePath?: string | null;
    /**
     * The path to the file attachment as hosted by ChronoSheets storage, only set if it\'s an image.  This is regarding the small version of the image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageSmallFilePath?: string | null;
    /**
     * The original file name of the attachment
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    OriginalFileName?: string | null;
    /**
     * Meta-data indicating the latitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    Latitude?: number;
    /**
     * Meta-data indicating the longitude of the file attachment.  If the attachment is an image, this data originates from the meta data inside the image file.
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    Longitude?: number;
    /**
     * The date and time the attachment was uploaded.  Time is in UTC.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    DateUploaded?: string;
    /**
     * The original date and time the image was captured, if it was an image.  This data originates from the meta data inside the image file.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    DateImageCaptured?: string;
    /**
     * The number of bytes allocated for storing the file attachment.
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    StorageAllocationBytes?: number;
    /**
     * If the attachment was an audio file, this field indicates the duration of the audio file in seconds.  This data originates from the meta data inside the audio file.
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    AudioDurationSeconds?: number;
    /**
     * The ID of the timesheet this attachment is attached to.
     * @type {number}
     * @memberof TimesheetFileAttachment
     */
    TimesheetId?: number;
    /**
     * The limited use signed URL for the document (if it\'s not an image).  This URL is unique and will eventually expire.  If the attachment is an image, then this won\'t be set.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    DocumentS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the large version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageLargeS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the medium version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageMediumS3SignedUrl?: string | null;
    /**
     * The limited use signed URL for the small version of the image.  This URL is unique and will eventually expire.  Only set when the attachment is actually an image.
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    ImageSmallS3SignedUrl?: string | null;
    /**
     * The start date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    TimesheetStart?: string;
    /**
     * The end date and time of the timesheet that this attachment is attached to
     * @type {string}
     * @memberof TimesheetFileAttachment
     */
    TimesheetEnd?: string;
}
/**
 * A standard API response
 * @export
 * @interface TimesheetFileAttachmentApiResponse
 */
export interface TimesheetFileAttachmentApiResponse {
    /**
     * 
     * @type {TimesheetFileAttachment}
     * @memberof TimesheetFileAttachmentApiResponse
     */
    Data?: TimesheetFileAttachment;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetFileAttachmentApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetFileAttachmentApiResponse
     */
    Message?: string | null;
}
/**
 * A paginated API repsonse
 * @export
 * @interface TimesheetFileAttachmentListApiResponseForPaginated
 */
export interface TimesheetFileAttachmentListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<TimesheetFileAttachment>}
     * @memberof TimesheetFileAttachmentListApiResponseForPaginated
     */
    Data?: Array<TimesheetFileAttachment> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetFileAttachmentListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetFileAttachmentListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof TimesheetFileAttachmentListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * A standard API response
 * @export
 * @interface TimesheetListApiResponse
 */
export interface TimesheetListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<Timesheet>}
     * @memberof TimesheetListApiResponse
     */
    Data?: Array<Timesheet> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface TimesheetTask
 */
export interface TimesheetTask {
    /**
     * 
     * @type {number}
     * @memberof TimesheetTask
     */
    Id?: number;
    /**
     * 
     * @type {string}
     * @memberof TimesheetTask
     */
    TaskName?: string | null;
    /**
     * 
     * @type {number}
     * @memberof TimesheetTask
     */
    OrganisationId?: number;
    /**
     * 
     * @type {boolean}
     * @memberof TimesheetTask
     */
    IsDeleted?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof TimesheetTask
     */
    TripEnabled?: boolean;
}
/**
 * A standard API response
 * @export
 * @interface TimesheetTaskApiResponse
 */
export interface TimesheetTaskApiResponse {
    /**
     * 
     * @type {TimesheetTask}
     * @memberof TimesheetTaskApiResponse
     */
    Data?: TimesheetTask;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetTaskApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetTaskApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface TimesheetTaskListApiResponse
 */
export interface TimesheetTaskListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<TimesheetTask>}
     * @memberof TimesheetTaskListApiResponse
     */
    Data?: Array<TimesheetTask> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TimesheetTaskListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TimesheetTaskListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface Transcription
 */
export interface Transcription {
    /**
     * 
     * @type {number}
     * @memberof Transcription
     */
    Id?: number;
    /**
     * 
     * @type {number}
     * @memberof Transcription
     */
    OrgId?: number;
    /**
     * 
     * @type {number}
     * @memberof Transcription
     */
    FileAttachmentId?: number;
    /**
     * 
     * @type {string}
     * @memberof Transcription
     */
    Created?: string;
    /**
     * 
     * @type {TranscriptionJobStatus}
     * @memberof Transcription
     */
    Status?: TranscriptionJobStatus;
    /**
     * 
     * @type {AudioMediaTypes}
     * @memberof Transcription
     */
    MediaType?: AudioMediaTypes;
    /**
     * 
     * @type {string}
     * @memberof Transcription
     */
    Contents?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface TranscriptionApiResponse
 */
export interface TranscriptionApiResponse {
    /**
     * 
     * @type {Transcription}
     * @memberof TranscriptionApiResponse
     */
    Data?: Transcription;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TranscriptionApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TranscriptionApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @enum {string}
 */
export enum TranscriptionJobStatus {
    Saved = 'Saved',
    Processing = 'Processing',
    Completed = 'Completed',
    FailedWithError = 'FailedWithError'
}

/**
 * 
 * @export
 * @interface Trip
 */
export interface Trip {
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    TripId?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    TimesheetId?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    VehicleId?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    OrgId?: number;
    /**
     * 
     * @type {MobilePlatforms}
     * @memberof Trip
     */
    MobilePlatform?: MobilePlatforms;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    StartDate?: string;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    EndDate?: string;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    VehicleName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    VehicleMake?: string | null;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    VehicleModel?: string | null;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    VehicleYear?: string | null;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    CostPerKilometer?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    TripTotalCost?: number;
    /**
     * 
     * @type {number}
     * @memberof Trip
     */
    TotalTripDistanceMeters?: number;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    StartAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    EndAddress?: string | null;
    /**
     * 
     * @type {Array<TripCoordinate>}
     * @memberof Trip
     */
    PathCoordinates?: Array<TripCoordinate> | null;
    /**
     * 
     * @type {string}
     * @memberof Trip
     */
    CacheExpiryDate?: string;
}
/**
 * A standard API response
 * @export
 * @interface TripApiResponse
 */
export interface TripApiResponse {
    /**
     * 
     * @type {Trip}
     * @memberof TripApiResponse
     */
    Data?: Trip;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TripApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TripApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface TripCoordinate
 */
export interface TripCoordinate {
    /**
     * 
     * @type {number}
     * @memberof TripCoordinate
     */
    Latitude?: number;
    /**
     * 
     * @type {number}
     * @memberof TripCoordinate
     */
    Longitude?: number;
}
/**
 * A paginated API repsonse
 * @export
 * @interface TripListApiResponseForPaginated
 */
export interface TripListApiResponseForPaginated {
    /**
     * The main Data of the response
     * @type {Array<Trip>}
     * @memberof TripListApiResponseForPaginated
     */
    Data?: Array<Trip> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof TripListApiResponseForPaginated
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof TripListApiResponseForPaginated
     */
    Message?: string | null;
    /**
     * The count of total records that are being paginated
     * @type {number}
     * @memberof TripListApiResponseForPaginated
     */
    TotalSetCount?: number;
}
/**
 * A request object for updating a new geofence
 * @export
 * @interface UpdateGeoFenceRequest
 */
export interface UpdateGeoFenceRequest {
    /**
     * The ID of the geofence you want to update
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    GeofenceId?: number;
    /**
     * The name of the geo fence
     * @type {string}
     * @memberof UpdateGeoFenceRequest
     */
    Name?: string | null;
    /**
     * A list of coordinates specifying the geofence region
     * @type {Array<BasicCoordinate>}
     * @memberof UpdateGeoFenceRequest
     */
    FenceCoordinates?: Array<BasicCoordinate> | null;
    /**
     * The job code to be used when the person enters/leaves the geofence
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person enters/leaves the geofence
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationGeofenceAlertSettings}
     * @memberof UpdateGeoFenceRequest
     */
    AlertSettings?: TimesheetAutomationGeofenceAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationGeofenceTriggerSettings}
     * @memberof UpdateGeoFenceRequest
     */
    TriggerSettings?: TimesheetAutomationGeofenceTriggerSettings;
    /**
     * The start hour in which this geofence should apply.  After this time, the geofence will be active.
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this geofence should apply.  After this time, the geofence will be active.
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this geofence will stop applying.  After this time, the geofence will be inactive.
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this geofence will stop applying.  After this time, the geofence will be inactive.
     * @type {number}
     * @memberof UpdateGeoFenceRequest
     */
    EndTimeMinute?: number;
}
/**
 * Fields used to update an existing JobCode
 * @export
 * @interface UpdateJobCodeRequest
 */
export interface UpdateJobCodeRequest {
    /**
     * The Id of the JobCode to be updated
     * @type {number}
     * @memberof UpdateJobCodeRequest
     */
    Id?: number;
    /**
     * The new JobCode to be set
     * @type {string}
     * @memberof UpdateJobCodeRequest
     */
    Code?: string | null;
    /**
     * The Id of the Project to be associated to
     * @type {number}
     * @memberof UpdateJobCodeRequest
     */
    ProjectId?: number;
    /**
     * The Id of the Client to be associated to
     * @type {number}
     * @memberof UpdateJobCodeRequest
     */
    ClientId?: number;
    /**
     * A collection of Task Ids to be available when choosing this JobCode
     * @type {Array<number>}
     * @memberof UpdateJobCodeRequest
     */
    LinkedTaskIds?: Array<number> | null;
    /**
     * Restrict the access to this JobCode by specifying which Organisation Groups can have access.  Only employees in these Organisation Groups will be able to access this JobCode
     * @type {Array<number>}
     * @memberof UpdateJobCodeRequest
     */
    LinkedOrgGroupIds?: Array<number> | null;
    /**
     * Whether or not this JobCode is to be marked as deleted
     * @type {boolean}
     * @memberof UpdateJobCodeRequest
     */
    IsDeleted?: boolean;
}
/**
 * 
 * @export
 * @interface UpdateMyProfileRequest
 */
export interface UpdateMyProfileRequest {
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    LastName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    OldPassword?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    NewPassword?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UpdateMyProfileRequest
     */
    ConfirmNewPassword?: string | null;
    /**
     * 
     * @type {boolean}
     * @memberof UpdateMyProfileRequest
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof UpdateMyProfileRequest
     */
    WantsToChangePassword?: boolean;
}
/**
 * A request object for updating a new NFC code
 * @export
 * @interface UpdateNFCCodeRequest
 */
export interface UpdateNFCCodeRequest {
    /**
     * The ID of the NFC code you want to update
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    NFCCodeId?: number;
    /**
     * The data stored on the NFC tag used to identify it
     * @type {string}
     * @memberof UpdateNFCCodeRequest
     */
    NFCTagData?: string | null;
    /**
     * The name of the NFC code
     * @type {string}
     * @memberof UpdateNFCCodeRequest
     */
    Name?: string | null;
    /**
     * The job code to be used when the person activates/deactivates the NFC code
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person activates/deactivates the NFC code
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeAlertSettings}
     * @memberof UpdateNFCCodeRequest
     */
    AlertSettings?: TimesheetAutomationNFCCodeAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationNFCCodeTriggerSettings}
     * @memberof UpdateNFCCodeRequest
     */
    TriggerSettings?: TimesheetAutomationNFCCodeTriggerSettings;
    /**
     * The start hour in which this NFC code should apply.  After this time, the NFC code will be active.
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this NFC code should apply.  After this time, the NFC code will be active.
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
     * @type {number}
     * @memberof UpdateNFCCodeRequest
     */
    EndTimeMinute?: number;
}
/**
 * Field for updating your Organisation
 * @export
 * @interface UpdateOrganisationRequest
 */
export interface UpdateOrganisationRequest {
    /**
     * The Id of your Organisation.  This is validated based on your current Auth Token
     * @type {number}
     * @memberof UpdateOrganisationRequest
     */
    OrgansationId?: number;
    /**
     * The updated organisation name
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationName?: string | null;
    /**
     * The updated Address Line 1 value
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    AddressLine01?: string | null;
    /**
     * The updated Address Line 2 value
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    AddressLine02?: string | null;
    /**
     * The updated address suburb
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationSuburb?: string | null;
    /**
     * The updated address state
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationState?: string | null;
    /**
     * The updated address postcode
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationPostcode?: string | null;
    /**
     * The updated address country
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationCountry?: string | null;
    /**
     * The updated contact phone number
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationPhone?: string | null;
    /**
     * The update organisation email address
     * @type {string}
     * @memberof UpdateOrganisationRequest
     */
    OrganisationEmailAddress?: string | null;
    /**
     * Allow your employees to edit timesheets outside of the current work day
     * @type {boolean}
     * @memberof UpdateOrganisationRequest
     */
    EditTimesheetsOutsideToday?: boolean;
}
/**
 * 
 * @export
 * @interface UpdateOrganisationResponse
 */
export interface UpdateOrganisationResponse {
    /**
     * 
     * @type {Array<string>}
     * @memberof UpdateOrganisationResponse
     */
    ValidationErrors?: Array<string> | null;
}
/**
 * A standard API response
 * @export
 * @interface UpdateOrganisationResponseApiResponse
 */
export interface UpdateOrganisationResponseApiResponse {
    /**
     * 
     * @type {UpdateOrganisationResponse}
     * @memberof UpdateOrganisationResponseApiResponse
     */
    Data?: UpdateOrganisationResponse;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UpdateOrganisationResponseApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UpdateOrganisationResponseApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UpdateProfileResponse
 */
export interface UpdateProfileResponse {
    /**
     * 
     * @type {number}
     * @memberof UpdateProfileResponse
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof UpdateProfileResponse
     */
    UserId?: number;
    /**
     * 
     * @type {Array<string>}
     * @memberof UpdateProfileResponse
     */
    ValidationErrors?: Array<string> | null;
}
/**
 * A standard API response
 * @export
 * @interface UpdateProfileResponseApiResponse
 */
export interface UpdateProfileResponseApiResponse {
    /**
     * 
     * @type {UpdateProfileResponse}
     * @memberof UpdateProfileResponseApiResponse
     */
    Data?: UpdateProfileResponse;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UpdateProfileResponseApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UpdateProfileResponseApiResponse
     */
    Message?: string | null;
}
/**
 * Fields for updating a project
 * @export
 * @interface UpdateProjectRequest
 */
export interface UpdateProjectRequest {
    /**
     * The Id of the Project that is to be updated
     * @type {number}
     * @memberof UpdateProjectRequest
     */
    ProjectId?: number;
    /**
     * The new name of the Project
     * @type {string}
     * @memberof UpdateProjectRequest
     */
    ProjectName?: string | null;
    /**
     * The updated estimated cost of the Project
     * @type {number}
     * @memberof UpdateProjectRequest
     */
    CostEstimation?: number;
    /**
     * The updated project start date
     * @type {string}
     * @memberof UpdateProjectRequest
     */
    StartDate?: string | null;
    /**
     * The update project end date
     * @type {string}
     * @memberof UpdateProjectRequest
     */
    EndDate?: string | null;
}
/**
 * A request object for updating a new QR code
 * @export
 * @interface UpdateQRCodeRequest
 */
export interface UpdateQRCodeRequest {
    /**
     * The ID of the QR code you want to update
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    QRCodeId?: number;
    /**
     * The name of the QR code
     * @type {string}
     * @memberof UpdateQRCodeRequest
     */
    Name?: string | null;
    /**
     * The job code to be used when the person activates/deactivates the QR code
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    TriggerJobCodeId?: number | null;
    /**
     * The task to be used when the person activates/deactivates the QR code
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    TriggerTaskId?: number | null;
    /**
     * Send an alert to a user, specified by their user ID
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    SendAlertToOrgGroupId?: number | null;
    /**
     * 
     * @type {TimesheetAutomationQRCodeAlertSettings}
     * @memberof UpdateQRCodeRequest
     */
    AlertSettings?: TimesheetAutomationQRCodeAlertSettings;
    /**
     * 
     * @type {TimesheetAutomationQRCodeTriggerSettings}
     * @memberof UpdateQRCodeRequest
     */
    TriggerSettings?: TimesheetAutomationQRCodeTriggerSettings;
    /**
     * The start hour in which this QR code should apply.  After this time, the QR code will be active.
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    StartTimeHour?: number;
    /**
     * The start minute in which this QR code should apply.  After this time, the QR code will be active.
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    StartTimeMinute?: number;
    /**
     * The end hour in which this QR code will stop applying.  After this time, the QR code will be inactive.
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    EndTimeHour?: number;
    /**
     * The end minute in which this QR code will stop applying.  After this time, the QR code will be inactive.
     * @type {number}
     * @memberof UpdateQRCodeRequest
     */
    EndTimeMinute?: number;
}
/**
 * Fields used to update a Task
 * @export
 * @interface UpdateTaskRequest
 */
export interface UpdateTaskRequest {
    /**
     * The Id of the Task that is to be updated
     * @type {number}
     * @memberof UpdateTaskRequest
     */
    Id?: number;
    /**
     * The updated Task Name
     * @type {string}
     * @memberof UpdateTaskRequest
     */
    TaskName?: string | null;
    /**
     * Whether or not this Task should be marked as deleted
     * @type {boolean}
     * @memberof UpdateTaskRequest
     */
    IsDeleted?: boolean;
    /**
     * Whether or not this Task should have GPS Trip Recording enabled
     * @type {boolean}
     * @memberof UpdateTaskRequest
     */
    TripEnabled?: boolean;
}
/**
 * Fields for updating an employee User Account
 * @export
 * @interface UpdateUserRequest
 */
export interface UpdateUserRequest {
    /**
     * The Id of the User that is to be updated
     * @type {number}
     * @memberof UpdateUserRequest
     */
    UserId?: number;
    /**
     * The Email Address of the employee
     * @type {string}
     * @memberof UpdateUserRequest
     */
    EmailAddress?: string | null;
    /**
     * The First Name of the employee
     * @type {string}
     * @memberof UpdateUserRequest
     */
    FirstName?: string | null;
    /**
     * The Last Name of the employee
     * @type {string}
     * @memberof UpdateUserRequest
     */
    LastName?: string | null;
    /**
     * Whether or not the employee is subscribed to ChronoSheets newsletters
     * @type {boolean}
     * @memberof UpdateUserRequest
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * Whether or not the employee account is active
     * @type {boolean}
     * @memberof UpdateUserRequest
     */
    IsAccountActive?: boolean;
    /**
     * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
     * @type {number}
     * @memberof UpdateUserRequest
     */
    Roles?: number;
    /**
     * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
     * @type {number}
     * @memberof UpdateUserRequest
     */
    AlertSettings?: number;
}
/**
 * 
 * @export
 * @interface UpdateUserResponse
 */
export interface UpdateUserResponse {
    /**
     * 
     * @type {number}
     * @memberof UpdateUserResponse
     */
    OrganisationId?: number;
    /**
     * 
     * @type {number}
     * @memberof UpdateUserResponse
     */
    UserId?: number;
    /**
     * 
     * @type {Array<string>}
     * @memberof UpdateUserResponse
     */
    ValidationErrors?: Array<string> | null;
}
/**
 * A standard API response
 * @export
 * @interface UpdateUserResponseApiResponse
 */
export interface UpdateUserResponseApiResponse {
    /**
     * 
     * @type {UpdateUserResponse}
     * @memberof UpdateUserResponseApiResponse
     */
    Data?: UpdateUserResponse;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UpdateUserResponseApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UpdateUserResponseApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UserForManagement
 */
export interface UserForManagement {
    /**
     * The ID of the user
     * @type {number}
     * @memberof UserForManagement
     */
    Id?: number;
    /**
     * The ID of the organisation
     * @type {number}
     * @memberof UserForManagement
     */
    OrganisationId?: number;
    /**
     * The username of the user
     * @type {string}
     * @memberof UserForManagement
     */
    UserName?: string | null;
    /**
     * The first name of the user
     * @type {string}
     * @memberof UserForManagement
     */
    FirstName?: string | null;
    /**
     * The last name of the user
     * @type {string}
     * @memberof UserForManagement
     */
    LastName?: string | null;
    /**
     * The email address of the user
     * @type {string}
     * @memberof UserForManagement
     */
    EmailAddress?: string | null;
    /**
     * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
     * @type {number}
     * @memberof UserForManagement
     */
    Roles?: number;
    /**
     * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
     * @type {number}
     * @memberof UserForManagement
     */
    AlertSettings?: number;
    /**
     * Whether or not the setup wizard is required
     * @type {boolean}
     * @memberof UserForManagement
     */
    SetupWizardRequired?: boolean;
    /**
     * Whether or not the user is subscribed to the user
     * @type {boolean}
     * @memberof UserForManagement
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * 
     * @type {Organisation}
     * @memberof UserForManagement
     */
    Organisation?: Organisation;
    /**
     * Whether or not this account is the organisation\'s primary account.
     * @type {boolean}
     * @memberof UserForManagement
     */
    IsPrimaryAccount?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof UserForManagement
     */
    IsAccountActive?: boolean;
}
/**
 * A standard API response
 * @export
 * @interface UserForManagementApiResponse
 */
export interface UserForManagementApiResponse {
    /**
     * 
     * @type {UserForManagement}
     * @memberof UserForManagementApiResponse
     */
    Data?: UserForManagement;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UserForManagementApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UserForManagementApiResponse
     */
    Message?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface UserForManagementListApiResponse
 */
export interface UserForManagementListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<UserForManagement>}
     * @memberof UserForManagementListApiResponse
     */
    Data?: Array<UserForManagement> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UserForManagementListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UserForManagementListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UserHourlyRate
 */
export interface UserHourlyRate {
    /**
     * 
     * @type {number}
     * @memberof UserHourlyRate
     */
    RateId?: number;
    /**
     * 
     * @type {number}
     * @memberof UserHourlyRate
     */
    UserId?: number;
    /**
     * 
     * @type {number}
     * @memberof UserHourlyRate
     */
    OrganisationId?: number;
    /**
     * 
     * @type {boolean}
     * @memberof UserHourlyRate
     */
    IsCurrent?: boolean;
    /**
     * 
     * @type {number}
     * @memberof UserHourlyRate
     */
    HourlyRate?: number;
    /**
     * 
     * @type {number}
     * @memberof UserHourlyRate
     */
    HourlyOvertimeRate?: number;
    /**
     * 
     * @type {string}
     * @memberof UserHourlyRate
     */
    StartDateTime?: string;
    /**
     * 
     * @type {string}
     * @memberof UserHourlyRate
     */
    EndDateTime?: string;
}
/**
 * A standard API response
 * @export
 * @interface UserHourlyRateListApiResponse
 */
export interface UserHourlyRateListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<UserHourlyRate>}
     * @memberof UserHourlyRateListApiResponse
     */
    Data?: Array<UserHourlyRate> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UserHourlyRateListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UserHourlyRateListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UserJobFavourite
 */
export interface UserJobFavourite {
    /**
     * 
     * @type {number}
     * @memberof UserJobFavourite
     */
    Id?: number;
    /**
     * 
     * @type {number}
     * @memberof UserJobFavourite
     */
    JobId?: number;
}
/**
 * A standard API response
 * @export
 * @interface UserJobFavouriteListApiResponse
 */
export interface UserJobFavouriteListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<UserJobFavourite>}
     * @memberof UserJobFavouriteListApiResponse
     */
    Data?: Array<UserJobFavourite> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UserJobFavouriteListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UserJobFavouriteListApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UserProfile
 */
export interface UserProfile {
    /**
     * 
     * @type {number}
     * @memberof UserProfile
     */
    Id?: number;
    /**
     * 
     * @type {number}
     * @memberof UserProfile
     */
    OrganisationId?: number;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    UserName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    FirstName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    LastName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    EmailAddress?: string | null;
    /**
     * 
     * @type {boolean}
     * @memberof UserProfile
     */
    IsSubscribedToNewsletter?: boolean;
    /**
     * 
     * @type {number}
     * @memberof UserProfile
     */
    Roles?: number;
    /**
     * 
     * @type {number}
     * @memberof UserProfile
     */
    AlertSettings?: number;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    OrganisationName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    OrganisationSuburb?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserProfile
     */
    OrganisationCountry?: string | null;
}
/**
 * A standard API response
 * @export
 * @interface UserProfileApiResponse
 */
export interface UserProfileApiResponse {
    /**
     * 
     * @type {UserProfile}
     * @memberof UserProfileApiResponse
     */
    Data?: UserProfile;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UserProfileApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UserProfileApiResponse
     */
    Message?: string | null;
}
/**
 * 
 * @export
 * @interface UsualHoursDay
 */
export interface UsualHoursDay {
    /**
     * 
     * @type {TimesheetDay}
     * @memberof UsualHoursDay
     */
    DayType?: TimesheetDay;
    /**
     * A collection of TimeSlots within this day
     * @type {Array<TimeSlot>}
     * @memberof UsualHoursDay
     */
    TimeSlots?: Array<TimeSlot> | null;
    /**
     * Mark here which existing UsualHours are to be deleted
     * @type {Array<number>}
     * @memberof UsualHoursDay
     */
    DeleteUsualHours?: Array<number> | null;
}
/**
 * A standard API response
 * @export
 * @interface UsualHoursDayListApiResponse
 */
export interface UsualHoursDayListApiResponse {
    /**
     * The main Data of the response
     * @type {Array<UsualHoursDay>}
     * @memberof UsualHoursDayListApiResponse
     */
    Data?: Array<UsualHoursDay> | null;
    /**
     * 
     * @type {ApiResponseCode}
     * @memberof UsualHoursDayListApiResponse
     */
    Status?: ApiResponseCode;
    /**
     * A message to accompany the response status.  If the Status is failed, this message will hint why it failed and what you need to do.
     * @type {string}
     * @memberof UsualHoursDayListApiResponse
     */
    Message?: string | null;
}

/**
 * AggregateClientProjectsApi - axios parameter creator
 * @export
 */
export const AggregateClientProjectsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get client and project information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageClientsAndProjects\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregateClientProjectsGetAggregateClientProjectsGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/AggregateClientProjects/GetAggregateClientProjects`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AggregateClientProjectsApi - functional programming interface
 * @export
 */
export const AggregateClientProjectsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get client and project information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageClientsAndProjects\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async aggregateClientProjectsGetAggregateClientProjectsGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AggregateClientListApiResponse>> {
            const localVarAxiosArgs = await AggregateClientProjectsApiAxiosParamCreator(configuration).aggregateClientProjectsGetAggregateClientProjectsGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * AggregateClientProjectsApi - factory interface
 * @export
 */
export const AggregateClientProjectsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get client and project information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageClientsAndProjects\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregateClientProjectsGetAggregateClientProjectsGet(options?: any): AxiosPromise<AggregateClientListApiResponse> {
            return AggregateClientProjectsApiFp(configuration).aggregateClientProjectsGetAggregateClientProjectsGet(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * AggregateClientProjectsApi - object-oriented interface
 * @export
 * @class AggregateClientProjectsApi
 * @extends {BaseAPI}
 */
export class AggregateClientProjectsApi extends BaseAPI {
    /**
     * 
     * @summary Get client and project information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageClientsAndProjects\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AggregateClientProjectsApi
     */
    public aggregateClientProjectsGetAggregateClientProjectsGet(options?: any) {
        return AggregateClientProjectsApiFp(this.configuration).aggregateClientProjectsGetAggregateClientProjectsGet(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * AggregateJobTasksApi - axios parameter creator
 * @export
 */
export const AggregateJobTasksApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get jobs and tasks information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregateJobTasksGetAggregateJobTasksGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/AggregateJobTasks/GetAggregateJobTasks`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AggregateJobTasksApi - functional programming interface
 * @export
 */
export const AggregateJobTasksApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get jobs and tasks information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async aggregateJobTasksGetAggregateJobTasksGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AggregateJobCodeListApiResponse>> {
            const localVarAxiosArgs = await AggregateJobTasksApiAxiosParamCreator(configuration).aggregateJobTasksGetAggregateJobTasksGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * AggregateJobTasksApi - factory interface
 * @export
 */
export const AggregateJobTasksApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get jobs and tasks information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregateJobTasksGetAggregateJobTasksGet(options?: any): AxiosPromise<AggregateJobCodeListApiResponse> {
            return AggregateJobTasksApiFp(configuration).aggregateJobTasksGetAggregateJobTasksGet(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * AggregateJobTasksApi - object-oriented interface
 * @export
 * @class AggregateJobTasksApi
 * @extends {BaseAPI}
 */
export class AggregateJobTasksApi extends BaseAPI {
    /**
     * 
     * @summary Get jobs and tasks information, aggregated.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AggregateJobTasksApi
     */
    public aggregateJobTasksGetAggregateJobTasksGet(options?: any) {
        return AggregateJobTasksApiFp(this.configuration).aggregateJobTasksGetAggregateJobTasksGet(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * ClientsApi - axios parameter creator
 * @export
 */
export const ClientsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertClientRequest} [insertClientRequest] An Insert Client Request object containing values for the new Client to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsCreateClientPost: async (insertClientRequest?: InsertClientRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Clients/CreateClient`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertClientRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertClientRequest !== undefined ? insertClientRequest : {})
                : (insertClientRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the Client you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsGetClientGet: async (clientId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Clients/GetClient`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (clientId !== undefined) {
                localVarQueryParameter['ClientId'] = clientId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a collection of clients that are under your organisation.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsGetClientsGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Clients/GetClients`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {SaveClientRequest} [saveClientRequest] A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsUpdateClientPut: async (saveClientRequest?: SaveClientRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Clients/UpdateClient`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof saveClientRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(saveClientRequest !== undefined ? saveClientRequest : {})
                : (saveClientRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ClientsApi - functional programming interface
 * @export
 */
export const ClientsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertClientRequest} [insertClientRequest] An Insert Client Request object containing values for the new Client to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async clientsCreateClientPost(insertClientRequest?: InsertClientRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await ClientsApiAxiosParamCreator(configuration).clientsCreateClientPost(insertClientRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the Client you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async clientsGetClientGet(clientId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ClientApiResponse>> {
            const localVarAxiosArgs = await ClientsApiAxiosParamCreator(configuration).clientsGetClientGet(clientId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a collection of clients that are under your organisation.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async clientsGetClientsGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ClientListApiResponse>> {
            const localVarAxiosArgs = await ClientsApiAxiosParamCreator(configuration).clientsGetClientsGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {SaveClientRequest} [saveClientRequest] A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async clientsUpdateClientPut(saveClientRequest?: SaveClientRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await ClientsApiAxiosParamCreator(configuration).clientsUpdateClientPut(saveClientRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * ClientsApi - factory interface
 * @export
 */
export const ClientsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertClientRequest} [insertClientRequest] An Insert Client Request object containing values for the new Client to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsCreateClientPost(insertClientRequest?: InsertClientRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return ClientsApiFp(configuration).clientsCreateClientPost(insertClientRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the Client you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsGetClientGet(clientId?: number, options?: any): AxiosPromise<ClientApiResponse> {
            return ClientsApiFp(configuration).clientsGetClientGet(clientId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a collection of clients that are under your organisation.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsGetClientsGet(options?: any): AxiosPromise<ClientListApiResponse> {
            return ClientsApiFp(configuration).clientsGetClientsGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a client.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {SaveClientRequest} [saveClientRequest] A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        clientsUpdateClientPut(saveClientRequest?: SaveClientRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return ClientsApiFp(configuration).clientsUpdateClientPut(saveClientRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ClientsApi - object-oriented interface
 * @export
 * @class ClientsApi
 * @extends {BaseAPI}
 */
export class ClientsApi extends BaseAPI {
    /**
     * 
     * @summary Create a client.    Requires the \'ManageClientsAndProjects\' permission.
     * @param {InsertClientRequest} [insertClientRequest] An Insert Client Request object containing values for the new Client to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ClientsApi
     */
    public clientsCreateClientPost(insertClientRequest?: InsertClientRequest, options?: any) {
        return ClientsApiFp(this.configuration).clientsCreateClientPost(insertClientRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
     * @param {number} [clientId] The ID of the Client you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ClientsApi
     */
    public clientsGetClientGet(clientId?: number, options?: any) {
        return ClientsApiFp(this.configuration).clientsGetClientGet(clientId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a collection of clients that are under your organisation.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ClientsApi
     */
    public clientsGetClientsGet(options?: any) {
        return ClientsApiFp(this.configuration).clientsGetClientsGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a client.    Requires the \'ManageClientsAndProjects\' permission.
     * @param {SaveClientRequest} [saveClientRequest] A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ClientsApi
     */
    public clientsUpdateClientPut(saveClientRequest?: SaveClientRequest, options?: any) {
        return ClientsApiFp(this.configuration).clientsUpdateClientPut(saveClientRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * FileAttachmentsApi - axios parameter creator
 * @export
 */
export const FileAttachmentsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete a particular timesheet file attachment  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [fileAttachmentId] The Id of the file attachment to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsDeleteTimesheetFileAttachmentDelete: async (fileAttachmentId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/FileAttachments/DeleteTimesheetFileAttachment`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (fileAttachmentId !== undefined) {
                localVarQueryParameter['FileAttachmentId'] = fileAttachmentId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular file attachment by ID.  User must own the file attachment for access.
         * @param {number} [fileAttachmentId] The ID of the file attachment
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsGetFileAttachmentByIdGet: async (fileAttachmentId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/FileAttachments/GetFileAttachmentById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (fileAttachmentId !== undefined) {
                localVarQueryParameter['FileAttachmentId'] = fileAttachmentId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get my file attachments.  Get files you\'ve attached to timesheets.
         * @param {string} [startDate] The Start date of the date range.  File attachments after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  File attachments before this date will be obtained.
         * @param {number} [skip] Skip this many File attachments
         * @param {number} [take] Take this many File attachments
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsGetMyFileAttachmentsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/FileAttachments/GetMyFileAttachments`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FileAttachmentsApi - functional programming interface
 * @export
 */
export const FileAttachmentsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete a particular timesheet file attachment  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [fileAttachmentId] The Id of the file attachment to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await FileAttachmentsApiAxiosParamCreator(configuration).fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular file attachment by ID.  User must own the file attachment for access.
         * @param {number} [fileAttachmentId] The ID of the file attachment
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetFileAttachmentApiResponse>> {
            const localVarAxiosArgs = await FileAttachmentsApiAxiosParamCreator(configuration).fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get my file attachments.  Get files you\'ve attached to timesheets.
         * @param {string} [startDate] The Start date of the date range.  File attachments after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  File attachments before this date will be obtained.
         * @param {number} [skip] Skip this many File attachments
         * @param {number} [take] Take this many File attachments
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fileAttachmentsGetMyFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetFileAttachmentListApiResponseForPaginated>> {
            const localVarAxiosArgs = await FileAttachmentsApiAxiosParamCreator(configuration).fileAttachmentsGetMyFileAttachmentsGet(startDate, endDate, skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * FileAttachmentsApi - factory interface
 * @export
 */
export const FileAttachmentsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Delete a particular timesheet file attachment  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [fileAttachmentId] The Id of the file attachment to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return FileAttachmentsApiFp(configuration).fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular file attachment by ID.  User must own the file attachment for access.
         * @param {number} [fileAttachmentId] The ID of the file attachment
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId?: number, options?: any): AxiosPromise<TimesheetFileAttachmentApiResponse> {
            return FileAttachmentsApiFp(configuration).fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get my file attachments.  Get files you\'ve attached to timesheets.
         * @param {string} [startDate] The Start date of the date range.  File attachments after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  File attachments before this date will be obtained.
         * @param {number} [skip] Skip this many File attachments
         * @param {number} [take] Take this many File attachments
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileAttachmentsGetMyFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, options?: any): AxiosPromise<TimesheetFileAttachmentListApiResponseForPaginated> {
            return FileAttachmentsApiFp(configuration).fileAttachmentsGetMyFileAttachmentsGet(startDate, endDate, skip, take, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * FileAttachmentsApi - object-oriented interface
 * @export
 * @class FileAttachmentsApi
 * @extends {BaseAPI}
 */
export class FileAttachmentsApi extends BaseAPI {
    /**
     * 
     * @summary Delete a particular timesheet file attachment  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [fileAttachmentId] The Id of the file attachment to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FileAttachmentsApi
     */
    public fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId?: number, options?: any) {
        return FileAttachmentsApiFp(this.configuration).fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular file attachment by ID.  User must own the file attachment for access.
     * @param {number} [fileAttachmentId] The ID of the file attachment
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FileAttachmentsApi
     */
    public fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId?: number, options?: any) {
        return FileAttachmentsApiFp(this.configuration).fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get my file attachments.  Get files you\'ve attached to timesheets.
     * @param {string} [startDate] The Start date of the date range.  File attachments after this date will be obtained.
     * @param {string} [endDate] The End date of the date range.  File attachments before this date will be obtained.
     * @param {number} [skip] Skip this many File attachments
     * @param {number} [take] Take this many File attachments
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FileAttachmentsApi
     */
    public fileAttachmentsGetMyFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, options?: any) {
        return FileAttachmentsApiFp(this.configuration).fileAttachmentsGetMyFileAttachmentsGet(startDate, endDate, skip, take, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * FleetApi - axios parameter creator
 * @export
 */
export const FleetApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {InsertVehicleRequest} [insertVehicleRequest] An Insert Vehicle Request object containing values for the new Vehicle to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetCreateVehiclePost: async (insertVehicleRequest?: InsertVehicleRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Fleet/CreateVehicle`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertVehicleRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertVehicleRequest !== undefined ? insertVehicleRequest : {})
                : (insertVehicleRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a vehicle from the fleet.  Requires the \'ManageFleet\' permission.
         * @param {number} [vehicleId] The unique ID of the vehicle you wish to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetDeleteVehicleDelete: async (vehicleId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Fleet/DeleteVehicle`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (vehicleId !== undefined) {
                localVarQueryParameter['VehicleId'] = vehicleId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular vehicle.  Does not require any special permission.
         * @param {number} [vehicleId] The ID of the Vehicle you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetGetVehicleByIdGet: async (vehicleId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Fleet/GetVehicleById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (vehicleId !== undefined) {
                localVarQueryParameter['VehicleId'] = vehicleId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a collection of vehicles that are under your organisation.    Does not require any special permission.
         * @param {boolean} [includeDeleted] Whether or not to include deleted vehicles
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetGetVehiclesGet: async (includeDeleted?: boolean, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Fleet/GetVehicles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (includeDeleted !== undefined) {
                localVarQueryParameter['IncludeDeleted'] = includeDeleted;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {SaveVehicleRequest} [saveVehicleRequest] A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetUpdateVehiclePut: async (saveVehicleRequest?: SaveVehicleRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Fleet/UpdateVehicle`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof saveVehicleRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(saveVehicleRequest !== undefined ? saveVehicleRequest : {})
                : (saveVehicleRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FleetApi - functional programming interface
 * @export
 */
export const FleetApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {InsertVehicleRequest} [insertVehicleRequest] An Insert Vehicle Request object containing values for the new Vehicle to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fleetCreateVehiclePost(insertVehicleRequest?: InsertVehicleRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await FleetApiAxiosParamCreator(configuration).fleetCreateVehiclePost(insertVehicleRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a vehicle from the fleet.  Requires the \'ManageFleet\' permission.
         * @param {number} [vehicleId] The unique ID of the vehicle you wish to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fleetDeleteVehicleDelete(vehicleId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await FleetApiAxiosParamCreator(configuration).fleetDeleteVehicleDelete(vehicleId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular vehicle.  Does not require any special permission.
         * @param {number} [vehicleId] The ID of the Vehicle you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fleetGetVehicleByIdGet(vehicleId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FleetVehicleApiResponse>> {
            const localVarAxiosArgs = await FleetApiAxiosParamCreator(configuration).fleetGetVehicleByIdGet(vehicleId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a collection of vehicles that are under your organisation.    Does not require any special permission.
         * @param {boolean} [includeDeleted] Whether or not to include deleted vehicles
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fleetGetVehiclesGet(includeDeleted?: boolean, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FleetVehicleListApiResponse>> {
            const localVarAxiosArgs = await FleetApiAxiosParamCreator(configuration).fleetGetVehiclesGet(includeDeleted, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {SaveVehicleRequest} [saveVehicleRequest] A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fleetUpdateVehiclePut(saveVehicleRequest?: SaveVehicleRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await FleetApiAxiosParamCreator(configuration).fleetUpdateVehiclePut(saveVehicleRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * FleetApi - factory interface
 * @export
 */
export const FleetApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {InsertVehicleRequest} [insertVehicleRequest] An Insert Vehicle Request object containing values for the new Vehicle to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetCreateVehiclePost(insertVehicleRequest?: InsertVehicleRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return FleetApiFp(configuration).fleetCreateVehiclePost(insertVehicleRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a vehicle from the fleet.  Requires the \'ManageFleet\' permission.
         * @param {number} [vehicleId] The unique ID of the vehicle you wish to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetDeleteVehicleDelete(vehicleId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return FleetApiFp(configuration).fleetDeleteVehicleDelete(vehicleId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular vehicle.  Does not require any special permission.
         * @param {number} [vehicleId] The ID of the Vehicle you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetGetVehicleByIdGet(vehicleId?: number, options?: any): AxiosPromise<FleetVehicleApiResponse> {
            return FleetApiFp(configuration).fleetGetVehicleByIdGet(vehicleId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a collection of vehicles that are under your organisation.    Does not require any special permission.
         * @param {boolean} [includeDeleted] Whether or not to include deleted vehicles
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetGetVehiclesGet(includeDeleted?: boolean, options?: any): AxiosPromise<FleetVehicleListApiResponse> {
            return FleetApiFp(configuration).fleetGetVehiclesGet(includeDeleted, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a vehicle.    Requires the \'ManageFleet\' permission.
         * @param {SaveVehicleRequest} [saveVehicleRequest] A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fleetUpdateVehiclePut(saveVehicleRequest?: SaveVehicleRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return FleetApiFp(configuration).fleetUpdateVehiclePut(saveVehicleRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * FleetApi - object-oriented interface
 * @export
 * @class FleetApi
 * @extends {BaseAPI}
 */
export class FleetApi extends BaseAPI {
    /**
     * 
     * @summary Create a vehicle.    Requires the \'ManageFleet\' permission.
     * @param {InsertVehicleRequest} [insertVehicleRequest] An Insert Vehicle Request object containing values for the new Vehicle to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FleetApi
     */
    public fleetCreateVehiclePost(insertVehicleRequest?: InsertVehicleRequest, options?: any) {
        return FleetApiFp(this.configuration).fleetCreateVehiclePost(insertVehicleRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete a vehicle from the fleet.  Requires the \'ManageFleet\' permission.
     * @param {number} [vehicleId] The unique ID of the vehicle you wish to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FleetApi
     */
    public fleetDeleteVehicleDelete(vehicleId?: number, options?: any) {
        return FleetApiFp(this.configuration).fleetDeleteVehicleDelete(vehicleId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular vehicle.  Does not require any special permission.
     * @param {number} [vehicleId] The ID of the Vehicle you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FleetApi
     */
    public fleetGetVehicleByIdGet(vehicleId?: number, options?: any) {
        return FleetApiFp(this.configuration).fleetGetVehicleByIdGet(vehicleId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a collection of vehicles that are under your organisation.    Does not require any special permission.
     * @param {boolean} [includeDeleted] Whether or not to include deleted vehicles
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FleetApi
     */
    public fleetGetVehiclesGet(includeDeleted?: boolean, options?: any) {
        return FleetApiFp(this.configuration).fleetGetVehiclesGet(includeDeleted, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a vehicle.    Requires the \'ManageFleet\' permission.
     * @param {SaveVehicleRequest} [saveVehicleRequest] A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FleetApi
     */
    public fleetUpdateVehiclePut(saveVehicleRequest?: SaveVehicleRequest, options?: any) {
        return FleetApiFp(this.configuration).fleetUpdateVehiclePut(saveVehicleRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * GeoFencingApi - axios parameter creator
 * @export
 */
export const GeoFencingApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {CreateGeoFenceRequest} [createGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingCreateGeofencePost: async (createGeoFenceRequest?: CreateGeoFenceRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/CreateGeofence`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof createGeoFenceRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(createGeoFenceRequest !== undefined ? createGeoFenceRequest : {})
                : (createGeoFenceRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a geofence.  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] Specify the geofence you want to delete with the geofence ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingDeleteGeofenceDelete: async (geofenceId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/DeleteGeofence`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (geofenceId !== undefined) {
                localVarQueryParameter['GeofenceId'] = geofenceId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a geofence by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [geofenceId] The ID of the geofence you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofenceByIdGet: async (geofenceId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/GetGeofenceById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (geofenceId !== undefined) {
                localVarQueryParameter['GeofenceId'] = geofenceId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Gets a list of all geofences in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofencesBasicInfoGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/GetGeofencesBasicInfo`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get geofences belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofencesGet: async (skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/GetGeofences`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {UpdateGeoFenceRequest} [updateGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingUpdateGeofencePut: async (updateGeoFenceRequest?: UpdateGeoFenceRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/GeoFencing/UpdateGeofence`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateGeoFenceRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateGeoFenceRequest !== undefined ? updateGeoFenceRequest : {})
                : (updateGeoFenceRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * GeoFencingApi - functional programming interface
 * @export
 */
export const GeoFencingApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {CreateGeoFenceRequest} [createGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingCreateGeofencePost(createGeoFenceRequest?: CreateGeoFenceRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingCreateGeofencePost(createGeoFenceRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Deletes a geofence.  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] Specify the geofence you want to delete with the geofence ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingDeleteGeofenceDelete(geofenceId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeofenceApiResponse>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingDeleteGeofenceDelete(geofenceId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a geofence by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [geofenceId] The ID of the geofence you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingGetGeofenceByIdGet(geofenceId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GeofenceApiResponse>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingGetGeofenceByIdGet(geofenceId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Gets a list of all geofences in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingGetGeofencesBasicInfoGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BasicGeofenceListApiResponseForPaginated>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingGetGeofencesBasicInfoGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get geofences belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingGetGeofencesGet(skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ExtendedGeofenceListApiResponseForPaginated>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingGetGeofencesGet(skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Updates a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {UpdateGeoFenceRequest} [updateGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async geoFencingUpdateGeofencePut(updateGeoFenceRequest?: UpdateGeoFenceRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await GeoFencingApiAxiosParamCreator(configuration).geoFencingUpdateGeofencePut(updateGeoFenceRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * GeoFencingApi - factory interface
 * @export
 */
export const GeoFencingApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {CreateGeoFenceRequest} [createGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingCreateGeofencePost(createGeoFenceRequest?: CreateGeoFenceRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return GeoFencingApiFp(configuration).geoFencingCreateGeofencePost(createGeoFenceRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a geofence.  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] Specify the geofence you want to delete with the geofence ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingDeleteGeofenceDelete(geofenceId?: number, options?: any): AxiosPromise<GeofenceApiResponse> {
            return GeoFencingApiFp(configuration).geoFencingDeleteGeofenceDelete(geofenceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a geofence by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [geofenceId] The ID of the geofence you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofenceByIdGet(geofenceId?: number, options?: any): AxiosPromise<GeofenceApiResponse> {
            return GeoFencingApiFp(configuration).geoFencingGetGeofenceByIdGet(geofenceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Gets a list of all geofences in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofencesBasicInfoGet(options?: any): AxiosPromise<BasicGeofenceListApiResponseForPaginated> {
            return GeoFencingApiFp(configuration).geoFencingGetGeofencesBasicInfoGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get geofences belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingGetGeofencesGet(skip?: number, take?: number, options?: any): AxiosPromise<ExtendedGeofenceListApiResponseForPaginated> {
            return GeoFencingApiFp(configuration).geoFencingGetGeofencesGet(skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
         * @param {UpdateGeoFenceRequest} [updateGeoFenceRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoFencingUpdateGeofencePut(updateGeoFenceRequest?: UpdateGeoFenceRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return GeoFencingApiFp(configuration).geoFencingUpdateGeofencePut(updateGeoFenceRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * GeoFencingApi - object-oriented interface
 * @export
 * @class GeoFencingApi
 * @extends {BaseAPI}
 */
export class GeoFencingApi extends BaseAPI {
    /**
     * 
     * @summary Create a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
     * @param {CreateGeoFenceRequest} [createGeoFenceRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingCreateGeofencePost(createGeoFenceRequest?: CreateGeoFenceRequest, options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingCreateGeofencePost(createGeoFenceRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a geofence.  Requires the \'ManageGeofencing\' permission.
     * @param {number} [geofenceId] Specify the geofence you want to delete with the geofence ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingDeleteGeofenceDelete(geofenceId?: number, options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingDeleteGeofenceDelete(geofenceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a geofence by ID  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [geofenceId] The ID of the geofence you want to obtain
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingGetGeofenceByIdGet(geofenceId?: number, options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingGetGeofenceByIdGet(geofenceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Gets a list of all geofences in your organisation, including just the name and ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingGetGeofencesBasicInfoGet(options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingGetGeofencesBasicInfoGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get geofences belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [skip] Number of records to skip
     * @param {number} [take] Number of records to take
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingGetGeofencesGet(skip?: number, take?: number, options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingGetGeofencesGet(skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a geofencing with rules to be used for clock on/off automation.  Requires the \'ManageGeofencing\' permission.
     * @param {UpdateGeoFenceRequest} [updateGeoFenceRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GeoFencingApi
     */
    public geoFencingUpdateGeofencePut(updateGeoFenceRequest?: UpdateGeoFenceRequest, options?: any) {
        return GeoFencingApiFp(this.configuration).geoFencingUpdateGeofencePut(updateGeoFenceRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * JobCodesApi - axios parameter creator
 * @export
 */
export const JobCodesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertJobCodeRequest} [insertJobCodeRequest] An Insert JobCode Request object containing values for the new JobCode to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesCreateJobCodePost: async (insertJobCodeRequest?: InsertJobCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/JobCodes/CreateJobCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertJobCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertJobCodeRequest !== undefined ? insertJobCodeRequest : {})
                : (insertJobCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [jobCodeId] The ID of the job code you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesDeleteJobCodeDelete: async (jobCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/JobCodes/DeleteJobCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (jobCodeId !== undefined) {
                localVarQueryParameter['JobCodeId'] = jobCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular job code by job code id.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {number} [jobCodeId] The ID of the JobCode you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesGetJobCodeByIdGet: async (jobCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/JobCodes/GetJobCodeById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (jobCodeId !== undefined) {
                localVarQueryParameter['JobCodeId'] = jobCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get job codes for your organisation.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesGetJobCodesGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/JobCodes/GetJobCodes`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateJobCodeRequest} [updateJobCodeRequest] A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesUpdateJobCodePut: async (updateJobCodeRequest?: UpdateJobCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/JobCodes/UpdateJobCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateJobCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateJobCodeRequest !== undefined ? updateJobCodeRequest : {})
                : (updateJobCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * JobCodesApi - functional programming interface
 * @export
 */
export const JobCodesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertJobCodeRequest} [insertJobCodeRequest] An Insert JobCode Request object containing values for the new JobCode to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async jobCodesCreateJobCodePost(insertJobCodeRequest?: InsertJobCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await JobCodesApiAxiosParamCreator(configuration).jobCodesCreateJobCodePost(insertJobCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [jobCodeId] The ID of the job code you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async jobCodesDeleteJobCodeDelete(jobCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await JobCodesApiAxiosParamCreator(configuration).jobCodesDeleteJobCodeDelete(jobCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular job code by job code id.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {number} [jobCodeId] The ID of the JobCode you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async jobCodesGetJobCodeByIdGet(jobCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<JobCodeApiResponse>> {
            const localVarAxiosArgs = await JobCodesApiAxiosParamCreator(configuration).jobCodesGetJobCodeByIdGet(jobCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get job codes for your organisation.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async jobCodesGetJobCodesGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<JobCodeListApiResponse>> {
            const localVarAxiosArgs = await JobCodesApiAxiosParamCreator(configuration).jobCodesGetJobCodesGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateJobCodeRequest} [updateJobCodeRequest] A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async jobCodesUpdateJobCodePut(updateJobCodeRequest?: UpdateJobCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await JobCodesApiAxiosParamCreator(configuration).jobCodesUpdateJobCodePut(updateJobCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * JobCodesApi - factory interface
 * @export
 */
export const JobCodesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertJobCodeRequest} [insertJobCodeRequest] An Insert JobCode Request object containing values for the new JobCode to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesCreateJobCodePost(insertJobCodeRequest?: InsertJobCodeRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return JobCodesApiFp(configuration).jobCodesCreateJobCodePost(insertJobCodeRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [jobCodeId] The ID of the job code you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesDeleteJobCodeDelete(jobCodeId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return JobCodesApiFp(configuration).jobCodesDeleteJobCodeDelete(jobCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular job code by job code id.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {number} [jobCodeId] The ID of the JobCode you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesGetJobCodeByIdGet(jobCodeId?: number, options?: any): AxiosPromise<JobCodeApiResponse> {
            return JobCodesApiFp(configuration).jobCodesGetJobCodeByIdGet(jobCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get job codes for your organisation.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesGetJobCodesGet(options?: any): AxiosPromise<JobCodeListApiResponse> {
            return JobCodesApiFp(configuration).jobCodesGetJobCodesGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a job code.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateJobCodeRequest} [updateJobCodeRequest] A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        jobCodesUpdateJobCodePut(updateJobCodeRequest?: UpdateJobCodeRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return JobCodesApiFp(configuration).jobCodesUpdateJobCodePut(updateJobCodeRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * JobCodesApi - object-oriented interface
 * @export
 * @class JobCodesApi
 * @extends {BaseAPI}
 */
export class JobCodesApi extends BaseAPI {
    /**
     * 
     * @summary Create a job code.    Requires the \'ManageJobsAndTask\' permission.
     * @param {InsertJobCodeRequest} [insertJobCodeRequest] An Insert JobCode Request object containing values for the new JobCode to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof JobCodesApi
     */
    public jobCodesCreateJobCodePost(insertJobCodeRequest?: InsertJobCodeRequest, options?: any) {
        return JobCodesApiFp(this.configuration).jobCodesCreateJobCodePost(insertJobCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete a job code.    Requires the \'ManageJobsAndTask\' permission.
     * @param {number} [jobCodeId] The ID of the job code you want to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof JobCodesApi
     */
    public jobCodesDeleteJobCodeDelete(jobCodeId?: number, options?: any) {
        return JobCodesApiFp(this.configuration).jobCodesDeleteJobCodeDelete(jobCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular job code by job code id.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
     * @param {number} [jobCodeId] The ID of the JobCode you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof JobCodesApi
     */
    public jobCodesGetJobCodeByIdGet(jobCodeId?: number, options?: any) {
        return JobCodesApiFp(this.configuration).jobCodesGetJobCodeByIdGet(jobCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get job codes for your organisation.    Requires \'SubmitTimesheets\' or \'ManageJobsAndTasks\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof JobCodesApi
     */
    public jobCodesGetJobCodesGet(options?: any) {
        return JobCodesApiFp(this.configuration).jobCodesGetJobCodesGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a job code.    Requires the \'ManageJobsAndTask\' permission.
     * @param {UpdateJobCodeRequest} [updateJobCodeRequest] A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof JobCodesApi
     */
    public jobCodesUpdateJobCodePut(updateJobCodeRequest?: UpdateJobCodeRequest, options?: any) {
        return JobCodesApiFp(this.configuration).jobCodesUpdateJobCodePut(updateJobCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * NFCCodesApi - axios parameter creator
 * @export
 */
export const NFCCodesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a NFC codes with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {CreateNFCCodeRequest} [createNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesCreateNFCCodePost: async (createNFCCodeRequest?: CreateNFCCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/CreateNFCCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof createNFCCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(createNFCCodeRequest !== undefined ? createNFCCodeRequest : {})
                : (createNFCCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a NFC code.  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nFCCodeId] Specify the NFC code you want to delete with the NFC code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesDeleteNFCCodeDelete: async (nFCCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/DeleteNFCCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (nFCCodeId !== undefined) {
                localVarQueryParameter['NFCCodeId'] = nFCCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a NFC code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [nFCCodeId] The ID of the NFC code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodeByIdGet: async (nFCCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/GetNFCCodeById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (nFCCodeId !== undefined) {
                localVarQueryParameter['NFCCodeId'] = nFCCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Gets a list of all NFC codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodesBasicInfoGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/GetNFCCodesBasicInfo`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get NFC codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodesGet: async (skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/GetNFCCodes`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a NFC code with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {UpdateNFCCodeRequest} [updateNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesUpdateNFCCodePut: async (updateNFCCodeRequest?: UpdateNFCCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/NFCCodes/UpdateNFCCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateNFCCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateNFCCodeRequest !== undefined ? updateNFCCodeRequest : {})
                : (updateNFCCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * NFCCodesApi - functional programming interface
 * @export
 */
export const NFCCodesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a NFC codes with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {CreateNFCCodeRequest} [createNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesCreateNFCCodePost(createNFCCodeRequest?: CreateNFCCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesCreateNFCCodePost(createNFCCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Deletes a NFC code.  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nFCCodeId] Specify the NFC code you want to delete with the NFC code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesDeleteNFCCodeDelete(nFCCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<NFCCodeApiResponse>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesDeleteNFCCodeDelete(nFCCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a NFC code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [nFCCodeId] The ID of the NFC code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesGetNFCCodeByIdGet(nFCCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<NFCCodeApiResponse>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesGetNFCCodeByIdGet(nFCCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Gets a list of all NFC codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesGetNFCCodesBasicInfoGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BasicNFCCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesGetNFCCodesBasicInfoGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get NFC codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesGetNFCCodesGet(skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ExtendedNFCCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesGetNFCCodesGet(skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Updates a NFC code with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {UpdateNFCCodeRequest} [updateNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async nFCCodesUpdateNFCCodePut(updateNFCCodeRequest?: UpdateNFCCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await NFCCodesApiAxiosParamCreator(configuration).nFCCodesUpdateNFCCodePut(updateNFCCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * NFCCodesApi - factory interface
 * @export
 */
export const NFCCodesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a NFC codes with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {CreateNFCCodeRequest} [createNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesCreateNFCCodePost(createNFCCodeRequest?: CreateNFCCodeRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return NFCCodesApiFp(configuration).nFCCodesCreateNFCCodePost(createNFCCodeRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a NFC code.  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nFCCodeId] Specify the NFC code you want to delete with the NFC code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesDeleteNFCCodeDelete(nFCCodeId?: number, options?: any): AxiosPromise<NFCCodeApiResponse> {
            return NFCCodesApiFp(configuration).nFCCodesDeleteNFCCodeDelete(nFCCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a NFC code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [nFCCodeId] The ID of the NFC code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodeByIdGet(nFCCodeId?: number, options?: any): AxiosPromise<NFCCodeApiResponse> {
            return NFCCodesApiFp(configuration).nFCCodesGetNFCCodeByIdGet(nFCCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Gets a list of all NFC codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodesBasicInfoGet(options?: any): AxiosPromise<BasicNFCCodeListApiResponseForPaginated> {
            return NFCCodesApiFp(configuration).nFCCodesGetNFCCodesBasicInfoGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get NFC codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesGetNFCCodesGet(skip?: number, take?: number, options?: any): AxiosPromise<ExtendedNFCCodeListApiResponseForPaginated> {
            return NFCCodesApiFp(configuration).nFCCodesGetNFCCodesGet(skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a NFC code with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
         * @param {UpdateNFCCodeRequest} [updateNFCCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        nFCCodesUpdateNFCCodePut(updateNFCCodeRequest?: UpdateNFCCodeRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return NFCCodesApiFp(configuration).nFCCodesUpdateNFCCodePut(updateNFCCodeRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * NFCCodesApi - object-oriented interface
 * @export
 * @class NFCCodesApi
 * @extends {BaseAPI}
 */
export class NFCCodesApi extends BaseAPI {
    /**
     * 
     * @summary Create a NFC codes with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
     * @param {CreateNFCCodeRequest} [createNFCCodeRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesCreateNFCCodePost(createNFCCodeRequest?: CreateNFCCodeRequest, options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesCreateNFCCodePost(createNFCCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a NFC code.  Requires the \'ManageNFCCodes\' permission.
     * @param {number} [nFCCodeId] Specify the NFC code you want to delete with the NFC code ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesDeleteNFCCodeDelete(nFCCodeId?: number, options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesDeleteNFCCodeDelete(nFCCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a NFC code by ID  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [nFCCodeId] The ID of the NFC code you want to obtain
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesGetNFCCodeByIdGet(nFCCodeId?: number, options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesGetNFCCodeByIdGet(nFCCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Gets a list of all NFC codes in your organisation, including just the name and ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesGetNFCCodesBasicInfoGet(options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesGetNFCCodesBasicInfoGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get NFC codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [skip] Number of records to skip
     * @param {number} [take] Number of records to take
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesGetNFCCodesGet(skip?: number, take?: number, options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesGetNFCCodesGet(skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a NFC code with rules to be used for clock on/off automation.  Requires the \'ManageNFCCodes\' permission.
     * @param {UpdateNFCCodeRequest} [updateNFCCodeRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NFCCodesApi
     */
    public nFCCodesUpdateNFCCodePut(updateNFCCodeRequest?: UpdateNFCCodeRequest, options?: any) {
        return NFCCodesApiFp(this.configuration).nFCCodesUpdateNFCCodePut(updateNFCCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * OrganisationApi - axios parameter creator
 * @export
 */
export const OrganisationApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Gets the setting for your organisation for editing timesheets outside of current work day.    Requires \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGetEditTimesheetsOutsideTodayGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organisation/GetEditTimesheetsOutsideToday`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get your organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGetOrganisationGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organisation/GetOrganisation`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update an organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {UpdateOrganisationRequest} [updateOrganisationRequest] An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationUpdateOrganisationPut: async (updateOrganisationRequest?: UpdateOrganisationRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organisation/UpdateOrganisation`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateOrganisationRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateOrganisationRequest !== undefined ? updateOrganisationRequest : {})
                : (updateOrganisationRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OrganisationApi - functional programming interface
 * @export
 */
export const OrganisationApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Gets the setting for your organisation for editing timesheets outside of current work day.    Requires \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGetEditTimesheetsOutsideTodayGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await OrganisationApiAxiosParamCreator(configuration).organisationGetEditTimesheetsOutsideTodayGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get your organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGetOrganisationGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrganisationApiResponse>> {
            const localVarAxiosArgs = await OrganisationApiAxiosParamCreator(configuration).organisationGetOrganisationGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update an organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {UpdateOrganisationRequest} [updateOrganisationRequest] An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationUpdateOrganisationPut(updateOrganisationRequest?: UpdateOrganisationRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UpdateOrganisationResponseApiResponse>> {
            const localVarAxiosArgs = await OrganisationApiAxiosParamCreator(configuration).organisationUpdateOrganisationPut(updateOrganisationRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * OrganisationApi - factory interface
 * @export
 */
export const OrganisationApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Gets the setting for your organisation for editing timesheets outside of current work day.    Requires \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGetEditTimesheetsOutsideTodayGet(options?: any): AxiosPromise<BooleanApiResponse> {
            return OrganisationApiFp(configuration).organisationGetEditTimesheetsOutsideTodayGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get your organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGetOrganisationGet(options?: any): AxiosPromise<OrganisationApiResponse> {
            return OrganisationApiFp(configuration).organisationGetOrganisationGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update an organisation.    Requires \'OrganisationAdmin\' permission.
         * @param {UpdateOrganisationRequest} [updateOrganisationRequest] An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationUpdateOrganisationPut(updateOrganisationRequest?: UpdateOrganisationRequest, options?: any): AxiosPromise<UpdateOrganisationResponseApiResponse> {
            return OrganisationApiFp(configuration).organisationUpdateOrganisationPut(updateOrganisationRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * OrganisationApi - object-oriented interface
 * @export
 * @class OrganisationApi
 * @extends {BaseAPI}
 */
export class OrganisationApi extends BaseAPI {
    /**
     * 
     * @summary Gets the setting for your organisation for editing timesheets outside of current work day.    Requires \'SubmitTimesheets\' permission.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationApi
     */
    public organisationGetEditTimesheetsOutsideTodayGet(options?: any) {
        return OrganisationApiFp(this.configuration).organisationGetEditTimesheetsOutsideTodayGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get your organisation.    Requires \'OrganisationAdmin\' permission.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationApi
     */
    public organisationGetOrganisationGet(options?: any) {
        return OrganisationApiFp(this.configuration).organisationGetOrganisationGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update an organisation.    Requires \'OrganisationAdmin\' permission.
     * @param {UpdateOrganisationRequest} [updateOrganisationRequest] An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationApi
     */
    public organisationUpdateOrganisationPut(updateOrganisationRequest?: UpdateOrganisationRequest, options?: any) {
        return OrganisationApiFp(this.configuration).organisationUpdateOrganisationPut(updateOrganisationRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * OrganisationGroupUsersApi - axios parameter creator
 * @export
 */
export const OrganisationGroupUsersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get a collection of organisation group users that belong to an organisation group.    Requires the \'ManageOrganisationGroups\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [orgGroupId] An OrganisationGroup Id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupUsersGetOrganisationGroupUsersGet: async (orgGroupId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroupUsers/GetOrganisationGroupUsers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (orgGroupId !== undefined) {
                localVarQueryParameter['orgGroupId'] = orgGroupId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Set the users who belong to an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SetOrganisationGroupUsersRequest} [setOrganisationGroupUsersRequest] A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupUsersUpdateOrganisationGroupUsersPut: async (setOrganisationGroupUsersRequest?: SetOrganisationGroupUsersRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroupUsers/UpdateOrganisationGroupUsers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof setOrganisationGroupUsersRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(setOrganisationGroupUsersRequest !== undefined ? setOrganisationGroupUsersRequest : {})
                : (setOrganisationGroupUsersRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OrganisationGroupUsersApi - functional programming interface
 * @export
 */
export const OrganisationGroupUsersApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get a collection of organisation group users that belong to an organisation group.    Requires the \'ManageOrganisationGroups\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [orgGroupId] An OrganisationGroup Id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserForManagementListApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupUsersApiAxiosParamCreator(configuration).organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Set the users who belong to an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SetOrganisationGroupUsersRequest} [setOrganisationGroupUsersRequest] A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest?: SetOrganisationGroupUsersRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupUsersApiAxiosParamCreator(configuration).organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * OrganisationGroupUsersApi - factory interface
 * @export
 */
export const OrganisationGroupUsersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get a collection of organisation group users that belong to an organisation group.    Requires the \'ManageOrganisationGroups\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [orgGroupId] An OrganisationGroup Id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId?: number, options?: any): AxiosPromise<UserForManagementListApiResponse> {
            return OrganisationGroupUsersApiFp(configuration).organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Set the users who belong to an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SetOrganisationGroupUsersRequest} [setOrganisationGroupUsersRequest] A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest?: SetOrganisationGroupUsersRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return OrganisationGroupUsersApiFp(configuration).organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * OrganisationGroupUsersApi - object-oriented interface
 * @export
 * @class OrganisationGroupUsersApi
 * @extends {BaseAPI}
 */
export class OrganisationGroupUsersApi extends BaseAPI {
    /**
     * 
     * @summary Get a collection of organisation group users that belong to an organisation group.    Requires the \'ManageOrganisationGroups\' or \'ManageOrganisationUsers\' permissions.
     * @param {number} [orgGroupId] An OrganisationGroup Id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupUsersApi
     */
    public organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId?: number, options?: any) {
        return OrganisationGroupUsersApiFp(this.configuration).organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Set the users who belong to an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
     * @param {SetOrganisationGroupUsersRequest} [setOrganisationGroupUsersRequest] A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupUsersApi
     */
    public organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest?: SetOrganisationGroupUsersRequest, options?: any) {
        return OrganisationGroupUsersApiFp(this.configuration).organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * OrganisationGroupsApi - axios parameter creator
 * @export
 */
export const OrganisationGroupsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {InsertOrganisationGroupRequest} [insertOrganisationGroupRequest] An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsCreateOrganisationGroupPost: async (insertOrganisationGroupRequest?: InsertOrganisationGroupRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/CreateOrganisationGroup`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertOrganisationGroupRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertOrganisationGroupRequest !== undefined ? insertOrganisationGroupRequest : {})
                : (insertOrganisationGroupRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} [organisationGroupId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsDeleteOrganisationGroupDelete: async (organisationGroupId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/DeleteOrganisationGroup`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (organisationGroupId !== undefined) {
                localVarQueryParameter['OrganisationGroupId'] = organisationGroupId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular organisation group.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [organisationGroupId] The ID of the OrganisationGroup you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupGet: async (organisationGroupId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/GetOrganisationGroup`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (organisationGroupId !== undefined) {
                localVarQueryParameter['OrganisationGroupId'] = organisationGroupId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get org groups for a particular job.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsForJobGet: async (jobId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/GetOrganisationGroupsForJob`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (jobId !== undefined) {
                localVarQueryParameter['JobId'] = jobId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get org groups for a particular vehicle.    Requires the \'ManageOrganisationGroups\', \'ManageFleet\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [vehicleId] The ID of the vehicle
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsForVehicleGet: async (vehicleId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/GetOrganisationGroupsForVehicle`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (vehicleId !== undefined) {
                localVarQueryParameter['VehicleId'] = vehicleId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a collection of organisation groups that are under your organisation.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/GetOrganisationGroups`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SaveOrganisationGroupRequest} [saveOrganisationGroupRequest] A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsUpdateOrganisationGroupPut: async (saveOrganisationGroupRequest?: SaveOrganisationGroupRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/OrganisationGroups/UpdateOrganisationGroup`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof saveOrganisationGroupRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(saveOrganisationGroupRequest !== undefined ? saveOrganisationGroupRequest : {})
                : (saveOrganisationGroupRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OrganisationGroupsApi - functional programming interface
 * @export
 */
export const OrganisationGroupsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {InsertOrganisationGroupRequest} [insertOrganisationGroupRequest] An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest?: InsertOrganisationGroupRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @param {number} [organisationGroupId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular organisation group.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [organisationGroupId] The ID of the OrganisationGroup you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsGetOrganisationGroupGet(organisationGroupId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrganisationGroupApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsGetOrganisationGroupGet(organisationGroupId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get org groups for a particular job.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsGetOrganisationGroupsForJobGet(jobId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrganisationGroupListApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsGetOrganisationGroupsForJobGet(jobId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get org groups for a particular vehicle.    Requires the \'ManageOrganisationGroups\', \'ManageFleet\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [vehicleId] The ID of the vehicle
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrganisationGroupListApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a collection of organisation groups that are under your organisation.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsGetOrganisationGroupsGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrganisationGroupListApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsGetOrganisationGroupsGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SaveOrganisationGroupRequest} [saveOrganisationGroupRequest] A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest?: SaveOrganisationGroupRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await OrganisationGroupsApiAxiosParamCreator(configuration).organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * OrganisationGroupsApi - factory interface
 * @export
 */
export const OrganisationGroupsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {InsertOrganisationGroupRequest} [insertOrganisationGroupRequest] An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest?: InsertOrganisationGroupRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {number} [organisationGroupId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular organisation group.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [organisationGroupId] The ID of the OrganisationGroup you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupGet(organisationGroupId?: number, options?: any): AxiosPromise<OrganisationGroupApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsGetOrganisationGroupGet(organisationGroupId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get org groups for a particular job.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsForJobGet(jobId?: number, options?: any): AxiosPromise<OrganisationGroupListApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsGetOrganisationGroupsForJobGet(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get org groups for a particular vehicle.    Requires the \'ManageOrganisationGroups\', \'ManageFleet\' or \'ManageOrganisationUsers\' permissions.
         * @param {number} [vehicleId] The ID of the vehicle
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId?: number, options?: any): AxiosPromise<OrganisationGroupListApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a collection of organisation groups that are under your organisation.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsGetOrganisationGroupsGet(options?: any): AxiosPromise<OrganisationGroupListApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsGetOrganisationGroupsGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
         * @param {SaveOrganisationGroupRequest} [saveOrganisationGroupRequest] A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest?: SaveOrganisationGroupRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return OrganisationGroupsApiFp(configuration).organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * OrganisationGroupsApi - object-oriented interface
 * @export
 * @class OrganisationGroupsApi
 * @extends {BaseAPI}
 */
export class OrganisationGroupsApi extends BaseAPI {
    /**
     * 
     * @summary Create an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
     * @param {InsertOrganisationGroupRequest} [insertOrganisationGroupRequest] An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest?: InsertOrganisationGroupRequest, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {number} [organisationGroupId] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId?: number, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular organisation group.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
     * @param {number} [organisationGroupId] The ID of the OrganisationGroup you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsGetOrganisationGroupGet(organisationGroupId?: number, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsGetOrganisationGroupGet(organisationGroupId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get org groups for a particular job.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
     * @param {number} [jobId] The ID of the job
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsGetOrganisationGroupsForJobGet(jobId?: number, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsGetOrganisationGroupsForJobGet(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get org groups for a particular vehicle.    Requires the \'ManageOrganisationGroups\', \'ManageFleet\' or \'ManageOrganisationUsers\' permissions.
     * @param {number} [vehicleId] The ID of the vehicle
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId?: number, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a collection of organisation groups that are under your organisation.    Requires the \'ManageOrganisationGroups\', \'ManageJobsAndTask\', \'ManageClientsAndProjects\' or \'ManageOrganisationUsers\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsGetOrganisationGroupsGet(options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsGetOrganisationGroupsGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update an organisation group.    Requires the \'ManageOrganisationGroups\' permissions.
     * @param {SaveOrganisationGroupRequest} [saveOrganisationGroupRequest] A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganisationGroupsApi
     */
    public organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest?: SaveOrganisationGroupRequest, options?: any) {
        return OrganisationGroupsApiFp(this.configuration).organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * ProjectsApi - axios parameter creator
 * @export
 */
export const ProjectsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertProjectRequest} [insertProjectRequest] An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsCreateProjectPost: async (insertProjectRequest?: InsertProjectRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Projects/CreateProject`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertProjectRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertProjectRequest !== undefined ? insertProjectRequest : {})
                : (insertProjectRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a project by its Id.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [projectId] The ID of the Project you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsGetProjectByIdGet: async (projectId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Projects/GetProjectById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (projectId !== undefined) {
                localVarQueryParameter['ProjectId'] = projectId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get projects for a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the client
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsGetProjectsForClientGet: async (clientId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Projects/GetProjectsForClient`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (clientId !== undefined) {
                localVarQueryParameter['ClientId'] = clientId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {UpdateProjectRequest} [updateProjectRequest] An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsUpdateProjectPut: async (updateProjectRequest?: UpdateProjectRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Projects/UpdateProject`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateProjectRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateProjectRequest !== undefined ? updateProjectRequest : {})
                : (updateProjectRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectsApi - functional programming interface
 * @export
 */
export const ProjectsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertProjectRequest} [insertProjectRequest] An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async projectsCreateProjectPost(insertProjectRequest?: InsertProjectRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await ProjectsApiAxiosParamCreator(configuration).projectsCreateProjectPost(insertProjectRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a project by its Id.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [projectId] The ID of the Project you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async projectsGetProjectByIdGet(projectId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectApiResponse>> {
            const localVarAxiosArgs = await ProjectsApiAxiosParamCreator(configuration).projectsGetProjectByIdGet(projectId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get projects for a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the client
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async projectsGetProjectsForClientGet(clientId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectListApiResponse>> {
            const localVarAxiosArgs = await ProjectsApiAxiosParamCreator(configuration).projectsGetProjectsForClientGet(clientId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {UpdateProjectRequest} [updateProjectRequest] An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async projectsUpdateProjectPut(updateProjectRequest?: UpdateProjectRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await ProjectsApiAxiosParamCreator(configuration).projectsUpdateProjectPut(updateProjectRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * ProjectsApi - factory interface
 * @export
 */
export const ProjectsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {InsertProjectRequest} [insertProjectRequest] An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsCreateProjectPost(insertProjectRequest?: InsertProjectRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return ProjectsApiFp(configuration).projectsCreateProjectPost(insertProjectRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a project by its Id.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [projectId] The ID of the Project you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsGetProjectByIdGet(projectId?: number, options?: any): AxiosPromise<ProjectApiResponse> {
            return ProjectsApiFp(configuration).projectsGetProjectByIdGet(projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get projects for a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [clientId] The ID of the client
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsGetProjectsForClientGet(clientId?: number, options?: any): AxiosPromise<ProjectListApiResponse> {
            return ProjectsApiFp(configuration).projectsGetProjectsForClientGet(clientId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a project.    Requires the \'ManageClientsAndProjects\' permission.
         * @param {UpdateProjectRequest} [updateProjectRequest] An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        projectsUpdateProjectPut(updateProjectRequest?: UpdateProjectRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return ProjectsApiFp(configuration).projectsUpdateProjectPut(updateProjectRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ProjectsApi - object-oriented interface
 * @export
 * @class ProjectsApi
 * @extends {BaseAPI}
 */
export class ProjectsApi extends BaseAPI {
    /**
     * 
     * @summary Create a project.    Requires the \'ManageClientsAndProjects\' permission.
     * @param {InsertProjectRequest} [insertProjectRequest] An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectsApi
     */
    public projectsCreateProjectPost(insertProjectRequest?: InsertProjectRequest, options?: any) {
        return ProjectsApiFp(this.configuration).projectsCreateProjectPost(insertProjectRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a project by its Id.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
     * @param {number} [projectId] The ID of the Project you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectsApi
     */
    public projectsGetProjectByIdGet(projectId?: number, options?: any) {
        return ProjectsApiFp(this.configuration).projectsGetProjectByIdGet(projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get projects for a particular client.    Requires the \'ManageClientsAndProjects\' or \'ManageJobsAndTask\' permissions.
     * @param {number} [clientId] The ID of the client
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectsApi
     */
    public projectsGetProjectsForClientGet(clientId?: number, options?: any) {
        return ProjectsApiFp(this.configuration).projectsGetProjectsForClientGet(clientId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a project.    Requires the \'ManageClientsAndProjects\' permission.
     * @param {UpdateProjectRequest} [updateProjectRequest] An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectsApi
     */
    public projectsUpdateProjectPut(updateProjectRequest?: UpdateProjectRequest, options?: any) {
        return ProjectsApiFp(this.configuration).projectsUpdateProjectPut(updateProjectRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * QRCodesApi - axios parameter creator
 * @export
 */
export const QRCodesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a QR codes with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {CreateQRCodeRequest} [createQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesCreateQRCodePost: async (createQRCodeRequest?: CreateQRCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/CreateQRCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof createQRCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(createQRCodeRequest !== undefined ? createQRCodeRequest : {})
                : (createQRCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a QR code.  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] Specify the QR code you want to delete with the QR code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesDeleteQRCodeDelete: async (qRCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/DeleteQRCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (qRCodeId !== undefined) {
                localVarQueryParameter['QRCodeId'] = qRCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a QR code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [qRCodeId] The ID of the QR code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodeByIdGet: async (qRCodeId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/GetQRCodeById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (qRCodeId !== undefined) {
                localVarQueryParameter['QRCodeId'] = qRCodeId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Gets a list of all QR codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodesBasicInfoGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/GetQRCodesBasicInfo`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get QR codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodesGet: async (skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/GetQRCodes`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a QR code with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {UpdateQRCodeRequest} [updateQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesUpdateQRCodePut: async (updateQRCodeRequest?: UpdateQRCodeRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/QRCodes/UpdateQRCode`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateQRCodeRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateQRCodeRequest !== undefined ? updateQRCodeRequest : {})
                : (updateQRCodeRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * QRCodesApi - functional programming interface
 * @export
 */
export const QRCodesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a QR codes with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {CreateQRCodeRequest} [createQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesCreateQRCodePost(createQRCodeRequest?: CreateQRCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesCreateQRCodePost(createQRCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Deletes a QR code.  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] Specify the QR code you want to delete with the QR code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesDeleteQRCodeDelete(qRCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<QRCodeApiResponse>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesDeleteQRCodeDelete(qRCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a QR code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [qRCodeId] The ID of the QR code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesGetQRCodeByIdGet(qRCodeId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<QRCodeApiResponse>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesGetQRCodeByIdGet(qRCodeId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Gets a list of all QR codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesGetQRCodesBasicInfoGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BasicQRCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesGetQRCodesBasicInfoGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get QR codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesGetQRCodesGet(skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ExtendedQRCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesGetQRCodesGet(skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Updates a QR code with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {UpdateQRCodeRequest} [updateQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async qRCodesUpdateQRCodePut(updateQRCodeRequest?: UpdateQRCodeRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await QRCodesApiAxiosParamCreator(configuration).qRCodesUpdateQRCodePut(updateQRCodeRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * QRCodesApi - factory interface
 * @export
 */
export const QRCodesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a QR codes with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {CreateQRCodeRequest} [createQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesCreateQRCodePost(createQRCodeRequest?: CreateQRCodeRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return QRCodesApiFp(configuration).qRCodesCreateQRCodePost(createQRCodeRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a QR code.  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] Specify the QR code you want to delete with the QR code ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesDeleteQRCodeDelete(qRCodeId?: number, options?: any): AxiosPromise<QRCodeApiResponse> {
            return QRCodesApiFp(configuration).qRCodesDeleteQRCodeDelete(qRCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a QR code by ID  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [qRCodeId] The ID of the QR code you want to obtain
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodeByIdGet(qRCodeId?: number, options?: any): AxiosPromise<QRCodeApiResponse> {
            return QRCodesApiFp(configuration).qRCodesGetQRCodeByIdGet(qRCodeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Gets a list of all QR codes in your organisation, including just the name and ID.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodesBasicInfoGet(options?: any): AxiosPromise<BasicQRCodeListApiResponseForPaginated> {
            return QRCodesApiFp(configuration).qRCodesGetQRCodesBasicInfoGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get QR codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
         * @param {number} [skip] Number of records to skip
         * @param {number} [take] Number of records to take
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesGetQRCodesGet(skip?: number, take?: number, options?: any): AxiosPromise<ExtendedQRCodeListApiResponseForPaginated> {
            return QRCodesApiFp(configuration).qRCodesGetQRCodesGet(skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a QR code with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
         * @param {UpdateQRCodeRequest} [updateQRCodeRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        qRCodesUpdateQRCodePut(updateQRCodeRequest?: UpdateQRCodeRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return QRCodesApiFp(configuration).qRCodesUpdateQRCodePut(updateQRCodeRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * QRCodesApi - object-oriented interface
 * @export
 * @class QRCodesApi
 * @extends {BaseAPI}
 */
export class QRCodesApi extends BaseAPI {
    /**
     * 
     * @summary Create a QR codes with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
     * @param {CreateQRCodeRequest} [createQRCodeRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesCreateQRCodePost(createQRCodeRequest?: CreateQRCodeRequest, options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesCreateQRCodePost(createQRCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a QR code.  Requires the \'ManageQRCodes\' permission.
     * @param {number} [qRCodeId] Specify the QR code you want to delete with the QR code ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesDeleteQRCodeDelete(qRCodeId?: number, options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesDeleteQRCodeDelete(qRCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a QR code by ID  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [qRCodeId] The ID of the QR code you want to obtain
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesGetQRCodeByIdGet(qRCodeId?: number, options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesGetQRCodeByIdGet(qRCodeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Gets a list of all QR codes in your organisation, including just the name and ID.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesGetQRCodesBasicInfoGet(options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesGetQRCodesBasicInfoGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get QR codes belonging to your organisation  Requires the \'SubmitTimesheets\' permission.
     * @param {number} [skip] Number of records to skip
     * @param {number} [take] Number of records to take
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesGetQRCodesGet(skip?: number, take?: number, options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesGetQRCodesGet(skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a QR code with rules to be used for clock on/off automation.  Requires the \'ManageQRCodes\' permission.
     * @param {UpdateQRCodeRequest} [updateQRCodeRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QRCodesApi
     */
    public qRCodesUpdateQRCodePut(updateQRCodeRequest?: UpdateQRCodeRequest, options?: any) {
        return QRCodesApiFp(this.configuration).qRCodesUpdateQRCodePut(updateQRCodeRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * ReportsApi - axios parameter creator
 * @export
 */
export const ReportsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {ForcedReportFromAllReports} [forceOnlyThisChart] A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the \&#39;NotForced\&#39; option.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetAllChartsDataAdminGet: async (startDate?: string, endDate?: string, userIds?: string, forceOnlyThisChart?: ForcedReportFromAllReports, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetAllChartsDataAdmin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }

            if (forceOnlyThisChart !== undefined) {
                localVarQueryParameter['ForceOnlyThisChart'] = forceOnlyThisChart;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user\'s own reports.    Requires the \'ViewOwnReports\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetAllChartsDataUserGet: async (startDate?: string, endDate?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetAllChartsDataUser`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetFleetSummaryAdminGet: async (startDate?: string, endDate?: string, userIds?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetFleetSummaryAdmin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get trip by Id, for reporting purposes.    Requires the \'ReportAdmin\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrgTripByIdGet: async (tripId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetOrgTripById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (tripId !== undefined) {
                localVarQueryParameter['TripId'] = tripId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTimesheetFileAttachmentsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetOrganisationTimesheetFileAttachments`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {string} [keywords] Search the transcripts by keyword(s)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTranscriptsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, keywords?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetOrganisationTranscripts`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }

            if (keywords !== undefined) {
                localVarQueryParameter['Keywords'] = keywords;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reports on Organisation trips (GPS tracking from whole organisation).    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTripsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetOrganisationTrips`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {RawDataSortColumns} [sort] Decide which column to sort on
         * @param {SortDirection} [order] Decide which direction to sort the column
         * @param {number} [skip] Skip this many rows
         * @param {number} [take] Take this many rows
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetRawDataAdminGet: async (startDate?: string, endDate?: string, userIds?: string, sort?: RawDataSortColumns, order?: SortDirection, skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/GetRawDataAdmin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }

            if (sort !== undefined) {
                localVarQueryParameter['Sort'] = sort;
            }

            if (order !== undefined) {
                localVarQueryParameter['Order'] = order;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Gets project cost estimations VS actual cost for date range and users.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsProjectCostingsAdminGet: async (startDate?: string, endDate?: string, userIds?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/ProjectCostingsAdmin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Timeseries jobs data for the logged in user.    Requires the \'ViewOwnReports\' or \'SubmitTimesheets\'.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsUserJobsOverTimeGet: async (startDate?: string, endDate?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Reports/UserJobsOverTime`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ReportsApi - functional programming interface
 * @export
 */
export const ReportsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {ForcedReportFromAllReports} [forceOnlyThisChart] A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the \&#39;NotForced\&#39; option.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetAllChartsDataAdminGet(startDate?: string, endDate?: string, userIds?: string, forceOnlyThisChart?: ForcedReportFromAllReports, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CombinedReportsDataApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetAllChartsDataAdminGet(startDate, endDate, userIds, forceOnlyThisChart, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user\'s own reports.    Requires the \'ViewOwnReports\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetAllChartsDataUserGet(startDate?: string, endDate?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CombinedReportsDataApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetAllChartsDataUserGet(startDate, endDate, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetFleetSummaryAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FleetSummaryReportItemListApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetFleetSummaryAdminGet(startDate, endDate, userIds, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get trip by Id, for reporting purposes.    Requires the \'ReportAdmin\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetOrgTripByIdGet(tripId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TripApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetOrgTripByIdGet(tripId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetOrganisationTimesheetFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrgReportTimesheetFileAttachmentListApiResponseForPaginated>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetOrganisationTimesheetFileAttachmentsGet(startDate, endDate, skip, take, userIds, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {string} [keywords] Search the transcripts by keyword(s)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetOrganisationTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, keywords?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrgReportTranscriptListApiResponseForPaginated>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetOrganisationTranscriptsGet(startDate, endDate, skip, take, userIds, keywords, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Reports on Organisation trips (GPS tracking from whole organisation).    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetOrganisationTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrgReportTripListApiResponseForPaginated>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetOrganisationTripsGet(startDate, endDate, skip, take, userIds, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {RawDataSortColumns} [sort] Decide which column to sort on
         * @param {SortDirection} [order] Decide which direction to sort the column
         * @param {number} [skip] Skip this many rows
         * @param {number} [take] Take this many rows
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsGetRawDataAdminGet(startDate?: string, endDate?: string, userIds?: string, sort?: RawDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<RawReportItemListApiResponseForPaginated>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsGetRawDataAdminGet(startDate, endDate, userIds, sort, order, skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Gets project cost estimations VS actual cost for date range and users.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsProjectCostingsAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectCostingReportItemListApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsProjectCostingsAdminGet(startDate, endDate, userIds, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Timeseries jobs data for the logged in user.    Requires the \'ViewOwnReports\' or \'SubmitTimesheets\'.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reportsUserJobsOverTimeGet(startDate?: string, endDate?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<JobSeriesReportItemListApiResponse>> {
            const localVarAxiosArgs = await ReportsApiAxiosParamCreator(configuration).reportsUserJobsOverTimeGet(startDate, endDate, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * ReportsApi - factory interface
 * @export
 */
export const ReportsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {ForcedReportFromAllReports} [forceOnlyThisChart] A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the \&#39;NotForced\&#39; option.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetAllChartsDataAdminGet(startDate?: string, endDate?: string, userIds?: string, forceOnlyThisChart?: ForcedReportFromAllReports, options?: any): AxiosPromise<CombinedReportsDataApiResponse> {
            return ReportsApiFp(configuration).reportsGetAllChartsDataAdminGet(startDate, endDate, userIds, forceOnlyThisChart, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user\'s own reports.    Requires the \'ViewOwnReports\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetAllChartsDataUserGet(startDate?: string, endDate?: string, options?: any): AxiosPromise<CombinedReportsDataApiResponse> {
            return ReportsApiFp(configuration).reportsGetAllChartsDataUserGet(startDate, endDate, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetFleetSummaryAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any): AxiosPromise<FleetSummaryReportItemListApiResponse> {
            return ReportsApiFp(configuration).reportsGetFleetSummaryAdminGet(startDate, endDate, userIds, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get trip by Id, for reporting purposes.    Requires the \'ReportAdmin\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrgTripByIdGet(tripId?: number, options?: any): AxiosPromise<TripApiResponse> {
            return ReportsApiFp(configuration).reportsGetOrgTripByIdGet(tripId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTimesheetFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any): AxiosPromise<OrgReportTimesheetFileAttachmentListApiResponseForPaginated> {
            return ReportsApiFp(configuration).reportsGetOrganisationTimesheetFileAttachmentsGet(startDate, endDate, skip, take, userIds, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {string} [keywords] Search the transcripts by keyword(s)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, keywords?: string, options?: any): AxiosPromise<OrgReportTranscriptListApiResponseForPaginated> {
            return ReportsApiFp(configuration).reportsGetOrganisationTranscriptsGet(startDate, endDate, skip, take, userIds, keywords, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reports on Organisation trips (GPS tracking from whole organisation).    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {number} [skip] Skip this many items
         * @param {number} [take] Take this many items
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetOrganisationTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any): AxiosPromise<OrgReportTripListApiResponseForPaginated> {
            return ReportsApiFp(configuration).reportsGetOrganisationTripsGet(startDate, endDate, skip, take, userIds, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {RawDataSortColumns} [sort] Decide which column to sort on
         * @param {SortDirection} [order] Decide which direction to sort the column
         * @param {number} [skip] Skip this many rows
         * @param {number} [take] Take this many rows
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsGetRawDataAdminGet(startDate?: string, endDate?: string, userIds?: string, sort?: RawDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): AxiosPromise<RawReportItemListApiResponseForPaginated> {
            return ReportsApiFp(configuration).reportsGetRawDataAdminGet(startDate, endDate, userIds, sort, order, skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Gets project cost estimations VS actual cost for date range and users.    Requires the \'ReportAdmin\' permission.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsProjectCostingsAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any): AxiosPromise<ProjectCostingReportItemListApiResponse> {
            return ReportsApiFp(configuration).reportsProjectCostingsAdminGet(startDate, endDate, userIds, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Timeseries jobs data for the logged in user.    Requires the \'ViewOwnReports\' or \'SubmitTimesheets\'.
         * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
         * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reportsUserJobsOverTimeGet(startDate?: string, endDate?: string, options?: any): AxiosPromise<JobSeriesReportItemListApiResponse> {
            return ReportsApiFp(configuration).reportsUserJobsOverTimeGet(startDate, endDate, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ReportsApi - object-oriented interface
 * @export
 * @class ReportsApi
 * @extends {BaseAPI}
 */
export class ReportsApi extends BaseAPI {
    /**
     * 
     * @summary Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {ForcedReportFromAllReports} [forceOnlyThisChart] A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the \&#39;NotForced\&#39; option.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetAllChartsDataAdminGet(startDate?: string, endDate?: string, userIds?: string, forceOnlyThisChart?: ForcedReportFromAllReports, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetAllChartsDataAdminGet(startDate, endDate, userIds, forceOnlyThisChart, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user\'s own reports.    Requires the \'ViewOwnReports\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetAllChartsDataUserGet(startDate?: string, endDate?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetAllChartsDataUserGet(startDate, endDate, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetFleetSummaryAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetFleetSummaryAdminGet(startDate, endDate, userIds, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get trip by Id, for reporting purposes.    Requires the \'ReportAdmin\' permission.
     * @param {number} [tripId] The ID of the Trip you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetOrgTripByIdGet(tripId?: number, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetOrgTripByIdGet(tripId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {number} [skip] Skip this many items
     * @param {number} [take] Take this many items
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetOrganisationTimesheetFileAttachmentsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetOrganisationTimesheetFileAttachmentsGet(startDate, endDate, skip, take, userIds, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {number} [skip] Skip this many items
     * @param {number} [take] Take this many items
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {string} [keywords] Search the transcripts by keyword(s)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetOrganisationTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, keywords?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetOrganisationTranscriptsGet(startDate, endDate, skip, take, userIds, keywords, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reports on Organisation trips (GPS tracking from whole organisation).    Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {number} [skip] Skip this many items
     * @param {number} [take] Take this many items
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetOrganisationTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, userIds?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetOrganisationTripsGet(startDate, endDate, skip, take, userIds, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {RawDataSortColumns} [sort] Decide which column to sort on
     * @param {SortDirection} [order] Decide which direction to sort the column
     * @param {number} [skip] Skip this many rows
     * @param {number} [take] Take this many rows
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsGetRawDataAdminGet(startDate?: string, endDate?: string, userIds?: string, sort?: RawDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any) {
        return ReportsApiFp(this.configuration).reportsGetRawDataAdminGet(startDate, endDate, userIds, sort, order, skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Gets project cost estimations VS actual cost for date range and users.    Requires the \'ReportAdmin\' permission.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {string} [userIds] A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsProjectCostingsAdminGet(startDate?: string, endDate?: string, userIds?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsProjectCostingsAdminGet(startDate, endDate, userIds, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Timeseries jobs data for the logged in user.    Requires the \'ViewOwnReports\' or \'SubmitTimesheets\'.
     * @param {string} [startDate] The start date for the date range.  Report data in the response is after this date
     * @param {string} [endDate] The end date for the date range.  Report data in the response is before this date
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ReportsApi
     */
    public reportsUserJobsOverTimeGet(startDate?: string, endDate?: string, options?: any) {
        return ReportsApiFp(this.configuration).reportsUserJobsOverTimeGet(startDate, endDate, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TasksApi - axios parameter creator
 * @export
 */
export const TasksApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertTaskRequest} [insertTaskRequest] An Insert Task Request object containing values for the new Task to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksCreateTaskPost: async (insertTaskRequest?: InsertTaskRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/CreateTask`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertTaskRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertTaskRequest !== undefined ? insertTaskRequest : {})
                : (insertTaskRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [taskId] The ID of the Task you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksDeleteTaskDelete: async (taskId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/DeleteTask`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (taskId !== undefined) {
                localVarQueryParameter['TaskId'] = taskId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular task by Id.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [taskId] The ID of the TimesheetTask you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTaskByIdGet: async (taskId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/GetTaskById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (taskId !== undefined) {
                localVarQueryParameter['TaskId'] = taskId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a collection of tasks for a particular Job, specified by JobId.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTasksForJobGet: async (jobId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/GetTasksForJob`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (jobId !== undefined) {
                localVarQueryParameter['JobId'] = jobId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get tasks in your organisation.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTasksGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/GetTasks`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateTaskRequest} [updateTaskRequest] An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksUpdateTaskPut: async (updateTaskRequest?: UpdateTaskRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Tasks/UpdateTask`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateTaskRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateTaskRequest !== undefined ? updateTaskRequest : {})
                : (updateTaskRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TasksApi - functional programming interface
 * @export
 */
export const TasksApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertTaskRequest} [insertTaskRequest] An Insert Task Request object containing values for the new Task to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksCreateTaskPost(insertTaskRequest?: InsertTaskRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksCreateTaskPost(insertTaskRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [taskId] The ID of the Task you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksDeleteTaskDelete(taskId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksDeleteTaskDelete(taskId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular task by Id.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [taskId] The ID of the TimesheetTask you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksGetTaskByIdGet(taskId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetTaskApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksGetTaskByIdGet(taskId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a collection of tasks for a particular Job, specified by JobId.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksGetTasksForJobGet(jobId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetTaskListApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksGetTasksForJobGet(jobId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get tasks in your organisation.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksGetTasksGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetTaskListApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksGetTasksGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateTaskRequest} [updateTaskRequest] An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tasksUpdateTaskPut(updateTaskRequest?: UpdateTaskRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await TasksApiAxiosParamCreator(configuration).tasksUpdateTaskPut(updateTaskRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TasksApi - factory interface
 * @export
 */
export const TasksApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {InsertTaskRequest} [insertTaskRequest] An Insert Task Request object containing values for the new Task to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksCreateTaskPost(insertTaskRequest?: InsertTaskRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return TasksApiFp(configuration).tasksCreateTaskPost(insertTaskRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {number} [taskId] The ID of the Task you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksDeleteTaskDelete(taskId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return TasksApiFp(configuration).tasksDeleteTaskDelete(taskId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular task by Id.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [taskId] The ID of the TimesheetTask you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTaskByIdGet(taskId?: number, options?: any): AxiosPromise<TimesheetTaskApiResponse> {
            return TasksApiFp(configuration).tasksGetTaskByIdGet(taskId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a collection of tasks for a particular Job, specified by JobId.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {number} [jobId] The ID of the job
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTasksForJobGet(jobId?: number, options?: any): AxiosPromise<TimesheetTaskListApiResponse> {
            return TasksApiFp(configuration).tasksGetTasksForJobGet(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get tasks in your organisation.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksGetTasksGet(options?: any): AxiosPromise<TimesheetTaskListApiResponse> {
            return TasksApiFp(configuration).tasksGetTasksGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a task.    Requires the \'ManageJobsAndTask\' permission.
         * @param {UpdateTaskRequest} [updateTaskRequest] An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tasksUpdateTaskPut(updateTaskRequest?: UpdateTaskRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return TasksApiFp(configuration).tasksUpdateTaskPut(updateTaskRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TasksApi - object-oriented interface
 * @export
 * @class TasksApi
 * @extends {BaseAPI}
 */
export class TasksApi extends BaseAPI {
    /**
     * 
     * @summary Create a task.    Requires the \'ManageJobsAndTask\' permission.
     * @param {InsertTaskRequest} [insertTaskRequest] An Insert Task Request object containing values for the new Task to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksCreateTaskPost(insertTaskRequest?: InsertTaskRequest, options?: any) {
        return TasksApiFp(this.configuration).tasksCreateTaskPost(insertTaskRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete a task.    Requires the \'ManageJobsAndTask\' permission.
     * @param {number} [taskId] The ID of the Task you want to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksDeleteTaskDelete(taskId?: number, options?: any) {
        return TasksApiFp(this.configuration).tasksDeleteTaskDelete(taskId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular task by Id.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
     * @param {number} [taskId] The ID of the TimesheetTask you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksGetTaskByIdGet(taskId?: number, options?: any) {
        return TasksApiFp(this.configuration).tasksGetTaskByIdGet(taskId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a collection of tasks for a particular Job, specified by JobId.    Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
     * @param {number} [jobId] The ID of the job
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksGetTasksForJobGet(jobId?: number, options?: any) {
        return TasksApiFp(this.configuration).tasksGetTasksForJobGet(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get tasks in your organisation.   Requires the \'SubmitTimesheets\' or \'ManageJobsAndTask\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksGetTasksGet(options?: any) {
        return TasksApiFp(this.configuration).tasksGetTasksGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a task.    Requires the \'ManageJobsAndTask\' permission.
     * @param {UpdateTaskRequest} [updateTaskRequest] An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TasksApi
     */
    public tasksUpdateTaskPut(updateTaskRequest?: UpdateTaskRequest, options?: any) {
        return TasksApiFp(this.configuration).tasksUpdateTaskPut(updateTaskRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TimesheetAutomationApi - axios parameter creator
 * @export
 */
export const TimesheetAutomationApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the \'SubmitTimesheets\' permission.
         * @param {CreateAutomationStepRequest} [createAutomationStepRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationCreateAutomationStepPost: async (createAutomationStepRequest?: CreateAutomationStepRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TimesheetAutomation/CreateAutomationStep`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof createAutomationStepRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(createAutomationStepRequest !== undefined ? createAutomationStepRequest : {})
                : (createAutomationStepRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for geofences activities  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] The ID of the Geofence
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet: async (geofenceId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TimesheetAutomation/GetTimesheetAutomationGeofenceAuditTrail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (geofenceId !== undefined) {
                localVarQueryParameter['GeofenceId'] = geofenceId;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (sort !== undefined) {
                localVarQueryParameter['Sort'] = sort;
            }

            if (order !== undefined) {
                localVarQueryParameter['Order'] = order;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for NFC tag activities  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nfcTagId] The ID of the NFC tag
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet: async (nfcTagId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TimesheetAutomation/GetTimesheetAutomationNFCTagAuditTrail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (nfcTagId !== undefined) {
                localVarQueryParameter['NfcTagId'] = nfcTagId;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (sort !== undefined) {
                localVarQueryParameter['Sort'] = sort;
            }

            if (order !== undefined) {
                localVarQueryParameter['Order'] = order;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for QR Code activities  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] The ID of the QR Code
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet: async (qRCodeId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TimesheetAutomation/GetTimesheetAutomationQRCodeAuditTrail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (qRCodeId !== undefined) {
                localVarQueryParameter['QRCodeId'] = qRCodeId;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (sort !== undefined) {
                localVarQueryParameter['Sort'] = sort;
            }

            if (order !== undefined) {
                localVarQueryParameter['Order'] = order;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TimesheetAutomationApi - functional programming interface
 * @export
 */
export const TimesheetAutomationApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the \'SubmitTimesheets\' permission.
         * @param {CreateAutomationStepRequest} [createAutomationStepRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest?: CreateAutomationStepRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await TimesheetAutomationApiAxiosParamCreator(configuration).timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for geofences activities  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] The ID of the Geofence
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated>> {
            const localVarAxiosArgs = await TimesheetAutomationApiAxiosParamCreator(configuration).timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId, userId, sort, order, skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for NFC tag activities  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nfcTagId] The ID of the NFC tag
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await TimesheetAutomationApiAxiosParamCreator(configuration).timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId, userId, sort, order, skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for QR Code activities  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] The ID of the QR Code
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated>> {
            const localVarAxiosArgs = await TimesheetAutomationApiAxiosParamCreator(configuration).timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId, userId, sort, order, skip, take, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TimesheetAutomationApi - factory interface
 * @export
 */
export const TimesheetAutomationApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the \'SubmitTimesheets\' permission.
         * @param {CreateAutomationStepRequest} [createAutomationStepRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest?: CreateAutomationStepRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return TimesheetAutomationApiFp(configuration).timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for geofences activities  Requires the \'ManageGeofencing\' permission.
         * @param {number} [geofenceId] The ID of the Geofence
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): AxiosPromise<TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated> {
            return TimesheetAutomationApiFp(configuration).timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId, userId, sort, order, skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for NFC tag activities  Requires the \'ManageNFCCodes\' permission.
         * @param {number} [nfcTagId] The ID of the NFC tag
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): AxiosPromise<TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated> {
            return TimesheetAutomationApiFp(configuration).timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId, userId, sort, order, skip, take, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieve the timesheet automation / alerts for QR Code activities  Requires the \'ManageQRCodes\' permission.
         * @param {number} [qRCodeId] The ID of the QR Code
         * @param {number} [userId] The ID of the user
         * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
         * @param {SortDirection} [order] The directions to sort records by
         * @param {number} [skip] Skip this many records
         * @param {number} [take] Take this many records
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any): AxiosPromise<TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated> {
            return TimesheetAutomationApiFp(configuration).timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId, userId, sort, order, skip, take, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TimesheetAutomationApi - object-oriented interface
 * @export
 * @class TimesheetAutomationApi
 * @extends {BaseAPI}
 */
export class TimesheetAutomationApi extends BaseAPI {
    /**
     * 
     * @summary Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the \'SubmitTimesheets\' permission.
     * @param {CreateAutomationStepRequest} [createAutomationStepRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetAutomationApi
     */
    public timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest?: CreateAutomationStepRequest, options?: any) {
        return TimesheetAutomationApiFp(this.configuration).timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieve the timesheet automation / alerts for geofences activities  Requires the \'ManageGeofencing\' permission.
     * @param {number} [geofenceId] The ID of the Geofence
     * @param {number} [userId] The ID of the user
     * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
     * @param {SortDirection} [order] The directions to sort records by
     * @param {number} [skip] Skip this many records
     * @param {number} [take] Take this many records
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetAutomationApi
     */
    public timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any) {
        return TimesheetAutomationApiFp(this.configuration).timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId, userId, sort, order, skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieve the timesheet automation / alerts for NFC tag activities  Requires the \'ManageNFCCodes\' permission.
     * @param {number} [nfcTagId] The ID of the NFC tag
     * @param {number} [userId] The ID of the user
     * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
     * @param {SortDirection} [order] The directions to sort records by
     * @param {number} [skip] Skip this many records
     * @param {number} [take] Take this many records
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetAutomationApi
     */
    public timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any) {
        return TimesheetAutomationApiFp(this.configuration).timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId, userId, sort, order, skip, take, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieve the timesheet automation / alerts for QR Code activities  Requires the \'ManageQRCodes\' permission.
     * @param {number} [qRCodeId] The ID of the QR Code
     * @param {number} [userId] The ID of the user
     * @param {AutomationAuditDataSortColumns} [sort] The field to sort the records by
     * @param {SortDirection} [order] The directions to sort records by
     * @param {number} [skip] Skip this many records
     * @param {number} [take] Take this many records
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetAutomationApi
     */
    public timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId?: number, userId?: number, sort?: AutomationAuditDataSortColumns, order?: SortDirection, skip?: number, take?: number, options?: any) {
        return TimesheetAutomationApiFp(this.configuration).timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId, userId, sort, order, skip, take, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TimesheetsApi - axios parameter creator
 * @export
 */
export const TimesheetsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Inserts a single timesheet record.    Requires the \'SubmitTimesheets\' permission.
         * @param {Timesheet} [timesheet] A Timesheet Request object containing values for the new Timesheet to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsCreateSingleTimesheetPost: async (timesheet?: Timesheet, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Timesheets/CreateSingleTimesheet`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof timesheet !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(timesheet !== undefined ? timesheet : {})
                : (timesheet || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a timesheet.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [timesheetId] The ID of the Timesheet you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsDeleteTimesheetDelete: async (timesheetId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Timesheets/DeleteTimesheet`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (timesheetId !== undefined) {
                localVarQueryParameter['TimesheetId'] = timesheetId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the \'SubmitTimesheets\' permission.
         * @param {string} [startDate] The start date of the date range
         * @param {string} [endDate] The end date of the date range
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsGetTimesheetsGet: async (startDate?: string, endDate?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Timesheets/GetTimesheets`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Batch update timesheets.    Requires the \'SubmitTimesheets\' permission.
         * @param {BatchUpdateTimesheetRequest} [batchUpdateTimesheetRequest] A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsUpdateTimesheetsPut: async (batchUpdateTimesheetRequest?: BatchUpdateTimesheetRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Timesheets/UpdateTimesheets`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof batchUpdateTimesheetRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(batchUpdateTimesheetRequest !== undefined ? batchUpdateTimesheetRequest : {})
                : (batchUpdateTimesheetRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TimesheetsApi - functional programming interface
 * @export
 */
export const TimesheetsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Inserts a single timesheet record.    Requires the \'SubmitTimesheets\' permission.
         * @param {Timesheet} [timesheet] A Timesheet Request object containing values for the new Timesheet to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetsCreateSingleTimesheetPost(timesheet?: Timesheet, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await TimesheetsApiAxiosParamCreator(configuration).timesheetsCreateSingleTimesheetPost(timesheet, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a timesheet.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [timesheetId] The ID of the Timesheet you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetsDeleteTimesheetDelete(timesheetId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await TimesheetsApiAxiosParamCreator(configuration).timesheetsDeleteTimesheetDelete(timesheetId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the \'SubmitTimesheets\' permission.
         * @param {string} [startDate] The start date of the date range
         * @param {string} [endDate] The end date of the date range
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetsGetTimesheetsGet(startDate?: string, endDate?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TimesheetListApiResponse>> {
            const localVarAxiosArgs = await TimesheetsApiAxiosParamCreator(configuration).timesheetsGetTimesheetsGet(startDate, endDate, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Batch update timesheets.    Requires the \'SubmitTimesheets\' permission.
         * @param {BatchUpdateTimesheetRequest} [batchUpdateTimesheetRequest] A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest?: BatchUpdateTimesheetRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ListApiResponse>> {
            const localVarAxiosArgs = await TimesheetsApiAxiosParamCreator(configuration).timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TimesheetsApi - factory interface
 * @export
 */
export const TimesheetsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Inserts a single timesheet record.    Requires the \'SubmitTimesheets\' permission.
         * @param {Timesheet} [timesheet] A Timesheet Request object containing values for the new Timesheet to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsCreateSingleTimesheetPost(timesheet?: Timesheet, options?: any): AxiosPromise<Int32ApiResponse> {
            return TimesheetsApiFp(configuration).timesheetsCreateSingleTimesheetPost(timesheet, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a timesheet.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [timesheetId] The ID of the Timesheet you want to delete
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsDeleteTimesheetDelete(timesheetId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return TimesheetsApiFp(configuration).timesheetsDeleteTimesheetDelete(timesheetId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the \'SubmitTimesheets\' permission.
         * @param {string} [startDate] The start date of the date range
         * @param {string} [endDate] The end date of the date range
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsGetTimesheetsGet(startDate?: string, endDate?: string, options?: any): AxiosPromise<TimesheetListApiResponse> {
            return TimesheetsApiFp(configuration).timesheetsGetTimesheetsGet(startDate, endDate, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Batch update timesheets.    Requires the \'SubmitTimesheets\' permission.
         * @param {BatchUpdateTimesheetRequest} [batchUpdateTimesheetRequest] A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest?: BatchUpdateTimesheetRequest, options?: any): AxiosPromise<Int32ListApiResponse> {
            return TimesheetsApiFp(configuration).timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TimesheetsApi - object-oriented interface
 * @export
 * @class TimesheetsApi
 * @extends {BaseAPI}
 */
export class TimesheetsApi extends BaseAPI {
    /**
     * 
     * @summary Inserts a single timesheet record.    Requires the \'SubmitTimesheets\' permission.
     * @param {Timesheet} [timesheet] A Timesheet Request object containing values for the new Timesheet to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetsApi
     */
    public timesheetsCreateSingleTimesheetPost(timesheet?: Timesheet, options?: any) {
        return TimesheetsApiFp(this.configuration).timesheetsCreateSingleTimesheetPost(timesheet, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete a timesheet.    Requires the \'SubmitTimesheets\' permission.
     * @param {number} [timesheetId] The ID of the Timesheet you want to delete
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetsApi
     */
    public timesheetsDeleteTimesheetDelete(timesheetId?: number, options?: any) {
        return TimesheetsApiFp(this.configuration).timesheetsDeleteTimesheetDelete(timesheetId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the \'SubmitTimesheets\' permission.
     * @param {string} [startDate] The start date of the date range
     * @param {string} [endDate] The end date of the date range
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetsApi
     */
    public timesheetsGetTimesheetsGet(startDate?: string, endDate?: string, options?: any) {
        return TimesheetsApiFp(this.configuration).timesheetsGetTimesheetsGet(startDate, endDate, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Batch update timesheets.    Requires the \'SubmitTimesheets\' permission.
     * @param {BatchUpdateTimesheetRequest} [batchUpdateTimesheetRequest] A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TimesheetsApi
     */
    public timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest?: BatchUpdateTimesheetRequest, options?: any) {
        return TimesheetsApiFp(this.configuration).timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TranscriptsApi - axios parameter creator
 * @export
 */
export const TranscriptsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get an audio to text transcript for a particular audio file attachment
         * @param {number} [fileAttachmentId] The ID of the file attachment that has a transcript.  It should be an audio file attachment.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transcriptsGetMyTranscriptGet: async (fileAttachmentId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Transcripts/GetMyTranscript`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (fileAttachmentId !== undefined) {
                localVarQueryParameter['FileAttachmentId'] = fileAttachmentId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get my file transcripts.  Get audio to text transcripts that you\'ve created.
         * @param {string} [startDate] The Start date of the date range.  Transcripts after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Transcripts before this date will be obtained.
         * @param {number} [skip] Skip this many transcripts
         * @param {number} [take] Take this many transcripts
         * @param {string} [keyword] Search the text content of the transcript keywords
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transcriptsGetMyTranscriptsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, keyword?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Transcripts/GetMyTranscripts`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }

            if (keyword !== undefined) {
                localVarQueryParameter['Keyword'] = keyword;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TranscriptsApi - functional programming interface
 * @export
 */
export const TranscriptsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get an audio to text transcript for a particular audio file attachment
         * @param {number} [fileAttachmentId] The ID of the file attachment that has a transcript.  It should be an audio file attachment.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async transcriptsGetMyTranscriptGet(fileAttachmentId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TranscriptionApiResponse>> {
            const localVarAxiosArgs = await TranscriptsApiAxiosParamCreator(configuration).transcriptsGetMyTranscriptGet(fileAttachmentId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get my file transcripts.  Get audio to text transcripts that you\'ve created.
         * @param {string} [startDate] The Start date of the date range.  Transcripts after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Transcripts before this date will be obtained.
         * @param {number} [skip] Skip this many transcripts
         * @param {number} [take] Take this many transcripts
         * @param {string} [keyword] Search the text content of the transcript keywords
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async transcriptsGetMyTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, keyword?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrgReportTranscriptListApiResponseForPaginated>> {
            const localVarAxiosArgs = await TranscriptsApiAxiosParamCreator(configuration).transcriptsGetMyTranscriptsGet(startDate, endDate, skip, take, keyword, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TranscriptsApi - factory interface
 * @export
 */
export const TranscriptsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get an audio to text transcript for a particular audio file attachment
         * @param {number} [fileAttachmentId] The ID of the file attachment that has a transcript.  It should be an audio file attachment.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transcriptsGetMyTranscriptGet(fileAttachmentId?: number, options?: any): AxiosPromise<TranscriptionApiResponse> {
            return TranscriptsApiFp(configuration).transcriptsGetMyTranscriptGet(fileAttachmentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get my file transcripts.  Get audio to text transcripts that you\'ve created.
         * @param {string} [startDate] The Start date of the date range.  Transcripts after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Transcripts before this date will be obtained.
         * @param {number} [skip] Skip this many transcripts
         * @param {number} [take] Take this many transcripts
         * @param {string} [keyword] Search the text content of the transcript keywords
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transcriptsGetMyTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, keyword?: string, options?: any): AxiosPromise<OrgReportTranscriptListApiResponseForPaginated> {
            return TranscriptsApiFp(configuration).transcriptsGetMyTranscriptsGet(startDate, endDate, skip, take, keyword, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TranscriptsApi - object-oriented interface
 * @export
 * @class TranscriptsApi
 * @extends {BaseAPI}
 */
export class TranscriptsApi extends BaseAPI {
    /**
     * 
     * @summary Get an audio to text transcript for a particular audio file attachment
     * @param {number} [fileAttachmentId] The ID of the file attachment that has a transcript.  It should be an audio file attachment.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TranscriptsApi
     */
    public transcriptsGetMyTranscriptGet(fileAttachmentId?: number, options?: any) {
        return TranscriptsApiFp(this.configuration).transcriptsGetMyTranscriptGet(fileAttachmentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get my file transcripts.  Get audio to text transcripts that you\'ve created.
     * @param {string} [startDate] The Start date of the date range.  Transcripts after this date will be obtained.
     * @param {string} [endDate] The End date of the date range.  Transcripts before this date will be obtained.
     * @param {number} [skip] Skip this many transcripts
     * @param {number} [take] Take this many transcripts
     * @param {string} [keyword] Search the text content of the transcript keywords
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TranscriptsApi
     */
    public transcriptsGetMyTranscriptsGet(startDate?: string, endDate?: string, skip?: number, take?: number, keyword?: string, options?: any) {
        return TranscriptsApiFp(this.configuration).transcriptsGetMyTranscriptsGet(startDate, endDate, skip, take, keyword, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TripsApi - axios parameter creator
 * @export
 */
export const TripsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the \'SubmitTimesheets\' permission.
         * @param {CreateTripRequest} [createTripRequest] A Create Trip Request object containing values for the new Trip to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsCreateTripPost: async (createTripRequest?: CreateTripRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Trips/CreateTrip`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof createTripRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(createTripRequest !== undefined ? createTripRequest : {})
                : (createTripRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get trip by Id.    Requires the \'ViewMyTrips\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsGetMyTripByIdGet: async (tripId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Trips/GetMyTripById`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (tripId !== undefined) {
                localVarQueryParameter['TripId'] = tripId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get my trips.  Get the GPS trips you\'ve recorded and submitted.    Requires the \'ViewMyTrips\' permission.
         * @param {string} [startDate] The Start date of the date range.  Trips after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Trips before this date will be obtained.
         * @param {number} [skip] Skip this many Trips
         * @param {number} [take] Take this many Trips
         * @param {number} [vehicleId] Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsGetMyTripsGet: async (startDate?: string, endDate?: string, skip?: number, take?: number, vehicleId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Trips/GetMyTrips`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (startDate !== undefined) {
                localVarQueryParameter['StartDate'] = (startDate as any instanceof Date) ?
                    (startDate as any).toISOString() :
                    startDate;
            }

            if (endDate !== undefined) {
                localVarQueryParameter['EndDate'] = (endDate as any instanceof Date) ?
                    (endDate as any).toISOString() :
                    endDate;
            }

            if (skip !== undefined) {
                localVarQueryParameter['Skip'] = skip;
            }

            if (take !== undefined) {
                localVarQueryParameter['Take'] = take;
            }

            if (vehicleId !== undefined) {
                localVarQueryParameter['VehicleId'] = vehicleId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TripsApi - functional programming interface
 * @export
 */
export const TripsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the \'SubmitTimesheets\' permission.
         * @param {CreateTripRequest} [createTripRequest] A Create Trip Request object containing values for the new Trip to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tripsCreateTripPost(createTripRequest?: CreateTripRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await TripsApiAxiosParamCreator(configuration).tripsCreateTripPost(createTripRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get trip by Id.    Requires the \'ViewMyTrips\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tripsGetMyTripByIdGet(tripId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TripApiResponse>> {
            const localVarAxiosArgs = await TripsApiAxiosParamCreator(configuration).tripsGetMyTripByIdGet(tripId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get my trips.  Get the GPS trips you\'ve recorded and submitted.    Requires the \'ViewMyTrips\' permission.
         * @param {string} [startDate] The Start date of the date range.  Trips after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Trips before this date will be obtained.
         * @param {number} [skip] Skip this many Trips
         * @param {number} [take] Take this many Trips
         * @param {number} [vehicleId] Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tripsGetMyTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, vehicleId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TripListApiResponseForPaginated>> {
            const localVarAxiosArgs = await TripsApiAxiosParamCreator(configuration).tripsGetMyTripsGet(startDate, endDate, skip, take, vehicleId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TripsApi - factory interface
 * @export
 */
export const TripsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the \'SubmitTimesheets\' permission.
         * @param {CreateTripRequest} [createTripRequest] A Create Trip Request object containing values for the new Trip to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsCreateTripPost(createTripRequest?: CreateTripRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return TripsApiFp(configuration).tripsCreateTripPost(createTripRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get trip by Id.    Requires the \'ViewMyTrips\' permission.
         * @param {number} [tripId] The ID of the Trip you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsGetMyTripByIdGet(tripId?: number, options?: any): AxiosPromise<TripApiResponse> {
            return TripsApiFp(configuration).tripsGetMyTripByIdGet(tripId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get my trips.  Get the GPS trips you\'ve recorded and submitted.    Requires the \'ViewMyTrips\' permission.
         * @param {string} [startDate] The Start date of the date range.  Trips after this date will be obtained.
         * @param {string} [endDate] The End date of the date range.  Trips before this date will be obtained.
         * @param {number} [skip] Skip this many Trips
         * @param {number} [take] Take this many Trips
         * @param {number} [vehicleId] Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tripsGetMyTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, vehicleId?: number, options?: any): AxiosPromise<TripListApiResponseForPaginated> {
            return TripsApiFp(configuration).tripsGetMyTripsGet(startDate, endDate, skip, take, vehicleId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TripsApi - object-oriented interface
 * @export
 * @class TripsApi
 * @extends {BaseAPI}
 */
export class TripsApi extends BaseAPI {
    /**
     * 
     * @summary Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the \'SubmitTimesheets\' permission.
     * @param {CreateTripRequest} [createTripRequest] A Create Trip Request object containing values for the new Trip to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TripsApi
     */
    public tripsCreateTripPost(createTripRequest?: CreateTripRequest, options?: any) {
        return TripsApiFp(this.configuration).tripsCreateTripPost(createTripRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get trip by Id.    Requires the \'ViewMyTrips\' permission.
     * @param {number} [tripId] The ID of the Trip you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TripsApi
     */
    public tripsGetMyTripByIdGet(tripId?: number, options?: any) {
        return TripsApiFp(this.configuration).tripsGetMyTripByIdGet(tripId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get my trips.  Get the GPS trips you\'ve recorded and submitted.    Requires the \'ViewMyTrips\' permission.
     * @param {string} [startDate] The Start date of the date range.  Trips after this date will be obtained.
     * @param {string} [endDate] The End date of the date range.  Trips before this date will be obtained.
     * @param {number} [skip] Skip this many Trips
     * @param {number} [take] Take this many Trips
     * @param {number} [vehicleId] Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TripsApi
     */
    public tripsGetMyTripsGet(startDate?: string, endDate?: string, skip?: number, take?: number, vehicleId?: number, options?: any) {
        return TripsApiFp(this.configuration).tripsGetMyTripsGet(startDate, endDate, skip, take, vehicleId, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UserJobFavouritesApi - axios parameter creator
 * @export
 */
export const UserJobFavouritesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {InsertUserJobFavouriteRequest} [insertUserJobFavouriteRequest] An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesCreateJobFavouritePost: async (insertUserJobFavouriteRequest?: InsertUserJobFavouriteRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserJobFavourites/CreateJobFavourite`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertUserJobFavouriteRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertUserJobFavouriteRequest !== undefined ? insertUserJobFavouriteRequest : {})
                : (insertUserJobFavouriteRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [jobId] The ID of the Job for the Job Favourite you want to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesDeleteJobFavouriteDelete: async (jobId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserJobFavourites/DeleteJobFavourite`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (jobId !== undefined) {
                localVarQueryParameter['JobId'] = jobId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get your job favourites.    Requires the \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesGetJobFavouritesGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserJobFavourites/GetJobFavourites`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UserJobFavouritesApi - functional programming interface
 * @export
 */
export const UserJobFavouritesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {InsertUserJobFavouriteRequest} [insertUserJobFavouriteRequest] An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest?: InsertUserJobFavouriteRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await UserJobFavouritesApiAxiosParamCreator(configuration).userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [jobId] The ID of the Job for the Job Favourite you want to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userJobFavouritesDeleteJobFavouriteDelete(jobId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await UserJobFavouritesApiAxiosParamCreator(configuration).userJobFavouritesDeleteJobFavouriteDelete(jobId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get your job favourites.    Requires the \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userJobFavouritesGetJobFavouritesGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserJobFavouriteListApiResponse>> {
            const localVarAxiosArgs = await UserJobFavouritesApiAxiosParamCreator(configuration).userJobFavouritesGetJobFavouritesGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * UserJobFavouritesApi - factory interface
 * @export
 */
export const UserJobFavouritesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {InsertUserJobFavouriteRequest} [insertUserJobFavouriteRequest] An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest?: InsertUserJobFavouriteRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return UserJobFavouritesApiFp(configuration).userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a job favourite.    Requires the \'SubmitTimesheets\' permission.
         * @param {number} [jobId] The ID of the Job for the Job Favourite you want to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesDeleteJobFavouriteDelete(jobId?: number, options?: any): AxiosPromise<BooleanApiResponse> {
            return UserJobFavouritesApiFp(configuration).userJobFavouritesDeleteJobFavouriteDelete(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get your job favourites.    Requires the \'SubmitTimesheets\' permission.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userJobFavouritesGetJobFavouritesGet(options?: any): AxiosPromise<UserJobFavouriteListApiResponse> {
            return UserJobFavouritesApiFp(configuration).userJobFavouritesGetJobFavouritesGet(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UserJobFavouritesApi - object-oriented interface
 * @export
 * @class UserJobFavouritesApi
 * @extends {BaseAPI}
 */
export class UserJobFavouritesApi extends BaseAPI {
    /**
     * 
     * @summary Create a job favourite.    Requires the \'SubmitTimesheets\' permission.
     * @param {InsertUserJobFavouriteRequest} [insertUserJobFavouriteRequest] An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserJobFavouritesApi
     */
    public userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest?: InsertUserJobFavouriteRequest, options?: any) {
        return UserJobFavouritesApiFp(this.configuration).userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete a job favourite.    Requires the \'SubmitTimesheets\' permission.
     * @param {number} [jobId] The ID of the Job for the Job Favourite you want to delete.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserJobFavouritesApi
     */
    public userJobFavouritesDeleteJobFavouriteDelete(jobId?: number, options?: any) {
        return UserJobFavouritesApiFp(this.configuration).userJobFavouritesDeleteJobFavouriteDelete(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get your job favourites.    Requires the \'SubmitTimesheets\' permission.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserJobFavouritesApi
     */
    public userJobFavouritesGetJobFavouritesGet(options?: any) {
        return UserJobFavouritesApiFp(this.configuration).userJobFavouritesGetJobFavouritesGet(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UserPayRatesApi - axios parameter creator
 * @export
 */
export const UserPayRatesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserHourlyRateRequest} [insertUserHourlyRateRequest] An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userPayRatesCreatePayRatePost: async (insertUserHourlyRateRequest?: InsertUserHourlyRateRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserPayRates/CreatePayRate`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertUserHourlyRateRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertUserHourlyRateRequest !== undefined ? insertUserHourlyRateRequest : {})
                : (insertUserHourlyRateRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a collection of pay rates for a particular user, specified by user id.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UserHourlyRate objects
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userPayRatesGetPayRatesGet: async (userId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserPayRates/GetPayRates`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UserPayRatesApi - functional programming interface
 * @export
 */
export const UserPayRatesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserHourlyRateRequest} [insertUserHourlyRateRequest] An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userPayRatesCreatePayRatePost(insertUserHourlyRateRequest?: InsertUserHourlyRateRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Int32ApiResponse>> {
            const localVarAxiosArgs = await UserPayRatesApiAxiosParamCreator(configuration).userPayRatesCreatePayRatePost(insertUserHourlyRateRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a collection of pay rates for a particular user, specified by user id.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UserHourlyRate objects
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userPayRatesGetPayRatesGet(userId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserHourlyRateListApiResponse>> {
            const localVarAxiosArgs = await UserPayRatesApiAxiosParamCreator(configuration).userPayRatesGetPayRatesGet(userId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * UserPayRatesApi - factory interface
 * @export
 */
export const UserPayRatesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserHourlyRateRequest} [insertUserHourlyRateRequest] An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userPayRatesCreatePayRatePost(insertUserHourlyRateRequest?: InsertUserHourlyRateRequest, options?: any): AxiosPromise<Int32ApiResponse> {
            return UserPayRatesApiFp(configuration).userPayRatesCreatePayRatePost(insertUserHourlyRateRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a collection of pay rates for a particular user, specified by user id.    Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UserHourlyRate objects
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userPayRatesGetPayRatesGet(userId?: number, options?: any): AxiosPromise<UserHourlyRateListApiResponse> {
            return UserPayRatesApiFp(configuration).userPayRatesGetPayRatesGet(userId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UserPayRatesApi - object-oriented interface
 * @export
 * @class UserPayRatesApi
 * @extends {BaseAPI}
 */
export class UserPayRatesApi extends BaseAPI {
    /**
     * 
     * @summary Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the \'ManageOrganisationUsers\' permission.
     * @param {InsertUserHourlyRateRequest} [insertUserHourlyRateRequest] An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserPayRatesApi
     */
    public userPayRatesCreatePayRatePost(insertUserHourlyRateRequest?: InsertUserHourlyRateRequest, options?: any) {
        return UserPayRatesApiFp(this.configuration).userPayRatesCreatePayRatePost(insertUserHourlyRateRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a collection of pay rates for a particular user, specified by user id.    Requires the \'ManageOrganisationUsers\' permission.
     * @param {number} [userId] The ID of the User for which you want to get UserHourlyRate objects
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserPayRatesApi
     */
    public userPayRatesGetPayRatesGet(userId?: number, options?: any) {
        return UserPayRatesApiFp(this.configuration).userPayRatesGetPayRatesGet(userId, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UserProfileApi - axios parameter creator
 * @export
 */
export const UserProfileApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.
         * @param {DoLoginRequest} [doLoginRequest] A request object containing your username/email and password.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileDoLoginPut: async (doLoginRequest?: DoLoginRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserProfile/DoLogin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof doLoginRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(doLoginRequest !== undefined ? doLoginRequest : {})
                : (doLoginRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileDoLogoutDelete: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserProfile/DoLogout`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileGetMyProfileGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserProfile/GetMyProfile`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Keep a session alive.  Use this method to keep a session active.  You could use this to \'ping\' ChronoSheets every \'x\' minutes to make sure your Auth Token will keep working.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileKeepSessionAliveGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserProfile/KeepSessionAlive`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.
         * @param {UpdateMyProfileRequest} [updateMyProfileRequest] An Update MyProfile Request object containing updated fields.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileUpdateMyProfilePut: async (updateMyProfileRequest?: UpdateMyProfileRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UserProfile/UpdateMyProfile`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateMyProfileRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateMyProfileRequest !== undefined ? updateMyProfileRequest : {})
                : (updateMyProfileRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UserProfileApi - functional programming interface
 * @export
 */
export const UserProfileApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.
         * @param {DoLoginRequest} [doLoginRequest] A request object containing your username/email and password.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userProfileDoLoginPut(doLoginRequest?: DoLoginRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DoLoginResponseApiResponse>> {
            const localVarAxiosArgs = await UserProfileApiAxiosParamCreator(configuration).userProfileDoLoginPut(doLoginRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userProfileDoLogoutDelete(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await UserProfileApiAxiosParamCreator(configuration).userProfileDoLogoutDelete(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userProfileGetMyProfileGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserProfileApiResponse>> {
            const localVarAxiosArgs = await UserProfileApiAxiosParamCreator(configuration).userProfileGetMyProfileGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Keep a session alive.  Use this method to keep a session active.  You could use this to \'ping\' ChronoSheets every \'x\' minutes to make sure your Auth Token will keep working.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userProfileKeepSessionAliveGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await UserProfileApiAxiosParamCreator(configuration).userProfileKeepSessionAliveGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.
         * @param {UpdateMyProfileRequest} [updateMyProfileRequest] An Update MyProfile Request object containing updated fields.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userProfileUpdateMyProfilePut(updateMyProfileRequest?: UpdateMyProfileRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UpdateProfileResponseApiResponse>> {
            const localVarAxiosArgs = await UserProfileApiAxiosParamCreator(configuration).userProfileUpdateMyProfilePut(updateMyProfileRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * UserProfileApi - factory interface
 * @export
 */
export const UserProfileApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.
         * @param {DoLoginRequest} [doLoginRequest] A request object containing your username/email and password.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileDoLoginPut(doLoginRequest?: DoLoginRequest, options?: any): AxiosPromise<DoLoginResponseApiResponse> {
            return UserProfileApiFp(configuration).userProfileDoLoginPut(doLoginRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileDoLogoutDelete(options?: any): AxiosPromise<BooleanApiResponse> {
            return UserProfileApiFp(configuration).userProfileDoLogoutDelete(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileGetMyProfileGet(options?: any): AxiosPromise<UserProfileApiResponse> {
            return UserProfileApiFp(configuration).userProfileGetMyProfileGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Keep a session alive.  Use this method to keep a session active.  You could use this to \'ping\' ChronoSheets every \'x\' minutes to make sure your Auth Token will keep working.    Does not require any special permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileKeepSessionAliveGet(options?: any): AxiosPromise<BooleanApiResponse> {
            return UserProfileApiFp(configuration).userProfileKeepSessionAliveGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.
         * @param {UpdateMyProfileRequest} [updateMyProfileRequest] An Update MyProfile Request object containing updated fields.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userProfileUpdateMyProfilePut(updateMyProfileRequest?: UpdateMyProfileRequest, options?: any): AxiosPromise<UpdateProfileResponseApiResponse> {
            return UserProfileApiFp(configuration).userProfileUpdateMyProfilePut(updateMyProfileRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UserProfileApi - object-oriented interface
 * @export
 * @class UserProfileApi
 * @extends {BaseAPI}
 */
export class UserProfileApi extends BaseAPI {
    /**
     * 
     * @summary Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.
     * @param {DoLoginRequest} [doLoginRequest] A request object containing your username/email and password.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserProfileApi
     */
    public userProfileDoLoginPut(doLoginRequest?: DoLoginRequest, options?: any) {
        return UserProfileApiFp(this.configuration).userProfileDoLoginPut(doLoginRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserProfileApi
     */
    public userProfileDoLogoutDelete(options?: any) {
        return UserProfileApiFp(this.configuration).userProfileDoLogoutDelete(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserProfileApi
     */
    public userProfileGetMyProfileGet(options?: any) {
        return UserProfileApiFp(this.configuration).userProfileGetMyProfileGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Keep a session alive.  Use this method to keep a session active.  You could use this to \'ping\' ChronoSheets every \'x\' minutes to make sure your Auth Token will keep working.    Does not require any special permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserProfileApi
     */
    public userProfileKeepSessionAliveGet(options?: any) {
        return UserProfileApiFp(this.configuration).userProfileKeepSessionAliveGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.
     * @param {UpdateMyProfileRequest} [updateMyProfileRequest] An Update MyProfile Request object containing updated fields.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserProfileApi
     */
    public userProfileUpdateMyProfilePut(updateMyProfileRequest?: UpdateMyProfileRequest, options?: any) {
        return UserProfileApiFp(this.configuration).userProfileUpdateMyProfilePut(updateMyProfileRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UsersApi - axios parameter creator
 * @export
 */
export const UsersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a user account in your organisation.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserRequest} [insertUserRequest] An Insert User Request object containing values for the new User to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersCreateTimesheetUserPost: async (insertUserRequest?: InsertUserRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Users/CreateTimesheetUser`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof insertUserRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(insertUserRequest !== undefined ? insertUserRequest : {})
                : (insertUserRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a particular user in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {number} [userId] The User ID of the UserForManagement you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersGetTimesheetUserGet: async (userId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Users/GetTimesheetUser`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get users accounts in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersGetTimesheetUsersGet: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Users/GetTimesheetUsers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update a user account.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {UpdateUserRequest} [updateUserRequest] A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersUpdateTimesheetUserPut: async (updateUserRequest?: UpdateUserRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Users/UpdateTimesheetUser`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof updateUserRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(updateUserRequest !== undefined ? updateUserRequest : {})
                : (updateUserRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UsersApi - functional programming interface
 * @export
 */
export const UsersApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a user account in your organisation.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserRequest} [insertUserRequest] An Insert User Request object containing values for the new User to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usersCreateTimesheetUserPost(insertUserRequest?: InsertUserRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InsertUserResponseApiResponse>> {
            const localVarAxiosArgs = await UsersApiAxiosParamCreator(configuration).usersCreateTimesheetUserPost(insertUserRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a particular user in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {number} [userId] The User ID of the UserForManagement you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usersGetTimesheetUserGet(userId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserForManagementApiResponse>> {
            const localVarAxiosArgs = await UsersApiAxiosParamCreator(configuration).usersGetTimesheetUserGet(userId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get users accounts in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usersGetTimesheetUsersGet(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserForManagementListApiResponse>> {
            const localVarAxiosArgs = await UsersApiAxiosParamCreator(configuration).usersGetTimesheetUsersGet(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Update a user account.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {UpdateUserRequest} [updateUserRequest] A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usersUpdateTimesheetUserPut(updateUserRequest?: UpdateUserRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UpdateUserResponseApiResponse>> {
            const localVarAxiosArgs = await UsersApiAxiosParamCreator(configuration).usersUpdateTimesheetUserPut(updateUserRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * UsersApi - factory interface
 * @export
 */
export const UsersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a user account in your organisation.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {InsertUserRequest} [insertUserRequest] An Insert User Request object containing values for the new User to create
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersCreateTimesheetUserPost(insertUserRequest?: InsertUserRequest, options?: any): AxiosPromise<InsertUserResponseApiResponse> {
            return UsersApiFp(configuration).usersCreateTimesheetUserPost(insertUserRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a particular user in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {number} [userId] The User ID of the UserForManagement you want to get
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersGetTimesheetUserGet(userId?: number, options?: any): AxiosPromise<UserForManagementApiResponse> {
            return UsersApiFp(configuration).usersGetTimesheetUserGet(userId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get users accounts in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersGetTimesheetUsersGet(options?: any): AxiosPromise<UserForManagementListApiResponse> {
            return UsersApiFp(configuration).usersGetTimesheetUsersGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update a user account.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {UpdateUserRequest} [updateUserRequest] A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usersUpdateTimesheetUserPut(updateUserRequest?: UpdateUserRequest, options?: any): AxiosPromise<UpdateUserResponseApiResponse> {
            return UsersApiFp(configuration).usersUpdateTimesheetUserPut(updateUserRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UsersApi - object-oriented interface
 * @export
 * @class UsersApi
 * @extends {BaseAPI}
 */
export class UsersApi extends BaseAPI {
    /**
     * 
     * @summary Create a user account in your organisation.  Requires the \'ManageOrganisationUsers\' permission.
     * @param {InsertUserRequest} [insertUserRequest] An Insert User Request object containing values for the new User to create
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    public usersCreateTimesheetUserPost(insertUserRequest?: InsertUserRequest, options?: any) {
        return UsersApiFp(this.configuration).usersCreateTimesheetUserPost(insertUserRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get a particular user in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
     * @param {number} [userId] The User ID of the UserForManagement you want to get
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    public usersGetTimesheetUserGet(userId?: number, options?: any) {
        return UsersApiFp(this.configuration).usersGetTimesheetUserGet(userId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get users accounts in your organisation.  Requires the \'ManageOrganisationUsers\' or \'ManageOrganisationGroups\' permissions.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    public usersGetTimesheetUsersGet(options?: any) {
        return UsersApiFp(this.configuration).usersGetTimesheetUsersGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update a user account.  Requires the \'ManageOrganisationUsers\' permission.
     * @param {UpdateUserRequest} [updateUserRequest] A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsersApi
     */
    public usersUpdateTimesheetUserPut(updateUserRequest?: UpdateUserRequest, options?: any) {
        return UsersApiFp(this.configuration).usersUpdateTimesheetUserPut(updateUserRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UsualHoursApi - axios parameter creator
 * @export
 */
export const UsualHoursApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UsualHours for
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usualHoursGetUsualHoursGet: async (userId?: number, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UsualHours/GetUsualHours`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }


    
            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Set usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {SetUsualHoursRequest} [setUsualHoursRequest] A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usualHoursSetUsualHoursPut: async (setUsualHoursRequest?: SetUsualHoursRequest, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/UsualHours/SetUsualHours`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication x-chronosheets-auth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
                    ? await configuration.apiKey("x-chronosheets-auth")
                    : await configuration.apiKey;
                localVarHeaderParameter["x-chronosheets-auth"] = localVarApiKeyValue;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            const queryParameters = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                queryParameters.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.query) {
                queryParameters.set(key, options.query[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(queryParameters)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const nonString = typeof setUsualHoursRequest !== 'string';
            const needsSerialization = nonString && configuration && configuration.isJsonMime
                ? configuration.isJsonMime(localVarRequestOptions.headers['Content-Type'])
                : nonString;
            localVarRequestOptions.data =  needsSerialization
                ? JSON.stringify(setUsualHoursRequest !== undefined ? setUsualHoursRequest : {})
                : (setUsualHoursRequest || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UsualHoursApi - functional programming interface
 * @export
 */
export const UsualHoursApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UsualHours for
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usualHoursGetUsualHoursGet(userId?: number, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UsualHoursDayListApiResponse>> {
            const localVarAxiosArgs = await UsualHoursApiAxiosParamCreator(configuration).usualHoursGetUsualHoursGet(userId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Set usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {SetUsualHoursRequest} [setUsualHoursRequest] A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async usualHoursSetUsualHoursPut(setUsualHoursRequest?: SetUsualHoursRequest, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BooleanApiResponse>> {
            const localVarAxiosArgs = await UsualHoursApiAxiosParamCreator(configuration).usualHoursSetUsualHoursPut(setUsualHoursRequest, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs = {...localVarAxiosArgs.options, url: (configuration?.basePath || basePath) + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * UsualHoursApi - factory interface
 * @export
 */
export const UsualHoursApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Get usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {number} [userId] The ID of the User for which you want to get UsualHours for
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usualHoursGetUsualHoursGet(userId?: number, options?: any): AxiosPromise<UsualHoursDayListApiResponse> {
            return UsualHoursApiFp(configuration).usualHoursGetUsualHoursGet(userId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Set usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
         * @param {SetUsualHoursRequest} [setUsualHoursRequest] A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        usualHoursSetUsualHoursPut(setUsualHoursRequest?: SetUsualHoursRequest, options?: any): AxiosPromise<BooleanApiResponse> {
            return UsualHoursApiFp(configuration).usualHoursSetUsualHoursPut(setUsualHoursRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UsualHoursApi - object-oriented interface
 * @export
 * @class UsualHoursApi
 * @extends {BaseAPI}
 */
export class UsualHoursApi extends BaseAPI {
    /**
     * 
     * @summary Get usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
     * @param {number} [userId] The ID of the User for which you want to get UsualHours for
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsualHoursApi
     */
    public usualHoursGetUsualHoursGet(userId?: number, options?: any) {
        return UsualHoursApiFp(this.configuration).usualHoursGetUsualHoursGet(userId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Set usual hours (rostered hours) for an employee.  Requires the \'ManageOrganisationUsers\' permission.
     * @param {SetUsualHoursRequest} [setUsualHoursRequest] A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UsualHoursApi
     */
    public usualHoursSetUsualHoursPut(setUsualHoursRequest?: SetUsualHoursRequest, options?: any) {
        return UsualHoursApiFp(this.configuration).usualHoursSetUsualHoursPut(setUsualHoursRequest, options).then((request) => request(this.axios, this.basePath));
    }
}


